namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *cell_kind_utility_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_RNN_CELL_KIND_UTILITY_H)==""\n"
R"==(#define GPU_INTEL_OCL_RNN_CELL_KIND_UTILITY_H)==""\n"
R"==(inline float one_m_square(float a) {)==""\n"
R"==(return 1.0f - a * a;)==""\n"
R"==(})==""\n"
R"==(inline float x_m_square(float a) {)==""\n"
R"==(return (1.0f - a) * a;)==""\n"
R"==(})==""\n"
R"==(inline float relu_fwd(float s, float alpha) {)==""\n"
R"==(return s > 0 ? s : s * alpha;)==""\n"
R"==(})==""\n"
R"==(inline float tanh_fwd(float s) {)==""\n"
R"==(return tanh(s);)==""\n"
R"==(})==""\n"
R"==(inline float logistic_fwd(float s) {)==""\n"
R"==(return 1 / (1 + exp((float)-s));)==""\n"
R"==(})==""\n"
R"==(inline float logistic_bwd(float s) {)==""\n"
R"==(return x_m_square(s);)==""\n"
R"==(})==""\n"
R"==(inline float relu_bwd(float s, float alpha) {)==""\n"
R"==(return s > 0 ? 1.f : alpha;)==""\n"
R"==(})==""\n"
R"==(inline float tanh_bwd(float s) {)==""\n"
R"==(return (1 - s) * (1 + s);)==""\n"
R"==(})==""\n"
R"==(inline float linear(float s, float alpha) {)==""\n"
R"==(return alpha * s;)==""\n"
R"==(})==""\n"
R"==(inline float relu_fwd_tm(float s, float alpha) {)==""\n"
R"==(#if !IS_TESTMODE)==""\n"
R"==(return relu_fwd(s, alpha);)==""\n"
R"==(#else)==""\n"
R"==(return linear(s, alpha);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(inline float tanh_fwd_tm(float s, float alpha) {)==""\n"
R"==(#if !IS_TESTMODE)==""\n"
R"==(return tanh(s);)==""\n"
R"==(#else)==""\n"
R"==(return linear(s, alpha);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(inline float logistic_fwd_tm(float s, float alpha) {)==""\n"
R"==(#if !IS_TESTMODE)==""\n"
R"==(return logistic_fwd(s);)==""\n"
R"==(#else)==""\n"
R"==(return linear(s, alpha);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(inline float relu_bwd_tm(float s, float alpha) {)==""\n"
R"==(#if !IS_TESTMODE)==""\n"
R"==(return relu_bwd(s, alpha);)==""\n"
R"==(#else)==""\n"
R"==(return linear(s, alpha);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(inline float tanh_bwd_tm(float s, float alpha) {)==""\n"
R"==(#if !IS_TESTMODE)==""\n"
R"==(return tanh_bwd(s);)==""\n"
R"==(#else)==""\n"
R"==(return linear(s, alpha);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(inline float logistic_bwd_tm(float s, float alpha) {)==""\n"
R"==(#if !IS_TESTMODE)==""\n"
R"==(return logistic_bwd(s);)==""\n"
R"==(#else)==""\n"
R"==(return linear(s, alpha);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(inline float activation_fwd(float s, float alpha, float cliping) {)==""\n"
R"==(#if CELL_KIND == VANILLA_RNN)==""\n"
R"==(#if ACTIVATION_KIND == ELTWISE_RELU)==""\n"
R"==(return relu_fwd_tm(s, alpha);)==""\n"
R"==(#elif ACTIVATION_KIND == ELTWISE_TANH)==""\n"
R"==(return tanh_fwd_tm(s, alpha);)==""\n"
R"==(#elif ACTIVATION_KIND == ELTWISE_LOGISTIC)==""\n"
R"==(return logistic_fwd_tm(s, alpha);)==""\n"
R"==(#else)==""\n"
R"==(#error "Unsupported activation_kind")==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(return 0.0f;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(inline float activation_bwd(float s, float alpha, float cliping) {)==""\n"
R"==(#if CELL_KIND == VANILLA_RNN)==""\n"
R"==(#if ACTIVATION_KIND == ELTWISE_RELU)==""\n"
R"==(return relu_bwd_tm(s, alpha);)==""\n"
R"==(#elif ACTIVATION_KIND == ELTWISE_TANH)==""\n"
R"==(return tanh_bwd_tm(s, alpha);)==""\n"
R"==(#elif ACTIVATION_KIND == ELTWISE_LOGISTIC)==""\n"
R"==(return logistic_bwd_tm(s, alpha);)==""\n"
R"==(#else)==""\n"
R"==(#error "Unsupported activation_kind")==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(return 0.0f;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(float vanilla_rnn_compute_gates(float G0, float B0, float alpha,)==""\n"
R"==(const __global float *restrict tm_scales) {)==""\n"
R"==(float G = activation_fwd(G0 + B0,)==""\n"
R"==(#if IS_TESTMODE)==""\n"
R"==(tm_scales[0], 0);)==""\n"
R"==(#else)==""\n"
R"==(alpha, 0);)==""\n"
R"==(#endif)==""\n"
R"==(return G;)==""\n"
R"==(})==""\n"
R"==(void store_vanilla_rnn(__global AUX_DATA_T *ws_gates, int gates_ws_ld,)==""\n"
R"==(__global WS_STATE_DATA_T *h_states_t_l, int states_ws_ld, int dhc,)==""\n"
R"==(int n, int c, float g) {)==""\n"
R"==(if (!RECOMPUTE_GATES && IS_TRAINING) {)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, n, 0, c)] = g;)==""\n"
R"==(})==""\n"
R"==(h_states_t_l[cell_ws_state(states_ws_ld, n, c)] = TO_WS_STATE(g);)==""\n"
R"==(})==""\n"
R"==(typedef struct vanilla_lstm_gates_t {)==""\n"
R"==(float G[vanilla_lstm_n_gates];)==""\n"
R"==(} vanilla_lstm_gates_t;)==""\n"
R"==(struct vanilla_lstm_gates_t vanilla_lstm_compute_gates()==""\n"
R"==(const float G[vanilla_lstm_n_gates],)==""\n"
R"==(const float B[vanilla_lstm_n_gates],)==""\n"
R"==(const __global float *restrict tm_scales) {)==""\n"
R"==(vanilla_lstm_gates_t ret;)==""\n"
R"==(ret.G[0] = logistic_fwd_tm(G[0] + B[0], tm_scales[0]);)==""\n"
R"==(ret.G[1] = logistic_fwd_tm(G[1] + B[1], tm_scales[1]);)==""\n"
R"==(ret.G[2] = tanh_fwd_tm(G[2] + B[2], tm_scales[2]);)==""\n"
R"==(ret.G[3] = logistic_fwd_tm(G[3] + B[3], tm_scales[3]);)==""\n"
R"==(return ret;)==""\n"
R"==(})==""\n"
R"==(void vanilla_lstm_store(__global AUX_DATA_T *ws_gates, int gates_ws_ld,)==""\n"
R"==(__global WS_STATE_DATA_T *h_states_t_l,)==""\n"
R"==(__global AUX_DATA_T *c_states_t_l,)==""\n"
R"==(const __global AUX_DATA_T *c_states_tm1_l, int states_ws_ld, int dhc,)==""\n"
R"==(int n, int c, float tm_cscale, vanilla_lstm_gates_t gates) {)==""\n"
R"==(float g_i = gates.G[0];)==""\n"
R"==(float g_f = gates.G[1];)==""\n"
R"==(float g_z = gates.G[2];)==""\n"
R"==(float g_o = gates.G[3];)==""\n"
R"==(if (!RECOMPUTE_GATES && IS_TRAINING) {)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, n, 0, c)] = g_i;)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, n, 1, c)] = g_f;)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, n, 2, c)] = g_z;)==""\n"
R"==(ws_gates[cell_ws_gates(gates_ws_ld, dhc, n, 3, c)] = g_o;)==""\n"
R"==(})==""\n"
R"==(float Ct = g_f * c_states_tm1_l[cell_ws_state(states_ws_ld, n, c)])==""\n"
R"==(+ g_i * g_z;)==""\n"
R"==(float Ht = g_o * tanh_fwd_tm(Ct, tm_cscale);)==""\n"
R"==(h_states_t_l[cell_ws_state(states_ws_ld, n, c)] = TO_WS_STATE(Ht);)==""\n"
R"==(c_states_t_l[cell_ws_state(states_ws_ld, n, c)] = Ct;)==""\n"
R"==(})==""\n"
R"==(#if IS_INT8 && CELL_KIND == VANILLA_LSTM)==""\n"
R"==(inline WS_STATE_DATA_T q_d(float f, float data_scale, float data_shift) {)==""\n"
R"==(return TO_WS_STATE(f * data_scale + data_shift);)==""\n"
R"==(})==""\n"
R"==(inline float deq_w(ACC_DATA_T s, int gate, int j, __global float *scales,)==""\n"
R"==(float data_scale, int dhc) {)==""\n"
R"==(#if WEI_QPARAM_MASK)==""\n"
R"==(float wei_scale = scales[gate * dhc + j];)==""\n"
R"==(#else)==""\n"
R"==(float wei_scale = scales[0];)==""\n"
R"==(#endif)==""\n"
R"==(return (float)(s) / (wei_scale * data_scale);)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#if CELL_KIND == LBR_GRU)==""\n"
R"==(typedef struct lbr_gru_gates_t {)==""\n"
R"==(float Wh_b;)==""\n"
R"==(float G[3];)==""\n"
R"==(} lbr_gru_gates_t;)==""\n"
R"==(struct lbr_gru_gates_t compute_gates_lbr_gru()==""\n"
R"==(const __global ACC_DATA_T *restrict scratch_gates,)==""\n"
R"==(const __global AUX_DATA_T *restrict scratch_cell,)==""\n"
R"==(const __global BIAS_DATA_T *restrict bias,)==""\n"
R"==(const __global float *restrict tm_scales, int scratch_gates_ld, int dhc,)==""\n"
R"==(int mb, int c) {)==""\n"
R"==(float G[n_gates];)==""\n"
R"==(float B[n_bias];)==""\n"
R"==(float C[n_gates];)==""\n"
R"==(for (int i = 0; i < n_gates; i++) {)==""\n"
R"==(G[i] = convert_float(scratch_gates[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, mb, i, c)]);)==""\n"
R"==(C[i] = convert_float(scratch_cell[cell_scratch_mem()==""\n"
R"==(scratch_gates_ld, dhc, mb, i, c)]);)==""\n"
R"==(})==""\n"
R"==(for (int i = 0; i < n_bias; i++) {)==""\n"
R"==(B[i] = convert_float(bias[off_ker_bias(dhc, i, c)]);)==""\n"
R"==(})==""\n"
R"==(lbr_gru_gates_t ret;)==""\n"
R"==(ret.Wh_b = C[2] + B[3];)==""\n"
R"==(ret.G[0] = logistic_fwd_tm(G[0] + C[0] + B[0], tm_scales[0]);)==""\n"
R"==(ret.G[1] = logistic_fwd_tm(G[1] + C[1] + B[1], tm_scales[1]);)==""\n"
R"==(ret.G[2] = tanh_fwd_tm(G[2] + ret.G[1] * ret.Wh_b + B[2], tm_scales[2]);)==""\n"
R"==(return ret;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}