namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *dispatch_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2023-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_DISPATCH_H)==""\n"
R"==(#define GPU_INTEL_OCL_DISPATCH_H)==""\n"
R"==(#define ROUND_UP(a, b) (((a) + (b)-1) / (b)))==""\n"
R"==(#ifndef USE_CUSTOM_GWS_GET_ID)==""\n"
R"==(#define GWS_GET_THREAD_ID(index) get_global_id(index))==""\n"
R"==(#endif)==""\n"
R"==(#ifdef USE_INT32_OFFSET)==""\n"
R"==(#define off_t int)==""\n"
R"==(#else)==""\n"
R"==(#define off_t long)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef GWS_WITH_RUNTIME_PARAMS)==""\n"
R"==(#define GWS_OP_ZERO(idx, stride, max, block) 0)==""\n"
R"==(#define GWS_OP_SOLO(idx, stride, max, block) (idx))==""\n"
R"==(#define GWS_OP_FIRST(idx, stride, max, block) ((idx) / (stride)))==""\n"
R"==(#define GWS_OP_MOD(idx, stride, max, block) ((idx) / (stride) % (max)))==""\n"
R"==(#define GWS_OP_SOLO_BLOCK(idx, stride, max, block) (idx) * (block))==""\n"
R"==(#define GWS_OP_FIRST_BLOCK(idx, stride, max, block) ((idx) / (stride)) * (block))==""\n"
R"==(#define GWS_OP_MOD_BLOCK(idx, stride, max, block) \)==""\n"
R"==(((idx) / (stride) % (max)) * (block))==""\n"
R"==(#define DEFAULT_DISPATCHER_SUFFIX DEFAULT)==""\n"
R"==(#define GWS0_GET_ID0(rt_params) GWS0_OP0(GWS_GET_THREAD_ID(GWS0_IDX0), (rt_params).strides[GWS0_RT_IDX0], (rt_params).sizes[GWS0_RT_IDX0], (rt_params).blocks[GWS0_RT_IDX0]))==""\n"
R"==(#define GWS0_GET_ID1(rt_params) GWS0_OP1(GWS_GET_THREAD_ID(GWS0_IDX1), (rt_params).strides[GWS0_RT_IDX1], (rt_params).sizes[GWS0_RT_IDX1], (rt_params).blocks[GWS0_RT_IDX1]))==""\n"
R"==(#define GWS0_GET_ID2(rt_params) GWS0_OP2(GWS_GET_THREAD_ID(GWS0_IDX2), (rt_params).strides[GWS0_RT_IDX2], (rt_params).sizes[GWS0_RT_IDX2], (rt_params).blocks[GWS0_RT_IDX2]))==""\n"
R"==(#define GWS0_GET_ID3(rt_params) GWS0_OP3(GWS_GET_THREAD_ID(GWS0_IDX3), (rt_params).strides[GWS0_RT_IDX3], (rt_params).sizes[GWS0_RT_IDX3], (rt_params).blocks[GWS0_RT_IDX3]))==""\n"
R"==(#define GWS0_GET_ID4(rt_params) GWS0_OP4(GWS_GET_THREAD_ID(GWS0_IDX4), (rt_params).strides[GWS0_RT_IDX4], (rt_params).sizes[GWS0_RT_IDX4], (rt_params).blocks[GWS0_RT_IDX4]))==""\n"
R"==(#define GWS0_GET_ID5(rt_params) GWS0_OP5(GWS_GET_THREAD_ID(GWS0_IDX5), (rt_params).strides[GWS0_RT_IDX5], (rt_params).sizes[GWS0_RT_IDX5], (rt_params).blocks[GWS0_RT_IDX5]))==""\n"
R"==(#define GWS0_GET_ID6(rt_params) GWS0_OP6(GWS_GET_THREAD_ID(GWS0_IDX6), (rt_params).strides[GWS0_RT_IDX6], (rt_params).sizes[GWS0_RT_IDX6], (rt_params).blocks[GWS0_RT_IDX6]))==""\n"
R"==(#define GWS0_GET_ID7(rt_params) GWS0_OP7(GWS_GET_THREAD_ID(GWS0_IDX7), (rt_params).strides[GWS0_RT_IDX7], (rt_params).sizes[GWS0_RT_IDX7], (rt_params).blocks[GWS0_RT_IDX7]))==""\n"
R"==(#define GWS0_GET_ID8(rt_params) GWS0_OP8(GWS_GET_THREAD_ID(GWS0_IDX8), (rt_params).strides[GWS0_RT_IDX8], (rt_params).sizes[GWS0_RT_IDX8], (rt_params).blocks[GWS0_RT_IDX8]))==""\n"
R"==(#define GWS0_GET_ID9(rt_params) GWS0_OP9(GWS_GET_THREAD_ID(GWS0_IDX9), (rt_params).strides[GWS0_RT_IDX9], (rt_params).sizes[GWS0_RT_IDX9], (rt_params).blocks[GWS0_RT_IDX9]))==""\n"
R"==(#define GWS1_GET_ID0(rt_params) GWS1_OP0(GWS_GET_THREAD_ID(GWS1_IDX0), (rt_params).strides[GWS1_RT_IDX0], (rt_params).sizes[GWS1_RT_IDX0], (rt_params).blocks[GWS1_RT_IDX0]))==""\n"
R"==(#define GWS1_GET_ID1(rt_params) GWS1_OP1(GWS_GET_THREAD_ID(GWS1_IDX1), (rt_params).strides[GWS1_RT_IDX1], (rt_params).sizes[GWS1_RT_IDX1], (rt_params).blocks[GWS1_RT_IDX1]))==""\n"
R"==(#define GWS1_GET_ID2(rt_params) GWS1_OP2(GWS_GET_THREAD_ID(GWS1_IDX2), (rt_params).strides[GWS1_RT_IDX2], (rt_params).sizes[GWS1_RT_IDX2], (rt_params).blocks[GWS1_RT_IDX2]))==""\n"
R"==(#define GWS1_GET_ID3(rt_params) GWS1_OP3(GWS_GET_THREAD_ID(GWS1_IDX3), (rt_params).strides[GWS1_RT_IDX3], (rt_params).sizes[GWS1_RT_IDX3], (rt_params).blocks[GWS1_RT_IDX3]))==""\n"
R"==(#define GWS1_GET_ID4(rt_params) GWS1_OP4(GWS_GET_THREAD_ID(GWS1_IDX4), (rt_params).strides[GWS1_RT_IDX4], (rt_params).sizes[GWS1_RT_IDX4], (rt_params).blocks[GWS1_RT_IDX4]))==""\n"
R"==(#define GWS1_GET_ID5(rt_params) GWS1_OP5(GWS_GET_THREAD_ID(GWS1_IDX5), (rt_params).strides[GWS1_RT_IDX5], (rt_params).sizes[GWS1_RT_IDX5], (rt_params).blocks[GWS1_RT_IDX5]))==""\n"
R"==(#define GWS1_GET_ID6(rt_params) GWS1_OP6(GWS_GET_THREAD_ID(GWS1_IDX6), (rt_params).strides[GWS1_RT_IDX6], (rt_params).sizes[GWS1_RT_IDX6], (rt_params).blocks[GWS1_RT_IDX6]))==""\n"
R"==(#define GWS1_GET_ID7(rt_params) GWS1_OP7(GWS_GET_THREAD_ID(GWS1_IDX7), (rt_params).strides[GWS1_RT_IDX7], (rt_params).sizes[GWS1_RT_IDX7], (rt_params).blocks[GWS1_RT_IDX7]))==""\n"
R"==(#define GWS1_GET_ID8(rt_params) GWS1_OP8(GWS_GET_THREAD_ID(GWS1_IDX8), (rt_params).strides[GWS1_RT_IDX8], (rt_params).sizes[GWS1_RT_IDX8], (rt_params).blocks[GWS1_RT_IDX8]))==""\n"
R"==(#define GWS1_GET_ID9(rt_params) GWS1_OP9(GWS_GET_THREAD_ID(GWS1_IDX9), (rt_params).strides[GWS1_RT_IDX9], (rt_params).sizes[GWS1_RT_IDX9], (rt_params).blocks[GWS1_RT_IDX9]))==""\n"
R"==(#define GWS2_GET_ID0(rt_params) GWS2_OP0(GWS_GET_THREAD_ID(GWS2_IDX0), (rt_params).strides[GWS2_RT_IDX0], (rt_params).sizes[GWS2_RT_IDX0], (rt_params).blocks[GWS2_RT_IDX0]))==""\n"
R"==(#define GWS2_GET_ID1(rt_params) GWS2_OP1(GWS_GET_THREAD_ID(GWS2_IDX1), (rt_params).strides[GWS2_RT_IDX1], (rt_params).sizes[GWS2_RT_IDX1], (rt_params).blocks[GWS2_RT_IDX1]))==""\n"
R"==(#define GWS2_GET_ID2(rt_params) GWS2_OP2(GWS_GET_THREAD_ID(GWS2_IDX2), (rt_params).strides[GWS2_RT_IDX2], (rt_params).sizes[GWS2_RT_IDX2], (rt_params).blocks[GWS2_RT_IDX2]))==""\n"
R"==(#define GWS2_GET_ID3(rt_params) GWS2_OP3(GWS_GET_THREAD_ID(GWS2_IDX3), (rt_params).strides[GWS2_RT_IDX3], (rt_params).sizes[GWS2_RT_IDX3], (rt_params).blocks[GWS2_RT_IDX3]))==""\n"
R"==(#define GWS2_GET_ID4(rt_params) GWS2_OP4(GWS_GET_THREAD_ID(GWS2_IDX4), (rt_params).strides[GWS2_RT_IDX4], (rt_params).sizes[GWS2_RT_IDX4], (rt_params).blocks[GWS2_RT_IDX4]))==""\n"
R"==(#define GWS2_GET_ID5(rt_params) GWS2_OP5(GWS_GET_THREAD_ID(GWS2_IDX5), (rt_params).strides[GWS2_RT_IDX5], (rt_params).sizes[GWS2_RT_IDX5], (rt_params).blocks[GWS2_RT_IDX5]))==""\n"
R"==(#define GWS2_GET_ID6(rt_params) GWS2_OP6(GWS_GET_THREAD_ID(GWS2_IDX6), (rt_params).strides[GWS2_RT_IDX6], (rt_params).sizes[GWS2_RT_IDX6], (rt_params).blocks[GWS2_RT_IDX6]))==""\n"
R"==(#define GWS2_GET_ID7(rt_params) GWS2_OP7(GWS_GET_THREAD_ID(GWS2_IDX7), (rt_params).strides[GWS2_RT_IDX7], (rt_params).sizes[GWS2_RT_IDX7], (rt_params).blocks[GWS2_RT_IDX7]))==""\n"
R"==(#define GWS2_GET_ID8(rt_params) GWS2_OP8(GWS_GET_THREAD_ID(GWS2_IDX8), (rt_params).strides[GWS2_RT_IDX8], (rt_params).sizes[GWS2_RT_IDX8], (rt_params).blocks[GWS2_RT_IDX8]))==""\n"
R"==(#define GWS2_GET_ID9(rt_params) GWS2_OP9(GWS_GET_THREAD_ID(GWS2_IDX9), (rt_params).strides[GWS2_RT_IDX9], (rt_params).sizes[GWS2_RT_IDX9], (rt_params).blocks[GWS2_RT_IDX9]))==""\n"
R"==(#define GWS3_GET_ID0(rt_params) GWS3_OP0(GWS_GET_THREAD_ID(GWS3_IDX0), (rt_params).strides[GWS3_RT_IDX0], (rt_params).sizes[GWS3_RT_IDX0], (rt_params).blocks[GWS3_RT_IDX0]))==""\n"
R"==(#define GWS3_GET_ID1(rt_params) GWS3_OP1(GWS_GET_THREAD_ID(GWS3_IDX1), (rt_params).strides[GWS3_RT_IDX1], (rt_params).sizes[GWS3_RT_IDX1], (rt_params).blocks[GWS3_RT_IDX1]))==""\n"
R"==(#define GWS3_GET_ID2(rt_params) GWS3_OP2(GWS_GET_THREAD_ID(GWS3_IDX2), (rt_params).strides[GWS3_RT_IDX2], (rt_params).sizes[GWS3_RT_IDX2], (rt_params).blocks[GWS3_RT_IDX2]))==""\n"
R"==(#define GWS3_GET_ID3(rt_params) GWS3_OP3(GWS_GET_THREAD_ID(GWS3_IDX3), (rt_params).strides[GWS3_RT_IDX3], (rt_params).sizes[GWS3_RT_IDX3], (rt_params).blocks[GWS3_RT_IDX3]))==""\n"
R"==(#define GWS3_GET_ID4(rt_params) GWS3_OP4(GWS_GET_THREAD_ID(GWS3_IDX4), (rt_params).strides[GWS3_RT_IDX4], (rt_params).sizes[GWS3_RT_IDX4], (rt_params).blocks[GWS3_RT_IDX4]))==""\n"
R"==(#define GWS3_GET_ID5(rt_params) GWS3_OP5(GWS_GET_THREAD_ID(GWS3_IDX5), (rt_params).strides[GWS3_RT_IDX5], (rt_params).sizes[GWS3_RT_IDX5], (rt_params).blocks[GWS3_RT_IDX5]))==""\n"
R"==(#define GWS3_GET_ID6(rt_params) GWS3_OP6(GWS_GET_THREAD_ID(GWS3_IDX6), (rt_params).strides[GWS3_RT_IDX6], (rt_params).sizes[GWS3_RT_IDX6], (rt_params).blocks[GWS3_RT_IDX6]))==""\n"
R"==(#define GWS3_GET_ID7(rt_params) GWS3_OP7(GWS_GET_THREAD_ID(GWS3_IDX7), (rt_params).strides[GWS3_RT_IDX7], (rt_params).sizes[GWS3_RT_IDX7], (rt_params).blocks[GWS3_RT_IDX7]))==""\n"
R"==(#define GWS3_GET_ID8(rt_params) GWS3_OP8(GWS_GET_THREAD_ID(GWS3_IDX8), (rt_params).strides[GWS3_RT_IDX8], (rt_params).sizes[GWS3_RT_IDX8], (rt_params).blocks[GWS3_RT_IDX8]))==""\n"
R"==(#define GWS3_GET_ID9(rt_params) GWS3_OP9(GWS_GET_THREAD_ID(GWS3_IDX9), (rt_params).strides[GWS3_RT_IDX9], (rt_params).sizes[GWS3_RT_IDX9], (rt_params).blocks[GWS3_RT_IDX9]))==""\n"
R"==(#define DISPATCH_BUFFER_ALIAS(NAME, SUFFIX) \)==""\n"
R"==(CONCAT2(CONCAT2(GWS_, NAME), CONCAT2(_, SUFFIX)))==""\n"
R"==(#define GWS_GET_OFF_NAMED(NAME, SUFFIX, rt_params) \)==""\n"
R"==(CONCAT2(DISPATCH_BUFFER_ALIAS(NAME, SUFFIX), _OFF)(rt_params))==""\n"
R"==(#define GWS_GET_OFF(NAME, rt_params) \)==""\n"
R"==(GWS_GET_OFF_NAMED(NAME, DEFAULT_DISPATCHER_SUFFIX, rt_params))==""\n"
R"==(#define GWS_GET_NAMED(dim_name, dispatcher_name, rt_params) \)==""\n"
R"==(CONCAT2(CONCAT2(GWS_GET_, dim_name), CONCAT2(_, dispatcher_name))(rt_params))==""\n"
R"==(#define GWS_GET(dim_name, rt_params) \)==""\n"
R"==(GWS_GET_NAMED(dim_name, DEFAULT_DISPATCHER_SUFFIX, rt_params))==""\n"
R"==(#define GWS_GET_BUFFER_POS_NAMED(NAME, SUFFIX, rt_params, buffer) \)==""\n"
R"==(&buffer[GWS_GET_OFF_NAMED(NAME, SUFFIX, rt_params)])==""\n"
R"==(#define GWS_GET_BUFFER_POS(NAME, rt_params, buffer) \)==""\n"
R"==(GWS_GET_BUFFER_POS_NAMED(NAME, DEFAULT_DISPATCHER_SUFFIX, rt_params, buffer))==""\n"
R"==(#else)==""\n"
R"==(#define GWS_OP_ZERO(idx, stride, max) 0)==""\n"
R"==(#define GWS_OP_SOLO(idx, stride, max) (idx))==""\n"
R"==(#define GWS_OP_FIRST(idx, stride, max) ((idx) / (stride)))==""\n"
R"==(#define GWS_OP_MOD(idx, stride, max) ((idx) / (stride) % (max)))==""\n"
R"==(#define GWS0_GET_ID0() GWS0_OP0(GWS_GET_THREAD_ID(GWS0_IDX0), GWS0_STRIDE0, ROUND_UP(GWS0_DIM0, GWS0_BLOCK0)) / GWS0_VEC_SIZE0 * GWS0_VEC_SIZE0 * GWS0_BLOCK0)==""\n"
R"==(#define GWS0_GET_ID1() GWS0_OP1(GWS_GET_THREAD_ID(GWS0_IDX1), GWS0_STRIDE1, ROUND_UP(GWS0_DIM1, GWS0_BLOCK1)) / GWS0_VEC_SIZE1 * GWS0_VEC_SIZE1 * GWS0_BLOCK1)==""\n"
R"==(#define GWS0_GET_ID2() GWS0_OP2(GWS_GET_THREAD_ID(GWS0_IDX2), GWS0_STRIDE2, ROUND_UP(GWS0_DIM2, GWS0_BLOCK2)) / GWS0_VEC_SIZE2 * GWS0_VEC_SIZE2 * GWS0_BLOCK2)==""\n"
R"==(#define GWS0_GET_ID3() GWS0_OP3(GWS_GET_THREAD_ID(GWS0_IDX3), GWS0_STRIDE3, ROUND_UP(GWS0_DIM3, GWS0_BLOCK3)) / GWS0_VEC_SIZE3 * GWS0_VEC_SIZE3 * GWS0_BLOCK3)==""\n"
R"==(#define GWS0_GET_ID4() GWS0_OP4(GWS_GET_THREAD_ID(GWS0_IDX4), GWS0_STRIDE4, ROUND_UP(GWS0_DIM4, GWS0_BLOCK4)) / GWS0_VEC_SIZE4 * GWS0_VEC_SIZE4 * GWS0_BLOCK4)==""\n"
R"==(#define GWS0_GET_ID5() GWS0_OP5(GWS_GET_THREAD_ID(GWS0_IDX5), GWS0_STRIDE5, ROUND_UP(GWS0_DIM5, GWS0_BLOCK5)) / GWS0_VEC_SIZE5 * GWS0_VEC_SIZE5 * GWS0_BLOCK5)==""\n"
R"==(#define GWS1_GET_ID0() GWS1_OP0(GWS_GET_THREAD_ID(GWS1_IDX0), GWS1_STRIDE0, ROUND_UP(GWS1_DIM0, GWS1_BLOCK0)) / GWS1_VEC_SIZE0 * GWS1_VEC_SIZE0 * GWS1_BLOCK0)==""\n"
R"==(#define GWS1_GET_ID1() GWS1_OP1(GWS_GET_THREAD_ID(GWS1_IDX1), GWS1_STRIDE1, ROUND_UP(GWS1_DIM1, GWS1_BLOCK1)) / GWS1_VEC_SIZE1 * GWS1_VEC_SIZE1 * GWS1_BLOCK1)==""\n"
R"==(#define GWS1_GET_ID2() GWS1_OP2(GWS_GET_THREAD_ID(GWS1_IDX2), GWS1_STRIDE2, ROUND_UP(GWS1_DIM2, GWS1_BLOCK2)) / GWS1_VEC_SIZE2 * GWS1_VEC_SIZE2 * GWS1_BLOCK2)==""\n"
R"==(#define GWS1_GET_ID3() GWS1_OP3(GWS_GET_THREAD_ID(GWS1_IDX3), GWS1_STRIDE3, ROUND_UP(GWS1_DIM3, GWS1_BLOCK3)) / GWS1_VEC_SIZE3 * GWS1_VEC_SIZE3 * GWS1_BLOCK3)==""\n"
R"==(#define GWS1_GET_ID4() GWS1_OP4(GWS_GET_THREAD_ID(GWS1_IDX4), GWS1_STRIDE4, ROUND_UP(GWS1_DIM4, GWS1_BLOCK4)) / GWS1_VEC_SIZE4 * GWS1_VEC_SIZE4 * GWS1_BLOCK4)==""\n"
R"==(#define GWS1_GET_ID5() GWS1_OP5(GWS_GET_THREAD_ID(GWS1_IDX5), GWS1_STRIDE5, ROUND_UP(GWS1_DIM5, GWS1_BLOCK5)) / GWS1_VEC_SIZE5 * GWS1_VEC_SIZE5 * GWS1_BLOCK5)==""\n"
R"==(#define GWS2_GET_ID0() GWS2_OP0(GWS_GET_THREAD_ID(GWS2_IDX0), GWS2_STRIDE0, ROUND_UP(GWS2_DIM0, GWS2_BLOCK0)) / GWS2_VEC_SIZE0 * GWS2_VEC_SIZE0 * GWS2_BLOCK0)==""\n"
R"==(#define GWS2_GET_ID1() GWS2_OP1(GWS_GET_THREAD_ID(GWS2_IDX1), GWS2_STRIDE1, ROUND_UP(GWS2_DIM1, GWS2_BLOCK1)) / GWS2_VEC_SIZE1 * GWS2_VEC_SIZE1 * GWS2_BLOCK1)==""\n"
R"==(#define GWS2_GET_ID2() GWS2_OP2(GWS_GET_THREAD_ID(GWS2_IDX2), GWS2_STRIDE2, ROUND_UP(GWS2_DIM2, GWS2_BLOCK2)) / GWS2_VEC_SIZE2 * GWS2_VEC_SIZE2 * GWS2_BLOCK2)==""\n"
R"==(#define GWS2_GET_ID3() GWS2_OP3(GWS_GET_THREAD_ID(GWS2_IDX3), GWS2_STRIDE3, ROUND_UP(GWS2_DIM3, GWS2_BLOCK3)) / GWS2_VEC_SIZE3 * GWS2_VEC_SIZE3 * GWS2_BLOCK3)==""\n"
R"==(#define GWS2_GET_ID4() GWS2_OP4(GWS_GET_THREAD_ID(GWS2_IDX4), GWS2_STRIDE4, ROUND_UP(GWS2_DIM4, GWS2_BLOCK4)) / GWS2_VEC_SIZE4 * GWS2_VEC_SIZE4 * GWS2_BLOCK4)==""\n"
R"==(#define GWS2_GET_ID5() GWS2_OP5(GWS_GET_THREAD_ID(GWS2_IDX5), GWS2_STRIDE5, ROUND_UP(GWS2_DIM5, GWS2_BLOCK5)) / GWS2_VEC_SIZE5 * GWS2_VEC_SIZE5 * GWS2_BLOCK5)==""\n"
R"==(#define GWS3_GET_ID0() GWS3_OP0(GWS_GET_THREAD_ID(GWS3_IDX0), GWS3_STRIDE0, ROUND_UP(GWS3_DIM0, GWS3_BLOCK0)) / GWS3_VEC_SIZE0 * GWS3_VEC_SIZE0 * GWS3_BLOCK0)==""\n"
R"==(#define GWS3_GET_ID1() GWS3_OP1(GWS_GET_THREAD_ID(GWS3_IDX1), GWS3_STRIDE1, ROUND_UP(GWS3_DIM1, GWS3_BLOCK1)) / GWS3_VEC_SIZE1 * GWS3_VEC_SIZE1 * GWS3_BLOCK1)==""\n"
R"==(#define GWS3_GET_ID2() GWS3_OP2(GWS_GET_THREAD_ID(GWS3_IDX2), GWS3_STRIDE2, ROUND_UP(GWS3_DIM2, GWS3_BLOCK2)) / GWS3_VEC_SIZE2 * GWS3_VEC_SIZE2 * GWS3_BLOCK2)==""\n"
R"==(#define GWS3_GET_ID3() GWS3_OP3(GWS_GET_THREAD_ID(GWS3_IDX3), GWS3_STRIDE3, ROUND_UP(GWS3_DIM3, GWS3_BLOCK3)) / GWS3_VEC_SIZE3 * GWS3_VEC_SIZE3 * GWS3_BLOCK3)==""\n"
R"==(#define GWS3_GET_ID4() GWS3_OP4(GWS_GET_THREAD_ID(GWS3_IDX4), GWS3_STRIDE4, ROUND_UP(GWS3_DIM4, GWS3_BLOCK4)) / GWS3_VEC_SIZE4 * GWS3_VEC_SIZE4 * GWS3_BLOCK4)==""\n"
R"==(#define GWS3_GET_ID5() GWS3_OP5(GWS_GET_THREAD_ID(GWS3_IDX5), GWS3_STRIDE5, ROUND_UP(GWS3_DIM5, GWS3_BLOCK5)) / GWS3_VEC_SIZE5 * GWS3_VEC_SIZE5 * GWS3_BLOCK5)==""\n"
R"==(#endif)==""\n"
R"==(#define GWS0_GET_BLOCK0() GWS0_BLOCK0)==""\n"
R"==(#define GWS0_GET_BLOCK1() GWS0_BLOCK1)==""\n"
R"==(#define GWS0_GET_BLOCK2() GWS0_BLOCK2)==""\n"
R"==(#define GWS0_GET_BLOCK3() GWS0_BLOCK3)==""\n"
R"==(#define GWS0_GET_BLOCK4() GWS0_BLOCK4)==""\n"
R"==(#define GWS0_GET_BLOCK5() GWS0_BLOCK5)==""\n"
R"==(#define GWS1_GET_BLOCK0() GWS1_BLOCK0)==""\n"
R"==(#define GWS1_GET_BLOCK1() GWS1_BLOCK1)==""\n"
R"==(#define GWS1_GET_BLOCK2() GWS1_BLOCK2)==""\n"
R"==(#define GWS1_GET_BLOCK3() GWS1_BLOCK3)==""\n"
R"==(#define GWS1_GET_BLOCK4() GWS1_BLOCK4)==""\n"
R"==(#define GWS1_GET_BLOCK5() GWS1_BLOCK5)==""\n"
R"==(#define GWS2_GET_BLOCK0() GWS2_BLOCK0)==""\n"
R"==(#define GWS2_GET_BLOCK1() GWS2_BLOCK1)==""\n"
R"==(#define GWS2_GET_BLOCK2() GWS2_BLOCK2)==""\n"
R"==(#define GWS2_GET_BLOCK3() GWS2_BLOCK3)==""\n"
R"==(#define GWS2_GET_BLOCK4() GWS2_BLOCK4)==""\n"
R"==(#define GWS2_GET_BLOCK5() GWS2_BLOCK5)==""\n"
R"==(#define GWS3_GET_BLOCK0() GWS3_BLOCK0)==""\n"
R"==(#define GWS3_GET_BLOCK1() GWS3_BLOCK1)==""\n"
R"==(#define GWS3_GET_BLOCK2() GWS3_BLOCK2)==""\n"
R"==(#define GWS3_GET_BLOCK3() GWS3_BLOCK3)==""\n"
R"==(#define GWS3_GET_BLOCK4() GWS3_BLOCK4)==""\n"
R"==(#define GWS3_GET_BLOCK5() GWS3_BLOCK5)==""\n"
R"==(#ifdef GWS_WITH_RUNTIME_PARAMS)==""\n"
R"==(#define NAMED_KERNEL_ATTR_SG0(name))==""\n"
R"==(#define NAMED_KERNEL_ATTR_SG1(name) \)==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(CONCAT2(GWS_SGS_, name)))))==""\n"
R"==(#else)==""\n"
R"==(#define NAMED_KERNEL_ATTR_SG0(name) \)==""\n"
R"==(__attribute__((reqd_work_group_size(CONCAT2(GWS_LWS0_, name), \)==""\n"
R"==(CONCAT2(GWS_LWS1_, name), CONCAT2(GWS_LWS2_, name)))))==""\n"
R"==(#define NAMED_KERNEL_ATTR_SG1(name) \)==""\n"
R"==(NAMED_KERNEL_ATTR_SG0(name) \)==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(CONCAT2(GWS_SGS_, name)))))==""\n"
R"==(#endif)==""\n"
R"==(#define NAMED_KERNEL_ATTR(name) \)==""\n"
R"==(CONCAT2(NAMED_KERNEL_ATTR_SG, CONCAT2(GWS_WITH_SG_, name))(name))==""\n"
R"==(#define KERNEL_ATTR NAMED_KERNEL_ATTR(DEFAULT))==""\n"
R"==(#define MAYBE_SKIP_NON_UNIFORM_WG() \)==""\n"
R"==(do { \)==""\n"
R"==(if ((GWS_0 != GWS_ORIG_0) && (GWS_ORIG_0 % LWS_0 != 0) \)==""\n"
R"==(&& (GWS_GET_THREAD_ID(0) >= GWS_ORIG_0)) \)==""\n"
R"==(return; \)==""\n"
R"==(if ((GWS_1 != GWS_ORIG_1) && (GWS_ORIG_1 % LWS_1 != 0) \)==""\n"
R"==(&& (GWS_GET_THREAD_ID(1) >= GWS_ORIG_1)) \)==""\n"
R"==(return; \)==""\n"
R"==(if ((GWS_2 != GWS_ORIG_2) && (GWS_ORIG_2 % LWS_2 != 0) \)==""\n"
R"==(&& (GWS_GET_THREAD_ID(2) >= GWS_ORIG_2)) \)==""\n"
R"==(return; \)==""\n"
R"==(} while (0))==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}