namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gen9_bnorm_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_BNORM_GEN9_BNORM_H)==""\n"
R"==(#define GPU_INTEL_OCL_BNORM_GEN9_BNORM_H)==""\n"
R"==(#define VECT_DT_N VECT_SIZE)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#define IS_IC_EQ_8 (IC == 8))==""\n"
R"==(#define HAS_IC_TAIL (IC != PADDED_IC))==""\n"
R"==(#define HAS_STAT_SP_BLOCK_TAIL (SP % STAT_SP_BLOCK))==""\n"
R"==(#define HAS_UPDATE_SP_BLOCK_TAIL (SP % UPDATE_SP_BLOCK))==""\n"
R"==(#if HAS_UPDATE_SP_BLOCK_TAIL % UPDATE_SP_UNROLL)==""\n"
R"==(#error "UPDATE_SP_UNROLL value not expected")==""\n"
R"==(#endif)==""\n"
R"==(#if NHWC_OPTIMIZED)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(#error IC tail processing not supported)==""\n"
R"==(#endif)==""\n"
R"==(#else )==""\n"
R"==(#if HAS_IC_TAIL && !USE_NHWC)==""\n"
R"==(#error IC tail processing not supported)==""\n"
R"==(#endif)==""\n"
R"==(#define HAS_STAT_SP_TAIL (STAT_SP_TAIL != STAT_SP_NBLOCKS))==""\n"
R"==(#define HAS_SP_TAIL (SP != SP_TAIL))==""\n"
R"==(#endif )==""\n"
R"==(#define IC_BLOCK_SGROUPS (IC_BLOCK / SG_SIZE))==""\n"
R"==(#define IC_TAIL_SGROUPS (IC_BLOCK_SGROUPS % VECT_SIZE))==""\n"
R"==(#define IC_VECT_SGROUPS (IC_BLOCK_SGROUPS - IC_TAIL_SGROUPS))==""\n"
R"==(#define HAS_IC_VECT_TAIL (IC_TAIL_SGROUPS > 0))==""\n"
R"==(#define LOAD_FLOAT_1x16(ptr) \)==""\n"
R"==(as_float(intel_sub_group_block_read((const __global uint *)(ptr))))==""\n"
R"==(#define LOAD_UINT_1x16(ptr) \)==""\n"
R"==(as_uint(intel_sub_group_block_read((const __global uint *)(ptr))))==""\n"
R"==(#define LOAD_UINT_8x16(ptr) \)==""\n"
R"==(convert_uint8(as_uint8( \)==""\n"
R"==(intel_sub_group_block_read8((const __global uint *)(ptr)))))==""\n"
R"==(#define LOAD_CHAR_1x16(ptr) \)==""\n"
R"==(as_char(intel_sub_group_block_read_uc((const __global uchar *)(ptr))))==""\n"
R"==(#define LOAD_CHAR_8x16(ptr) \)==""\n"
R"==(convert_char8(as_char8( \)==""\n"
R"==(intel_sub_group_block_read_uc8((const __global uchar *)(ptr)))))==""\n"
R"==(#define LOAD_DATA_1x16(ptr) \)==""\n"
R"==(CONVERT_FLOAT_T(AS_DATA_T(BLOCK_READ((const __global BLOCK_DATA_T *)(ptr)))))==""\n"
R"==(#define LOAD_DATA_8x16(ptr) \)==""\n"
R"==(CONVERT_FLOAT8_T( \)==""\n"
R"==(AS_DATA8_T(BLOCK_READ8((const __global BLOCK_DATA_T *)(ptr)))))==""\n"
R"==(#define LOAD_VECT_DATA(ptr) \)==""\n"
R"==(CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T( \)==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)(ptr)))))==""\n"
R"==(#define LOAD_VECT_CHAR(ptr) \)==""\n"
R"==(CONVERT_VECT_CHAR_T( \)==""\n"
R"==(AS_VECT_CHAR_T(VECT_UCHAR_READ((const __global uchar *)(ptr)))))==""\n"
R"==(#define LOAD_VECT_FLOAT(ptr) \)==""\n"
R"==(AS_VECT_FLOAT_T(VECT_UINT_READ((const __global uint *)(ptr))))==""\n"
R"==(#define STORE_DATA_1x16(ptr, val) \)==""\n"
R"==(BLOCK_WRITE((__global BLOCK_DATA_T *)(ptr), \)==""\n"
R"==(AS_BLOCK_DATA_T(CONVERT_DATA_T(val))))==""\n"
R"==(#define STORE_DATA_8x16(ptr, val) \)==""\n"
R"==(BLOCK_WRITE8((__global BLOCK_DATA_T *)ptr, \)==""\n"
R"==(AS_BLOCK_DATA8_T(CONVERT_DATA8_T(val))))==""\n"
R"==(#define STORE_VECT_DATA(ptr, val) \)==""\n"
R"==(VECT_BLOCK_WRITE((__global BLOCK_DATA_T *)(ptr), \)==""\n"
R"==(AS_VECT_BLOCK_DATA_T(CONVERT_VECTOR_DATA_T(val))))==""\n"
R"==(#define STORE_FLOAT_1x16(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write((__global uint *)(ptr), as_uint(val)))==""\n"
R"==(#define STORE_FLOAT_8x16(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write8((__global uint *)(ptr), as_uint8(val)))==""\n"
R"==(#define STORE_CHAR_1x16(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write_uc((__global uchar *)(ptr), as_uchar(val)))==""\n"
R"==(#define STORE_CHAR_8x16(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)(ptr), as_uchar8(val)))==""\n"
R"==(#define STORE_VECT_CHAR(ptr, val) \)==""\n"
R"==(VECT_UCHAR_WRITE((__global uchar *)(ptr), \)==""\n"
R"==(AS_VECT_UCHAR_T(CONVERT_VECT_CHAR_T(val))))==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(#define MAYBE_LAST_IC_LOAD_FLOAT_1x16(ptr, idx) \)==""\n"
R"==((is_last_ic_block ? (simd_id < 8 ? ptr[(idx) + simd_id] : 0.0f) \)==""\n"
R"==(: as_float(intel_sub_group_block_read( \)==""\n"
R"==((const __global uint *)(&ptr[(idx)])))))==""\n"
R"==(#else)==""\n"
R"==(#define MAYBE_LAST_IC_LOAD_FLOAT_1x16(ptr, idx) LOAD_FLOAT_1x16(&ptr[(idx)]))==""\n"
R"==(#endif)==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(#define ISGREATER(x, y) ((x) > (y) ? -1 : 0))==""\n"
R"==(#else)==""\n"
R"==(#define ISGREATER(x, y) isgreater((x), (y)))==""\n"
R"==(#endif)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(#define IC_BLOCK_STRIDE IC)==""\n"
R"==(#else)==""\n"
R"==(#define IC_BLOCK_STRIDE 16)==""\n"
R"==(#endif)==""\n"
R"==(#if NHWC_OPTIMIZED)==""\n"
R"==(#define REDUCE_NUM_SGROUPS IC_BLOCK_SGROUPS)==""\n"
R"==(#else)==""\n"
R"==(#define REDUCE_NUM_SGROUPS 1)==""\n"
R"==(#endif)==""\n"
R"==(#define CALC_SLM_LINE_SIZE (REDUCE_NUM_SGROUPS * GWS_LWS0_CALC))==""\n"
R"==(#define CALC_SLM_SIZE (CALC_SLM_LINE_SIZE * GWS_LWS1_CALC * GWS_LWS2_CALC))==""\n"
R"==(#if IS_FWD)==""\n"
R"==(#if USE_STATS_ONE_PASS)==""\n"
R"==(#define ACCUM_DATA_T float)==""\n"
R"==(#define ACCUM_DATA8_T float8)==""\n"
R"==(#define ACCUM_DATA2_T float2)==""\n"
R"==(#define SUM_DATA_T ACCUM_DATA2_T)==""\n"
R"==(SUM_DATA_T summation(ACCUM_DATA_T input, SUM_DATA_T state) {)==""\n"
R"==(ACCUM_DATA2_T ret;)==""\n"
R"==(ACCUM_DATA_T y = input - state.s1;)==""\n"
R"==(ACCUM_DATA_T t = state.s0 + y;)==""\n"
R"==(ret.s1 = (t - state.s0) - y;)==""\n"
R"==(ret.s0 = t;)==""\n"
R"==(return ret;)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION)==""\n"
R"==(#if NHWC_OPTIMIZED)==""\n"
R"==(#if VECT_SIZE > 1)==""\n"
R"==(#define GET_SCALAR_VAL(v, idx) v[idx / VECT_SIZE][idx % VECT_SIZE])==""\n"
R"==(#else)==""\n"
R"==(#define GET_SCALAR_VAL(v, idx) v[idx])==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(#define GET_SCALAR_VAL(v, idx) v[idx])==""\n"
R"==(#endif)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(#if USE_STATS_ONE_PASS)==""\n"
R"==(void gen9_mean_var_calc_fused_reduction(volatile __global atomic_float *mean,)==""\n"
R"==(volatile __global atomic_float *variance, int dst_offset,)==""\n"
R"==(SUM_DATA_T *sum, SUM_DATA_T *sum_sq, __local SUM_DATA_T *local_sum,)==""\n"
R"==(__local SUM_DATA_T *local_sum_sq) {)==""\n"
R"==(#else )==""\n"
R"==(void gen9_calc_fused_reduction(volatile __global atomic_float *dst,)==""\n"
R"==(int dst_offset, float *sum, __local float *local_sum) {)==""\n"
R"==(#endif)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(const int group_size = GWS_LWS1_CALC * GWS_LWS2_CALC;)==""\n"
R"==(const int sg_group_id = get_local_id(0) / SG_SIZE;)==""\n"
R"==(const int local_id = get_local_id(1);)==""\n"
R"==(if (local_id > 0) {)==""\n"
R"==(for (int sg = 0; sg < REDUCE_NUM_SGROUPS; ++sg) {)==""\n"
R"==(const int slm_offset = CALC_SLM_LINE_SIZE * local_id)==""\n"
R"==(+ REDUCE_NUM_SGROUPS * SG_SIZE * sg_group_id + sg * SG_SIZE)==""\n"
R"==(+ simd_id;)==""\n"
R"==(local_sum[slm_offset] = sum[sg];)==""\n"
R"==(#if USE_STATS_ONE_PASS)==""\n"
R"==(local_sum_sq[slm_offset] = sum_sq[sg];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(if (local_id == 0) {)==""\n"
R"==(for (int sg = 0; sg < REDUCE_NUM_SGROUPS; ++sg) {)==""\n"
R"==(for (int gr_id = 1; gr_id < group_size; ++gr_id) {)==""\n"
R"==(const int off_local = CALC_SLM_LINE_SIZE * gr_id)==""\n"
R"==(+ REDUCE_NUM_SGROUPS * SG_SIZE * sg_group_id)==""\n"
R"==(+ sg * SG_SIZE + simd_id;)==""\n"
R"==(#if USE_STATS_ONE_PASS)==""\n"
R"==(SUM_DATA_T tmp = local_sum[off_local];)==""\n"
R"==(SUM_DATA_T tmp_sq = local_sum_sq[off_local];)==""\n"
R"==(sum[sg] = summation(tmp.s1, sum[sg]);)==""\n"
R"==(sum_sq[sg] = summation(tmp_sq.s1, sum_sq[sg]);)==""\n"
R"==(sum[sg] = summation(tmp.s0, sum[sg]);)==""\n"
R"==(sum_sq[sg] = summation(tmp_sq.s0, sum_sq[sg]);)==""\n"
R"==(#else )==""\n"
R"==(sum[sg] += local_sum[off_local];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(const int offset = dst_offset + sg * SG_SIZE + simd_id;)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(if (offset < IC) {)==""\n"
R"==(#endif)==""\n"
R"==(#if USE_STATS_ONE_PASS)==""\n"
R"==(atomic_add_global(&mean[offset], sum[sg].s0);)==""\n"
R"==(atomic_add_global(&variance[offset], sum_sq[sg].s0);)==""\n"
R"==(#else )==""\n"
R"==(atomic_add_global(&dst[offset], sum[sg]);)==""\n"
R"==(#endif)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#if IS_BWD)==""\n"
R"==(void gen9_calc_fused_reduction(volatile __global atomic_float *diff_scale,)==""\n"
R"==(volatile __global atomic_float *diff_shift, int dst_offset,)==""\n"
R"==(#if NHWC_OPTIMIZED)==""\n"
R"==(VECT_FLOAT_T *diff_gamma, VECT_FLOAT_T *diff_beta,)==""\n"
R"==(#else)==""\n"
R"==(float8 diff_gamma, float8 diff_beta,)==""\n"
R"==(#endif)==""\n"
R"==(float *diff_gamma_tail, float *diff_beta_tail,)==""\n"
R"==(__local float *local_gamma, __local float *local_beta) {)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(const int group_size = GWS_LWS1_CALC * GWS_LWS2_CALC;)==""\n"
R"==(const int sg_group_id = get_local_id(0) / SG_SIZE;)==""\n"
R"==(const int local_id = get_local_id(1);)==""\n"
R"==(for (int sg = 0; sg < REDUCE_NUM_SGROUPS; ++sg) {)==""\n"
R"==(const int slm_offset = CALC_SLM_LINE_SIZE * local_id)==""\n"
R"==(+ REDUCE_NUM_SGROUPS * SG_SIZE * sg_group_id + sg * SG_SIZE)==""\n"
R"==(+ simd_id;)==""\n"
R"==(#if HAS_IC_VECT_TAIL && NHWC_OPTIMIZED)==""\n"
R"==(if (sg >= IC_VECT_SGROUPS) {)==""\n"
R"==(local_gamma[slm_offset] = diff_gamma_tail[sg - IC_VECT_SGROUPS];)==""\n"
R"==(local_beta[slm_offset] = diff_beta_tail[sg - IC_VECT_SGROUPS];)==""\n"
R"==(} else)==""\n"
R"==(#endif)==""\n"
R"==({)==""\n"
R"==(local_gamma[slm_offset] = GET_SCALAR_VAL(diff_gamma, sg);)==""\n"
R"==(local_beta[slm_offset] = GET_SCALAR_VAL(diff_beta, sg);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(if (local_id == 0) {)==""\n"
R"==(for (int sg = 0; sg < REDUCE_NUM_SGROUPS; ++sg) {)==""\n"
R"==(float d_gamma = 0.f;)==""\n"
R"==(float d_beta = 0.f;)==""\n"
R"==(for (int gr_id = 0; gr_id < group_size; ++gr_id) {)==""\n"
R"==(const int off_local = CALC_SLM_LINE_SIZE * gr_id)==""\n"
R"==(+ REDUCE_NUM_SGROUPS * SG_SIZE * sg_group_id)==""\n"
R"==(+ sg * SG_SIZE + simd_id;)==""\n"
R"==(d_gamma += local_gamma[off_local];)==""\n"
R"==(d_beta += local_beta[off_local];)==""\n"
R"==(})==""\n"
R"==(const int offset = dst_offset + sg * SG_SIZE + simd_id;)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(if (offset < IC))==""\n"
R"==(#endif)==""\n"
R"==({)==""\n"
R"==(atomic_add_global(&diff_scale[offset], d_gamma);)==""\n"
R"==(#if DIFF_SHIFT == 1)==""\n"
R"==(atomic_add_global(&diff_shift[offset], d_beta);)==""\n"
R"==(#else)==""\n"
R"==(atomic_add_global()==""\n"
R"==(&diff_shift[IC + IC * REDUCE_STAT_NBLOCKS + offset],)==""\n"
R"==(d_beta);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}
}