namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gen9_pooling_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(inline VECT_DATA_T read_vect_c_block(int idx, const __global DATA_T *ptr, int c,)==""\n"
R"==(int blocks_stride, int chunks_per_block);)==""\n"
R"==(inline VECT_INT_T read_vect_c_block_int(int idx, const __global int *ptr, int c,)==""\n"
R"==(int blocks_stride, int chunks_per_block);)==""\n"
R"==(inline void write_vect_c_block(int idx, __global DATA_T *ptr, int c,)==""\n"
R"==(int blocks_stride, int chunks_per_block, VECT_DATA_T block);)==""\n"
R"==(inline void write_vect_c_block_int(int idx, __global int *ptr, int c,)==""\n"
R"==(int blocks_stride, int chunks_per_block, VECT_INT_T block);)==""\n"
R"==(#if DT_BF16 || DT_F16)==""\n"
R"==(#define USE_FLOATS true)==""\n"
R"==(#else)==""\n"
R"==(#define USE_FLOATS (ALG_AVG_NP || ALG_AVG_P))==""\n"
R"==(#endif)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void gen9_pooling_fwd(__global DATA_T *src, __global int *ws,)==""\n"
R"==(__global DATA_T *dst, const int batch_id POST_OP_ARGS) {)==""\n"
R"==(const int mb0 = MB_BLOCK_SIZE * batch_id + GWS_GET_MB();)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(const int mb1 = mb0 + MB / 2;)==""\n"
R"==(#endif)==""\n"
R"==(const int c = GWS_GET_C();)==""\n"
R"==(const int od = GWS_GET_OD();)==""\n"
R"==(const int oh = GWS_GET_OH();)==""\n"
R"==(const int ow = GWS_GET_OW();)==""\n"
R"==(#if USE_MB_C_BLOCK)==""\n"
R"==(const int src_stride = (SRC_SB0 > 1) ? SRC_SB0 : SRC_S0;)==""\n"
R"==(const int dst_stride = (DST_SB0 > 1) ? DST_SB0 : DST_S0;)==""\n"
R"==(const int src_chunks_per_c_block = CHUNKS_PER_C_BLOCK;)==""\n"
R"==(const int dst_chunks_per_c_block = CHUNKS_PER_C_BLOCK;)==""\n"
R"==(#elif USE_ONLY_C_BLOCK)==""\n"
R"==(const int src_stride = (SRC_B1 > 1) ? SRC_S1 : SUB_GROUP_SIZE;)==""\n"
R"==(const int dst_stride = (DST_B1 > 1) ? DST_S1 : SUB_GROUP_SIZE;)==""\n"
R"==(const int src_chunks_per_c_block)==""\n"
R"==(= (SRC_B1 > 1) ? (SRC_B1 / SUB_GROUP_SIZE) : 1;)==""\n"
R"==(const int dst_chunks_per_c_block)==""\n"
R"==(= (DST_B1 > 1) ? (DST_B1 / SUB_GROUP_SIZE) : 1;)==""\n"
R"==(#endif)==""\n"
R"==(const int ws_stride = dst_stride;)==""\n"
R"==(const int ws_chunks_per_c_block = dst_chunks_per_c_block;)==""\n"
R"==(if (mb0 >= SRC_D0) {)==""\n"
R"==(VECT_DATA_T dst_zero = DATA_ZERO;)==""\n"
R"==(VECT_INT_T ws_zero = 0;)==""\n"
R"==(int off = DST_OFF(mb0, c, od, oh, ow);)==""\n"
R"==(write_vect_c_block()==""\n"
R"==(0, &dst[off], c, dst_stride, dst_chunks_per_c_block, dst_zero);)==""\n"
R"==(write_vect_c_block()==""\n"
R"==(1, &dst[off], c, dst_stride, dst_chunks_per_c_block, dst_zero);)==""\n"
R"==(#if ALG_MAX && IS_TRAINING)==""\n"
R"==(write_vect_c_block_int()==""\n"
R"==(0, &ws[off], c, ws_stride, ws_chunks_per_c_block, ws_zero);)==""\n"
R"==(write_vect_c_block_int()==""\n"
R"==(1, &ws[off], c, ws_stride, ws_chunks_per_c_block, ws_zero);)==""\n"
R"==(#endif )==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(const int id = od * SD - PD;)==""\n"
R"==(const int ih = oh * SH - PH;)==""\n"
R"==(const int iw = ow * SW - PW;)==""\n"
R"==(#if USE_FLOATS)==""\n"
R"==(VECT_FLOAT_T D0 = ALG_MAX ? CONVERT_FLOAT_T(DATA_MIN) : 0.0f;)==""\n"
R"==(VECT_FLOAT_T D1 = ALG_MAX ? CONVERT_FLOAT_T(DATA_MIN) : 0.0f;)==""\n"
R"==(#else )==""\n"
R"==(VECT_DATA_T D0 = ALG_MAX ? DATA_MIN : DATA_ZERO;)==""\n"
R"==(VECT_DATA_T D1 = ALG_MAX ? DATA_MIN : DATA_ZERO;)==""\n"
R"==(#endif )==""\n"
R"==(VECT_INT_T WS0 = 0, WS1 = 0;)==""\n"
R"==(for (int kd = 0; kd < KD; ++kd) {)==""\n"
R"==(if (id + kd < 0 || id + kd >= ID) continue;)==""\n"
R"==(for (int kh = 0; kh < KH; ++kh) {)==""\n"
R"==(if (ih + kh < 0 || ih + kh >= IH) continue;)==""\n"
R"==(for (int kw = 0; kw < KW; ++kw) {)==""\n"
R"==(if (iw + kw < 0 || iw + kw >= IW) continue;)==""\n"
R"==(int src_off0 = SRC_OFF(mb0, c, id + kd, ih + kh, iw + kw);)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(int src_off1 = SRC_OFF(mb1, c, id + kd, ih + kh, iw + kw);)==""\n"
R"==(#endif)==""\n"
R"==(#if USE_FLOATS)==""\n"
R"==(VECT_FLOAT_T S0 = CONVERT_VECT_FLOAT_T(read_vect_c_block(0,)==""\n"
R"==(&src[src_off0], c, src_stride, src_chunks_per_c_block));)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(VECT_FLOAT_T S1 = CONVERT_VECT_FLOAT_T(read_vect_c_block(0,)==""\n"
R"==(&src[src_off1], c, src_stride, src_chunks_per_c_block));)==""\n"
R"==(#else)==""\n"
R"==(VECT_FLOAT_T S1 = CONVERT_VECT_FLOAT_T(read_vect_c_block(1,)==""\n"
R"==(&src[src_off0], c, src_stride, src_chunks_per_c_block));)==""\n"
R"==(#endif)==""\n"
R"==(#else )==""\n"
R"==(VECT_DATA_T S0 = read_vect_c_block(0, &src[src_off0], c,)==""\n"
R"==(src_stride, src_chunks_per_c_block);)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(VECT_DATA_T S1 = read_vect_c_block(0, &src[src_off1], c,)==""\n"
R"==(src_stride, src_chunks_per_c_block);)==""\n"
R"==(#else)==""\n"
R"==(VECT_DATA_T S1 = read_vect_c_block(1, &src[src_off0], c,)==""\n"
R"==(src_stride, src_chunks_per_c_block);)==""\n"
R"==(#endif)==""\n"
R"==(#endif )==""\n"
R"==(#if ALG_MAX)==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(VECT_INT_T CMP0 = isless(D0, S0);)==""\n"
R"==(WS0 = select(WS0, kd * KH * KW + kh * KW + kw, CMP0);)==""\n"
R"==(D0 = select(D0, S0, CMP0);)==""\n"
R"==(VECT_INT_T CMP1 = isless(D1, S1);)==""\n"
R"==(WS1 = select(WS1, kd * KH * KW + kh * KW + kw, CMP1);)==""\n"
R"==(D1 = select(D1, S1, CMP1);)==""\n"
R"==(#else )==""\n"
R"==(D0 = max(D0, S0);)==""\n"
R"==(D1 = max(D1, S1);)==""\n"
R"==(#endif )==""\n"
R"==(#else )==""\n"
R"==(D0 += S0;)==""\n"
R"==(D1 += S1;)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if ALG_AVG_P)==""\n"
R"==(D0 = D0 / (KD * KH * KW);)==""\n"
R"==(D1 = D1 / (KD * KH * KW);)==""\n"
R"==(#endif )==""\n"
R"==(#if ALG_AVG_NP)==""\n"
R"==(const int id_start = max(od * SD - PD, 0);)==""\n"
R"==(const int ih_start = max(oh * SH - PH, 0);)==""\n"
R"==(const int iw_start = max(ow * SW - PW, 0);)==""\n"
R"==(const int id_end = min(od * SD - PD + KD, ID);)==""\n"
R"==(const int ih_end = min(oh * SH - PH + KH, IH);)==""\n"
R"==(const int iw_end = min(ow * SW - PW + KW, IW);)==""\n"
R"==(const int num_summands)==""\n"
R"==(= (ih_end - ih_start) * (iw_end - iw_start) * (id_end - id_start);)==""\n"
R"==(D0 = D0 / num_summands;)==""\n"
R"==(D1 = D1 / num_summands;)==""\n"
R"==(#endif )==""\n"
R"==(int dst_off0 = DST_OFF(mb0, c, od, oh, ow);)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(int dst_off1 = DST_OFF(mb1, c, od, oh, ow);)==""\n"
R"==(#endif)==""\n"
R"==(VECT_DATA_T sum0;)==""\n"
R"==(VECT_DATA_T sum1;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(sum0 = read_vect_c_block()==""\n"
R"==(0, &dst[dst_off0], c, dst_stride, dst_chunks_per_c_block);)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(sum1 = read_vect_c_block()==""\n"
R"==(0, &dst[dst_off1], c, dst_stride, dst_chunks_per_c_block);)==""\n"
R"==(#else)==""\n"
R"==(sum1 = read_vect_c_block()==""\n"
R"==(1, &dst[dst_off0], c, dst_stride, dst_chunks_per_c_block);)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(const int local_id = get_sub_group_local_id();)==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(const int po_mb = mb0;)==""\n"
R"==(const int po_oc = c + local_id;)==""\n"
R"==(if (po_oc < C_WO_PADDING) {)==""\n"
R"==(POST_OP_DATA_T po_sum0 = DATA_TO_REF(sum0);)==""\n"
R"==(float po_D0 = USE_FLOATS ? D0 : CONVERT_FLOAT_T(D0);)==""\n"
R"==(APPLY_POST_OPS_SERIAL_BINARY_2D()==""\n"
R"==(po_D0, float, po_sum0, POST_OP_DATA_T, po_mb, 1, po_oc, 1);)==""\n"
R"==(D0 = USE_FLOATS ? po_D0 : CONVERT_DATA_T(po_D0);)==""\n"
R"==(POST_OP_DATA_T po_sum1 = DATA_TO_REF(sum1);)==""\n"
R"==(float po_D1 = USE_FLOATS ? D1 : CONVERT_FLOAT_T(D1);)==""\n"
R"==(APPLY_POST_OPS_SERIAL_BINARY_2D()==""\n"
R"==(po_D1, float, po_sum1, POST_OP_DATA_T, po_mb, 1, po_oc, 1);)==""\n"
R"==(D1 = USE_FLOATS ? po_D1 : CONVERT_DATA_T(po_D1);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(for (int idx = 0; idx < VECT_DT_N; ++idx) {)==""\n"
R"==(#if USE_MB_C_BLOCK)==""\n"
R"==(int c_sub_block_id = idx % CHUNKS_PER_C_BLOCK;)==""\n"
R"==(int mb_sub_block_id = idx / CHUNKS_PER_C_BLOCK;)==""\n"
R"==(const int po_oc = c + c_sub_block_id * SUB_GROUP_SIZE + local_id;)==""\n"
R"==(int po_mb = (mb0 + mb_sub_block_id) % MB;)==""\n"
R"==(#else )==""\n"
R"==(const int po_oc = c + idx * SUB_GROUP_SIZE + local_id;)==""\n"
R"==(int po_mb = mb0;)==""\n"
R"==(#endif )==""\n"
R"==(if (po_mb >= MB || po_oc >= C_WO_PADDING) continue;)==""\n"
R"==(float d0_i = USE_FLOATS ? D0[idx] : CONVERT_FLOAT_T(D0[idx]);)==""\n"
R"==(POST_OP_DATA_T sum0_i = DATA_TO_REF(sum0[idx]);)==""\n"
R"==(APPLY_POST_OPS_SERIAL_BINARY_2D()==""\n"
R"==(d0_i, float, sum0_i, POST_OP_DATA_T, po_mb, 1, po_oc, 1);)==""\n"
R"==(D0[idx] = USE_FLOATS ? d0_i : CONVERT_DATA_T(d0_i);)==""\n"
R"==(float d1_i = USE_FLOATS ? D1[idx] : CONVERT_FLOAT_T(D1[idx]);)==""\n"
R"==(POST_OP_DATA_T sum1_i = DATA_TO_REF(sum1[idx]);)==""\n"
R"==(po_mb += VECT_DT_N;)==""\n"
R"==(APPLY_POST_OPS_SERIAL_BINARY_2D()==""\n"
R"==(d1_i, float, sum1_i, POST_OP_DATA_T, po_mb, 1, po_oc, 1);)==""\n"
R"==(D1[idx] = USE_FLOATS ? d1_i : CONVERT_DATA_T(d1_i);)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#if USE_FLOATS)==""\n"
R"==(VECT_DATA_T res0 = CONVERT_VECTOR_DATA_T(D0);)==""\n"
R"==(VECT_DATA_T res1 = CONVERT_VECTOR_DATA_T(D1);)==""\n"
R"==(#else)==""\n"
R"==(VECT_DATA_T res0 = D0;)==""\n"
R"==(VECT_DATA_T res1 = D1;)==""\n"
R"==(#endif)==""\n"
R"==(write_vect_c_block()==""\n"
R"==(0, &dst[dst_off0], c, dst_stride, dst_chunks_per_c_block, res0);)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(write_vect_c_block()==""\n"
R"==(0, &dst[dst_off1], c, dst_stride, dst_chunks_per_c_block, res1);)==""\n"
R"==(#else)==""\n"
R"==(write_vect_c_block()==""\n"
R"==(1, &dst[dst_off0], c, dst_stride, dst_chunks_per_c_block, res1);)==""\n"
R"==(#endif)==""\n"
R"==(#if ALG_MAX && IS_TRAINING)==""\n"
R"==(int ws_off0 = dst_off0;)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(int ws_off1 = dst_off1;)==""\n"
R"==(#endif)==""\n"
R"==(write_vect_c_block_int()==""\n"
R"==(0, &ws[ws_off0], c, ws_stride, ws_chunks_per_c_block, WS0);)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(write_vect_c_block_int()==""\n"
R"==(0, &ws[ws_off1], c, ws_stride, ws_chunks_per_c_block, WS1);)==""\n"
R"==(#else)==""\n"
R"==(write_vect_c_block_int()==""\n"
R"==(1, &ws[ws_off0], c, ws_stride, ws_chunks_per_c_block, WS1);)==""\n"
R"==(#endif)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if IS_BWD)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void gen9_pooling_bwd(__global DATA_T *diff_src, __global int *ws,)==""\n"
R"==(__global DATA_T *diff_dst) {)==""\n"
R"==(const int mb0 = GWS_GET_MB();)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(int mb[UNROLL_MB_COUNT];)==""\n"
R"==(mb[0] = GWS_GET_MB();)==""\n"
R"==(unroll_for(int i = 1; i < UNROLL_MB_COUNT; i++) {)==""\n"
R"==(mb[i] = mb[i - 1] + MB / UNROLL_MB_COUNT;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(const int c = GWS_GET_C();)==""\n"
R"==(const int id = GWS_GET_ID();)==""\n"
R"==(const int ih = GWS_GET_IH();)==""\n"
R"==(const int iw = GWS_GET_IW();)==""\n"
R"==(#if USE_MB_C_BLOCK)==""\n"
R"==(const int src_stride = (SRC_SB0 > 1) ? SRC_SB0 : SRC_S0;)==""\n"
R"==(const int dst_stride = (DST_SB0 > 1) ? DST_SB0 : DST_S0;)==""\n"
R"==(const int src_chunks_per_c_block = CHUNKS_PER_C_BLOCK;)==""\n"
R"==(const int dst_chunks_per_c_block = CHUNKS_PER_C_BLOCK;)==""\n"
R"==(#elif USE_ONLY_C_BLOCK)==""\n"
R"==(const int src_stride = (SRC_B1 > 1) ? SRC_S1 : SUB_GROUP_SIZE;)==""\n"
R"==(const int dst_stride = (DST_B1 > 1) ? DST_S1 : SUB_GROUP_SIZE;)==""\n"
R"==(const int src_chunks_per_c_block)==""\n"
R"==(= (SRC_B1 > 1) ? (SRC_B1 / SUB_GROUP_SIZE) : 1;)==""\n"
R"==(const int dst_chunks_per_c_block)==""\n"
R"==(= (DST_B1 > 1) ? (DST_B1 / SUB_GROUP_SIZE) : 1;)==""\n"
R"==(#endif)==""\n"
R"==(const int ws_stride = dst_stride;)==""\n"
R"==(const int ws_chunks_per_c_block = dst_chunks_per_c_block;)==""\n"
R"==(VECT_FLOAT_T S0 = 0, S1 = 0;)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(VECT_FLOAT_T S[UNROLL_MB_COUNT] = {0};)==""\n"
R"==(#endif)==""\n"
R"==(for (int kd = 0; kd < KD; kd++) {)==""\n"
R"==(int od = (id + PD - kd);)==""\n"
R"==(if (od % SD != 0) continue;)==""\n"
R"==(od /= SD;)==""\n"
R"==(if (od < 0 || od >= OD) continue;)==""\n"
R"==(for (int kh = 0; kh < KH; kh++) {)==""\n"
R"==(int oh = (ih + PH - kh);)==""\n"
R"==(if (oh % SH != 0) continue;)==""\n"
R"==(oh /= SH;)==""\n"
R"==(if (oh < 0 || oh >= OH) continue;)==""\n"
R"==(for (int kw = 0; kw < KW; kw++) {)==""\n"
R"==(int ow = (iw + PW - kw);)==""\n"
R"==(if (ow % SW != 0) continue;)==""\n"
R"==(ow /= SW;)==""\n"
R"==(if (ow < 0 || ow >= OW) continue;)==""\n"
R"==(const int dst_off0 = DST_OFF(mb0, c, od, oh, ow);)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(int dst_off[UNROLL_MB_COUNT];)==""\n"
R"==(unroll_for(int i = 0; i < UNROLL_MB_COUNT; i++) {)==""\n"
R"==(dst_off[i] = DST_OFF(mb[i], c, od, oh, ow);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(VECT_FLOAT_T D0 = CONVERT_VECT_FLOAT_T()==""\n"
R"==(read_vect_c_block(0, &diff_dst[dst_off0], c, dst_stride,)==""\n"
R"==(dst_chunks_per_c_block));)==""\n"
R"==(VECT_FLOAT_T D1 = CONVERT_VECT_FLOAT_T()==""\n"
R"==(read_vect_c_block(1, &diff_dst[dst_off0], c, dst_stride,)==""\n"
R"==(dst_chunks_per_c_block));)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(VECT_FLOAT_T D[UNROLL_MB_COUNT];)==""\n"
R"==(unroll_for(int i = 0; i < UNROLL_MB_COUNT; i++) {)==""\n"
R"==(D[i] = CONVERT_VECT_FLOAT_T()==""\n"
R"==(read_vect_c_block(0, &diff_dst[dst_off[i]], c,)==""\n"
R"==(dst_stride, dst_chunks_per_c_block));)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if ALG_MAX)==""\n"
R"==(VECT_INT_T WS0 = read_vect_c_block_int()==""\n"
R"==(0, &ws[dst_off0], c, ws_stride, ws_chunks_per_c_block);)==""\n"
R"==(VECT_INT_T WS1 = read_vect_c_block_int()==""\n"
R"==(1, &ws[dst_off0], c, ws_stride, ws_chunks_per_c_block);)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(VECT_INT_T WS[UNROLL_MB_COUNT];)==""\n"
R"==(unroll_for(int i = 0; i < UNROLL_MB_COUNT; i++) {)==""\n"
R"==(WS[i] = read_vect_c_block_int(0, &ws[dst_off[i]], c,)==""\n"
R"==(ws_stride, ws_chunks_per_c_block);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(VECT_INT_T CMP0 = isnotequal()==""\n"
R"==(AS_VECT_FLOAT_T(WS0 - kd * KH * KW - kh * KW - kw),)==""\n"
R"==((VECT_FLOAT_T)0);)==""\n"
R"==(D0 = select(D0, (VECT_FLOAT_T)0, CMP0);)==""\n"
R"==(VECT_INT_T CMP1 = isnotequal()==""\n"
R"==(AS_VECT_FLOAT_T(WS1 - kd * KH * KW - kh * KW - kw),)==""\n"
R"==((VECT_FLOAT_T)0);)==""\n"
R"==(D1 = select(D1, (VECT_FLOAT_T)0, CMP1);)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(VECT_INT_T CMP[UNROLL_MB_COUNT];)==""\n"
R"==(unroll_for(int i = 0; i < UNROLL_MB_COUNT; i++) {)==""\n"
R"==(CMP[i] = isnotequal(AS_VECT_FLOAT_T(WS[i] - kd * KH * KW)==""\n"
R"==(- kh * KW - kw),)==""\n"
R"==((VECT_FLOAT_T)0);)==""\n"
R"==(D[i] = select(D[i], (VECT_FLOAT_T)0, CMP[i]);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#if ALG_AVG_NP)==""\n"
R"==(const int id_start = max(id - kd, 0);)==""\n"
R"==(const int ih_start = max(ih - kh, 0);)==""\n"
R"==(const int iw_start = max(iw - kw, 0);)==""\n"
R"==(const int id_end = min(id - kd + KD, ID);)==""\n"
R"==(const int ih_end = min(ih - kh + KH, IH);)==""\n"
R"==(const int iw_end = min(iw - kw + KW, IW);)==""\n"
R"==(const int num_summands = (ih_end - ih_start))==""\n"
R"==(* (iw_end - iw_start) * (id_end - id_start);)==""\n"
R"==(D0 /= num_summands;)==""\n"
R"==(D1 /= num_summands;)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(unroll_for(int i = 0; i < UNROLL_MB_COUNT; i++) {)==""\n"
R"==(D[i] /= num_summands;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(S0 += D0;)==""\n"
R"==(S1 += D1;)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(unroll_for(int i = 0; i < UNROLL_MB_COUNT; i++) {)==""\n"
R"==(S[i] += D[i];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if ALG_AVG_P)==""\n"
R"==(S0 /= KD * KH * KW;)==""\n"
R"==(S1 /= KD * KH * KW;)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(unroll_for(int i = 0; i < UNROLL_MB_COUNT; i++) { S[i] /= KD * KH * KW; })==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(int src_off0 = SRC_OFF(mb0, c, id, ih, iw);)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(int src_off[UNROLL_MB_COUNT];)==""\n"
R"==(unroll_for(int i = 0; i < UNROLL_MB_COUNT; i++) {)==""\n"
R"==(src_off[i] = SRC_OFF(mb[i], c, id, ih, iw);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(write_vect_c_block(0, &diff_src[src_off0], c, src_stride,)==""\n"
R"==(src_chunks_per_c_block, CONVERT_VECTOR_DATA_T(S0));)==""\n"
R"==(#if UNROLL_MB_COUNT > 1)==""\n"
R"==(unroll_for(int i = 0; i < UNROLL_MB_COUNT; i++) {)==""\n"
R"==(write_vect_c_block(0, &diff_src[src_off[i]], c, src_stride,)==""\n"
R"==(src_chunks_per_c_block, CONVERT_VECTOR_DATA_T(S[i]));)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(write_vect_c_block(1, &diff_src[src_off0], c, src_stride,)==""\n"
R"==(src_chunks_per_c_block, CONVERT_VECTOR_DATA_T(S1));)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(inline DATA_T read_c_block(const __global DATA_T *ptr, int c) {)==""\n"
R"==(#if C_W_PADDING % SUB_GROUP_SIZE != 0)==""\n"
R"==(int local_id = get_sub_group_local_id();)==""\n"
R"==(int tail = C_WO_PADDING - c;)==""\n"
R"==(return (local_id < tail) ? ptr[local_id] : 0;)==""\n"
R"==(#else)==""\n"
R"==(return AS_DATA_T(BLOCK_READ((const __global BLOCK_DATA_T *)ptr));)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#define CALC_VECT_LEN() \)==""\n"
R"==(({ \)==""\n"
R"==(int size; \)==""\n"
R"==(if (USE_ONLY_C_BLOCK == 1 \)==""\n"
R"==(&& VECT_DT_N > C_WO_PADDING / SUB_GROUP_SIZE + 1) \)==""\n"
R"==(size = C_WO_PADDING / SUB_GROUP_SIZE + 1; \)==""\n"
R"==(else \)==""\n"
R"==(size = VECT_DT_N; \)==""\n"
R"==(size; \)==""\n"
R"==(}))==""\n"
R"==(inline VECT_DATA_T read_vect_c_block(int idx, const __global DATA_T *ptr, int c,)==""\n"
R"==(int blocks_stride, int chunks_per_block) {)==""\n"
R"==(if (idx >= NVECT) return 0;)==""\n"
R"==(if ((blocks_stride == chunks_per_block * SUB_GROUP_SIZE))==""\n"
R"==(&& (C_WO_PADDING % (chunks_per_block * SUB_GROUP_SIZE) == 0)) {)==""\n"
R"==(return AS_VECT_DATA_T(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)ptr)==""\n"
R"==(+ idx * VECT_DT_N * SUB_GROUP_SIZE));)==""\n"
R"==(} else {)==""\n"
R"==(VECT_DATA_T ret;)==""\n"
R"==(for (int i = 0; i < CALC_VECT_LEN(); i++) {)==""\n"
R"==(const int offset_index = (idx * VECT_DT_N + i);)==""\n"
R"==(const int local_c_block_index = offset_index % chunks_per_block;)==""\n"
R"==(const int global_c_block_index = offset_index / chunks_per_block;)==""\n"
R"==(const int ptr_offset = local_c_block_index * SUB_GROUP_SIZE)==""\n"
R"==(+ global_c_block_index * blocks_stride;)==""\n"
R"==(const int c_off)==""\n"
R"==(= (USE_ONLY_C_BLOCK ? offset_index * SUB_GROUP_SIZE)==""\n"
R"==(: local_c_block_index * SUB_GROUP_SIZE);)==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(ret = read_c_block(ptr + ptr_offset, c + c_off);)==""\n"
R"==(#else)==""\n"
R"==(ret[i] = read_c_block(ptr + ptr_offset, c + c_off);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#if VECT_DT_N > 1)==""\n"
R"==(for (int i = CALC_VECT_LEN(); i < VECT_DT_N; ++i) {)==""\n"
R"==(ret[i] = 0;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(return ret;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(inline int read_c_block_int(const __global int *ptr, int c) {)==""\n"
R"==(#if C_W_PADDING % SUB_GROUP_SIZE != 0)==""\n"
R"==(int local_id = get_sub_group_local_id();)==""\n"
R"==(int tail = C_WO_PADDING - c;)==""\n"
R"==(return (local_id < tail) ? ptr[local_id] : 0;)==""\n"
R"==(#else)==""\n"
R"==(return as_int(intel_sub_group_block_read((const __global uint *)ptr));)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(inline VECT_INT_T read_vect_c_block_int(int idx, const __global int *ptr, int c,)==""\n"
R"==(int blocks_stride, int chunks_per_block) {)==""\n"
R"==(if (idx >= NVECT) return 0;)==""\n"
R"==(if ((blocks_stride == chunks_per_block * SUB_GROUP_SIZE))==""\n"
R"==(&& (C_WO_PADDING % (chunks_per_block * SUB_GROUP_SIZE) == 0)) {)==""\n"
R"==(return AS_VECT_INT_T(VECT_UINT_READ()==""\n"
R"==((const __global uint *)ptr + idx * VECT_DT_N * SUB_GROUP_SIZE));)==""\n"
R"==(} else {)==""\n"
R"==(VECT_INT_T ret;)==""\n"
R"==(for (int i = 0; i < VECT_DT_N; i++) {)==""\n"
R"==(const int offset_index = (idx * VECT_DT_N + i);)==""\n"
R"==(const int local_c_block_index = offset_index % chunks_per_block;)==""\n"
R"==(const int global_c_block_index = offset_index / chunks_per_block;)==""\n"
R"==(const int ptr_offset = local_c_block_index * SUB_GROUP_SIZE)==""\n"
R"==(+ global_c_block_index * blocks_stride;)==""\n"
R"==(const int c_off)==""\n"
R"==(= (USE_ONLY_C_BLOCK ? offset_index * SUB_GROUP_SIZE)==""\n"
R"==(: local_c_block_index * SUB_GROUP_SIZE);)==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(ret = read_c_block_int(ptr + ptr_offset, c + c_off);)==""\n"
R"==(#else)==""\n"
R"==(ret[i] = read_c_block_int(ptr + ptr_offset, c + c_off);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(return ret;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(inline void write_c_block(__global DATA_T *ptr, int c, DATA_T value) {)==""\n"
R"==(#if C_W_PADDING % SUB_GROUP_SIZE != 0)==""\n"
R"==(int local_id = get_sub_group_local_id();)==""\n"
R"==(int tail = C_WO_PADDING - c;)==""\n"
R"==(if (local_id < tail) ptr[local_id] = value;)==""\n"
R"==(#else)==""\n"
R"==(#if C_WO_PADDING % SUB_GROUP_SIZE != 0)==""\n"
R"==(int local_id = get_sub_group_local_id();)==""\n"
R"==(if (local_id >= C_WO_PADDING - c && local_id < C_W_PADDING - c) value = 0;)==""\n"
R"==(#endif)==""\n"
R"==(if (c >= C_WO_PADDING) {)==""\n"
R"==(BLOCK_WRITE((__global BLOCK_DATA_T *)ptr,)==""\n"
R"==(AS_BLOCK_DATA_T(CONVERT_DATA_T(DATA_ZERO)));)==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(BLOCK_WRITE((__global BLOCK_DATA_T *)ptr, AS_BLOCK_DATA_T(value));)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(inline void write_vect_c_block(int idx, __global DATA_T *ptr, int c,)==""\n"
R"==(int blocks_stride, int chunks_per_block, VECT_DATA_T block) {)==""\n"
R"==(if (idx >= NVECT) return;)==""\n"
R"==(if ((blocks_stride == chunks_per_block * SUB_GROUP_SIZE))==""\n"
R"==(&& (C_WO_PADDING % (chunks_per_block * SUB_GROUP_SIZE) == 0)) {)==""\n"
R"==(VECT_BLOCK_WRITE()==""\n"
R"==((__global BLOCK_DATA_T *)ptr + idx * VECT_DT_N * SUB_GROUP_SIZE,)==""\n"
R"==(AS_VECT_BLOCK_DATA_T(block));)==""\n"
R"==(} else {)==""\n"
R"==(for (int i = 0; i < VECT_DT_N; i++) {)==""\n"
R"==(const int offset_index = (idx * VECT_DT_N + i);)==""\n"
R"==(const int local_c_block_index = offset_index % chunks_per_block;)==""\n"
R"==(const int global_c_block_index = offset_index / chunks_per_block;)==""\n"
R"==(const int ptr_offset = local_c_block_index * SUB_GROUP_SIZE)==""\n"
R"==(+ global_c_block_index * blocks_stride;)==""\n"
R"==(const int c_off)==""\n"
R"==(= (USE_ONLY_C_BLOCK ? offset_index * SUB_GROUP_SIZE)==""\n"
R"==(: local_c_block_index * SUB_GROUP_SIZE);)==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(write_c_block(ptr + ptr_offset, c + c_off, block);)==""\n"
R"==(#else)==""\n"
R"==(write_c_block(ptr + ptr_offset, c + c_off, block[i]);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(inline void write_c_block_int(__global int *ptr, int c, int value) {)==""\n"
R"==(#if C_WO_PADDING % SUB_GROUP_SIZE != 0)==""\n"
R"==(int local_id = get_sub_group_local_id();)==""\n"
R"==(int tail = C_WO_PADDING - c;)==""\n"
R"==(if (local_id < tail))==""\n"
R"==(ptr[local_id] = value;)==""\n"
R"==(else if (local_id < C_W_PADDING - c) {)==""\n"
R"==(ptr[local_id] = 0;)==""\n"
R"==(} else)==""\n"
R"==(return;)==""\n"
R"==(#else)==""\n"
R"==(if (c >= C_WO_PADDING) {)==""\n"
R"==(intel_sub_group_block_write((__global uint *)ptr, 0);)==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(intel_sub_group_block_write((__global uint *)ptr, as_uint(value));)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(inline void write_vect_c_block_int(int idx, __global int *ptr, int c,)==""\n"
R"==(int blocks_stride, int chunks_per_block, VECT_INT_T block) {)==""\n"
R"==(if (idx >= NVECT) return;)==""\n"
R"==(if ((blocks_stride == chunks_per_block * SUB_GROUP_SIZE))==""\n"
R"==(&& (C_WO_PADDING % (chunks_per_block * SUB_GROUP_SIZE) == 0)) {)==""\n"
R"==(VECT_UINT_WRITE((__global uint *)ptr + idx * VECT_DT_N * SUB_GROUP_SIZE,)==""\n"
R"==(AS_VECT_UINT_T(block));)==""\n"
R"==(} else {)==""\n"
R"==(for (int i = 0; i < VECT_DT_N; i++) {)==""\n"
R"==(const int offset_index = (idx * VECT_DT_N + i);)==""\n"
R"==(const int local_c_block_index = offset_index % chunks_per_block;)==""\n"
R"==(const int global_c_block_index = offset_index / chunks_per_block;)==""\n"
R"==(const int ptr_offset = local_c_block_index * SUB_GROUP_SIZE)==""\n"
R"==(+ global_c_block_index * blocks_stride;)==""\n"
R"==(const int c_off)==""\n"
R"==(= (USE_ONLY_C_BLOCK ? offset_index * SUB_GROUP_SIZE)==""\n"
R"==(: local_c_block_index * SUB_GROUP_SIZE);)==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(write_c_block_int(ptr + ptr_offset, c + c_off, block);)==""\n"
R"==(#else)==""\n"
R"==(write_c_block_int(ptr + ptr_offset, c + c_off, block[i]);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}