namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gen9_sum_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#if DST_DT_S8)==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_U8)==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_uchar8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_BF8)==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_HF8)==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_F16)==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_half8(intel_sub_group_block_read_us8((const __global ushort *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us8((__global ushort *)(dst), as_ushort8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_S32)==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_int8(intel_sub_group_block_read8((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write8((__global uint *)(dst), as_uint8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_F32)==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_float8(intel_sub_group_block_read8((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write8((__global uint *)(dst), as_uint8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_BF16)==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_ushort8(intel_sub_group_block_read_us8((const __global ushort *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us8((__global ushort *)(dst), as_ushort8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(float8 get_values(__global SRC_DATA_T *src, ptrdiff_t offset) {)==""\n"
R"==(float8 val;)==""\n"
R"==(const uint max_sub_group_size = get_max_sub_group_size();)==""\n"
R"==(__global BLOCK_DATA_T *read_pos = (__global BLOCK_DATA_T *)src + offset;)==""\n"
R"==(if (offset + VECT_DT_N * max_sub_group_size < N_ELEMS) {)==""\n"
R"==(val = CONVERT_FLOAT8_T(AS_DATA8_T(BLOCK_READ8(read_pos)));)==""\n"
R"==(} else {)==""\n"
R"==(const uint sub_group_local_id = get_sub_group_local_id();)==""\n"
R"==(uint pos = offset + sub_group_local_id;)==""\n"
R"==(for (uint i = 0; pos < N_ELEMS && i < VECT_DT_N; i++) {)==""\n"
R"==(val[i] = CONVERT_FLOAT_T(src[pos]);)==""\n"
R"==(pos += max_sub_group_size;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(return val;)==""\n"
R"==(})==""\n"
R"==(__kernel void gen9_sum(__global SRC_DATA_T *input0, __global SRC_DATA_T *input1,)==""\n"
R"==(__global SRC_DATA_T *input2, __global SRC_DATA_T *input3,)==""\n"
R"==(__global SRC_DATA_T *input4, __global SRC_DATA_T *input5,)==""\n"
R"==(__global SRC_DATA_T *input6, __global SRC_DATA_T *input7,)==""\n"
R"==(__global SRC_DATA_T *input8, __global SRC_DATA_T *input9,)==""\n"
R"==(__global SRC_DATA_T *input10, __global SRC_DATA_T *input11,)==""\n"
R"==(__global SRC_DATA_T *input12, __global SRC_DATA_T *input13,)==""\n"
R"==(__global SRC_DATA_T *input14, __global SRC_DATA_T *input15,)==""\n"
R"==(__global DST_DATA_T *output, __global float *scales) {)==""\n"
R"==(const uint group_id = get_group_id(0);)==""\n"
R"==(const uint group_size = get_local_size(0);)==""\n"
R"==(const uint sub_group_id = get_sub_group_id();)==""\n"
R"==(const uint max_sub_group_size = get_max_sub_group_size();)==""\n"
R"==(const uint sub_group_local_id = get_sub_group_local_id();)==""\n"
R"==(ptrdiff_t offset)==""\n"
R"==(= (group_id * group_size + sub_group_id * max_sub_group_size))==""\n"
R"==(* VECT_DT_N;)==""\n"
R"==(__global BLOCK_DATA_T *write_pos = (__global BLOCK_DATA_T *)output + offset;)==""\n"
R"==(int id = 0;)==""\n"
R"==(float8 sum = 0;)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input0, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input1, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input2, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input3, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input4, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input5, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input6, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input7, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input8, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input9, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input10, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input11, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input12, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input13, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input14, offset) * scales[id++];)==""\n"
R"==(if (id < N_INPUTS) sum += get_values(input15, offset) * scales[id++];)==""\n"
R"==(if (offset + VECT_DT_N * max_sub_group_size < N_ELEMS) {)==""\n"
R"==(DST_BLOCK_WRITE8(write_pos, TO_DST8(sum));)==""\n"
R"==(} else {)==""\n"
R"==(uint pos = offset + sub_group_local_id;)==""\n"
R"==(for (uint i = 0; pos < N_ELEMS && i < VECT_DT_N; i++) {)==""\n"
R"==(output[pos] = TO_DST(sum[i]);)==""\n"
R"==(pos += max_sub_group_size;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}