namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gen9_wino_conv_fwd_data_2x3_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#define BLOCK_SIZE OC_BLOCK)==""\n"
R"==(#define BLOCKED_DATA_T CONCAT2(DATA_T, BLOCK_SIZE))==""\n"
R"==(#define BLOCKED_READ(ptr) vload16(0, ptr))==""\n"
R"==(#define BLOCKED_WRITE(data, ptr) \)==""\n"
R"==(do { \)==""\n"
R"==(BLOCKED_DATA_T result = data; \)==""\n"
R"==(unroll_for(int _i = 0; _i < BLOCK_SIZE; _i++) { \)==""\n"
R"==((ptr)[_i] = result[_i]; \)==""\n"
R"==(} \)==""\n"
R"==(} while (0))==""\n"
R"==(#define VECT_SIZE 4)==""\n"
R"==(#define VECT_DATA_T CONCAT2(DATA_T, VECT_SIZE))==""\n"
R"==(#define AS_VECT_DATA_T AS_DATA4_T)==""\n"
R"==(#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA4_T)==""\n"
R"==(#define OC_OUTER_BLOCK OC_BLOCK)==""\n"
R"==(#define IC_OUTER_BLOCK IC_BLOCK)==""\n"
R"==(#define WINO_D (WINO_M + WINO_R - 1))==""\n"
R"==(#define VW WINO_IW)==""\n"
R"==(#define VH WINO_IH)==""\n"
R"==(#define VC WINO_IC)==""\n"
R"==(#define MW WINO_OW)==""\n"
R"==(#define MH WINO_OH)==""\n"
R"==(#define MC WINO_OC)==""\n"
R"==(static inline int off_nCdhw16c()==""\n"
R"==(int n, int c, int d, int h, int w, int C, int D, int H, int W) {)==""\n"
R"==(int off = 0;)==""\n"
R"==(off += n * (C / 16) * D * H * W * 16;)==""\n"
R"==(off += (c / 16) * D * H * W * 16;)==""\n"
R"==(off += d * H * W * 16;)==""\n"
R"==(off += h * W * 16;)==""\n"
R"==(off += w * 16;)==""\n"
R"==(off += c % 16;)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(static inline int off_NCdhw16n16c()==""\n"
R"==(int n, int c, int d, int h, int w, int C, int D, int H, int W) {)==""\n"
R"==(int off = 0;)==""\n"
R"==(off += (n / 16) * (C / 16) * D * H * W * 16 * 16;)==""\n"
R"==(off += (c / 16) * D * H * W * 16 * 16;)==""\n"
R"==(off += d * H * W * 16 * 16;)==""\n"
R"==(off += h * W * 16 * 16;)==""\n"
R"==(off += w * 16 * 16;)==""\n"
R"==(off += (n % 16) * 16;)==""\n"
R"==(off += (c % 16);)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(static inline int off_gIOdhw16i16o(int g, int o, int i, int d, int h, int w,)==""\n"
R"==(int O, int I, int D, int H, int W) {)==""\n"
R"==(int off = 0;)==""\n"
R"==(off += g * (I / 16) * (O / 16) * D * H * W * 16 * 16;)==""\n"
R"==(off += (i / 16) * (O / 16) * D * H * W * 16 * 16;)==""\n"
R"==(off += (o / 16) * D * H * W * 16 * 16;)==""\n"
R"==(off += d * H * W * 16 * 16;)==""\n"
R"==(off += h * W * 16 * 16;)==""\n"
R"==(off += w * 16 * 16;)==""\n"
R"==(off += (i % 16) * 16;)==""\n"
R"==(off += (o % 16);)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(static inline int src_off(int n, int c, int d, int h, int w) {)==""\n"
R"==(if (SRC_W16C) return off_nCdhw16c(n, c, d, h, w, G * IC, 1, IH, IW);)==""\n"
R"==(if (SRC_16N16C) return off_NCdhw16n16c(n, c, d, h, w, G * IC, 1, IH, IW);)==""\n"
R"==(return 0;)==""\n"
R"==(})==""\n"
R"==(static inline int wei_off(int g, int o, int i, int d, int h, int w) {)==""\n"
R"==(return off_gIOdhw16i16o(g, o, i, d, h, w, OC, IC, 1, KH, KW);)==""\n"
R"==(})==""\n"
R"==(static inline int U_off(int o, int i, int h, int z) {)==""\n"
R"==(int off = z * KH * WINO_IC * WINO_OC;)==""\n"
R"==(off += h * WINO_IC * WINO_OC;)==""\n"
R"==(off += i * WINO_OC;)==""\n"
R"==(off += o;)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(static inline int V_off(int n, int i, int h, int w, int z) {)==""\n"
R"==(int off = n * WINO_D * VW * VH * VC;)==""\n"
R"==(off += z * VW * VH * VC;)==""\n"
R"==(off += w * VH * VC;)==""\n"
R"==(off += (h + PH) * VC;)==""\n"
R"==(off += i;)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(static inline int M_off(int n, int o, int h, int w, int z) {)==""\n"
R"==(int off = n * WINO_D * MW * MH * MC;)==""\n"
R"==(off += z * MW * MH * MC;)==""\n"
R"==(off += w * MH * MC;)==""\n"
R"==(off += h * MC;)==""\n"
R"==(off += o;)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(static inline int dst_off(int n, int c, int d, int h, int w) {)==""\n"
R"==(if (DST_W16C) return off_nCdhw16c(n, c, d, h, w, G * OC, 1, OH, OW);)==""\n"
R"==(if (DST_16N16C) return off_NCdhw16n16c(n, c, d, h, w, G * OC, 1, OH, OW);)==""\n"
R"==(return 0;)==""\n"
R"==(})==""\n"
R"==(__kernel void gen9_wino_wei_transform_2x3()==""\n"
R"==(__global DATA_T *U, const __global DATA_T *weights) {)==""\n"
R"==(const uint weights_tile_width = WINO_M;)==""\n"
R"==(const uint weights_tile_height = 1;)==""\n"
R"==(const uint in_kw = get_global_id(0) * weights_tile_width;)==""\n"
R"==(const uint in_kh = get_global_id(1) * weights_tile_height;)==""\n"
R"==(const uint U_tile_width = WINO_D;)==""\n"
R"==(const uint U_tile_height = 1;)==""\n"
R"==(const uint out_kw = get_global_id(0) * U_tile_width;)==""\n"
R"==(const uint out_kh = get_global_id(1) * U_tile_height;)==""\n"
R"==(const uint ic = get_global_id(2) % WINO_IC;)==""\n"
R"==(const uint oc = get_global_id(2) / WINO_IC;)==""\n"
R"==(uint in_idx = wei_off(0, oc, ic, 0, in_kh, in_kw);)==""\n"
R"==(bool is_valid = ic < IC || oc < OC;)==""\n"
R"==(VECT_DATA_T tile;)==""\n"
R"==(tile.x = is_valid ? weights[in_idx] : 0;)==""\n"
R"==(in_idx += wei_off(0, 0, 0, 0, 0, 1);)==""\n"
R"==(tile.y = is_valid ? weights[in_idx] : 0;)==""\n"
R"==(in_idx += wei_off(0, 0, 0, 0, 0, 1);)==""\n"
R"==(tile.z = is_valid ? weights[in_idx] : 0;)==""\n"
R"==(uint out_idx = U_off(oc, ic, out_kh, out_kw);)==""\n"
R"==(U[out_idx] = tile.x;)==""\n"
R"==(out_idx += U_off(0, 0, 0, 1);)==""\n"
R"==(U[out_idx] = (tile.x + tile.y + tile.z) / 2;)==""\n"
R"==(out_idx += U_off(0, 0, 0, 1);)==""\n"
R"==(U[out_idx] = (tile.x - tile.y + tile.z) / 2;)==""\n"
R"==(out_idx += U_off(0, 0, 0, 1);)==""\n"
R"==(U[out_idx] = tile.z;)==""\n"
R"==(})==""\n"
R"==(__kernel void gen9_wino_src_transform_2x3()==""\n"
R"==(__global DATA_T *V, const __global DATA_T *src) {)==""\n"
R"==(const uint tile_id_x = get_global_id(0);)==""\n"
R"==(const uint tile_id_y = get_global_id(1);)==""\n"
R"==(const uint stride_x = WINO_M;)==""\n"
R"==(const uint stride_y = 1;)==""\n"
R"==(const uint iw = tile_id_x * stride_x - PW;)==""\n"
R"==(const uint ih = tile_id_y * stride_y - PH;)==""\n"
R"==(const uint ic = (get_global_id(2) % (WINO_IC / IC_BLOCK)) * IC_BLOCK;)==""\n"
R"==(const uint n = get_global_id(2) / (WINO_IC / IC_BLOCK);)==""\n"
R"==(const bool w0 = iw < 0 || iw >= IW;)==""\n"
R"==(const bool w1 = iw + 1 < 0 || iw + 1 >= IW;)==""\n"
R"==(const bool w2 = iw + 2 < 0 || iw + 2 >= IW;)==""\n"
R"==(const bool w3 = iw + 3 < 0 || iw + 3 >= IW;)==""\n"
R"==(const bool h0 = ih < 0 || ih >= IH || ic > IC;)==""\n"
R"==(BLOCKED_DATA_T d0, d1, d2, d3;)==""\n"
R"==(int in_idx = src_off(n, ic, 0, ih, iw);)==""\n"
R"==(d0 = (h0 || w0) ? 0 : BLOCKED_READ(&src[in_idx]);)==""\n"
R"==(in_idx += src_off(0, 0, 0, 0, 1);)==""\n"
R"==(d1 = (h0 || w1) ? 0 : BLOCKED_READ(&src[in_idx]);)==""\n"
R"==(in_idx += src_off(0, 0, 0, 0, 1);)==""\n"
R"==(d2 = (h0 || w2) ? 0 : BLOCKED_READ(&src[in_idx]);)==""\n"
R"==(in_idx += src_off(0, 0, 0, 0, 1);)==""\n"
R"==(d3 = (h0 || w3) ? 0 : BLOCKED_READ(&src[in_idx]);)==""\n"
R"==(int out_idx = V_off(n, ic, ih, tile_id_x, 0);)==""\n"
R"==(BLOCKED_WRITE(d0 - d2, &V[out_idx]);)==""\n"
R"==(out_idx += V_off(0, 0, -PH, 0, 1);)==""\n"
R"==(BLOCKED_WRITE(d1 + d2, &V[out_idx]);)==""\n"
R"==(out_idx += V_off(0, 0, -PH, 0, 1);)==""\n"
R"==(BLOCKED_WRITE(-d1 + d2, &V[out_idx]);)==""\n"
R"==(out_idx += V_off(0, 0, -PH, 0, 1);)==""\n"
R"==(BLOCKED_WRITE(d1 - d3, &V[out_idx]);)==""\n"
R"==(})==""\n"
R"==(__kernel void gen9_wino_dst_transform_2x3(__global DATA_T *dst,)==""\n"
R"==(const __global DATA_T *M, const __global DATA_T *bias POST_OP_ARGS) {)==""\n"
R"==(const uint tile_id_x = get_global_id(0);)==""\n"
R"==(const uint tile_id_y = get_global_id(1);)==""\n"
R"==(const uint dst_tile_width_x = WINO_M;)==""\n"
R"==(const uint dst_tile_width_y = 1;)==""\n"
R"==(const uint ow = tile_id_x * dst_tile_width_x;)==""\n"
R"==(const uint oh = tile_id_y * dst_tile_width_y;)==""\n"
R"==(const uint oc = (get_global_id(2) % (OC / OC_BLOCK)) * OC_BLOCK;)==""\n"
R"==(const uint n = get_global_id(2) / (OC / OC_BLOCK);)==""\n"
R"==(BLOCKED_DATA_T m0, m1, m2, m3;)==""\n"
R"==(int M_idx = M_off(n, oc, tile_id_y, tile_id_x, 0);)==""\n"
R"==(m0 = BLOCKED_READ(&M[M_idx]);)==""\n"
R"==(M_idx += M_off(0, 0, 0, 0, 1);)==""\n"
R"==(m1 = BLOCKED_READ(&M[M_idx]);)==""\n"
R"==(M_idx += M_off(0, 0, 0, 0, 1);)==""\n"
R"==(m2 = BLOCKED_READ(&M[M_idx]);)==""\n"
R"==(M_idx += M_off(0, 0, 0, 0, 1);)==""\n"
R"==(m3 = BLOCKED_READ(&M[M_idx]);)==""\n"
R"==(BLOCKED_DATA_T C1 = m0 + m1 + m2;)==""\n"
R"==(BLOCKED_DATA_T C2 = m1 - m2 - m3;)==""\n"
R"==(if (WITH_BIAS || WITH_POST_OP) {)==""\n"
R"==(const int c_size = WINO_M * OC_BLOCK;)==""\n"
R"==(DATA_T C[c_size];)==""\n"
R"==(BLOCKED_WRITE(C1, &C[0]);)==""\n"
R"==(BLOCKED_WRITE(C2, &C[OC_BLOCK]);)==""\n"
R"==(if (WITH_BIAS) {)==""\n"
R"==(for (int oc_outer = 0; oc_outer < OC_BLOCK; oc_outer++) {)==""\n"
R"==(for (int ow_block = 0; ow_block < WINO_M; ow_block++) {)==""\n"
R"==(const int c_off = ow_block * OC_BLOCK + oc_outer;)==""\n"
R"==(const int bc_off = oc + oc_outer;)==""\n"
R"==(C[c_off] += (OC_WO_PADDING % OC_BLOCK == 0)==""\n"
R"==(|| bc_off < OC_WO_PADDING))==""\n"
R"==(? bias[bc_off])==""\n"
R"==(: DATA_ZERO;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(DATA_T S[c_size];)==""\n"
R"==(if (WITH_SUM) {)==""\n"
R"==(BLOCKED_DATA_T S1, S2;)==""\n"
R"==(int dst_idx = dst_off(n, oc, 0, oh, ow);)==""\n"
R"==(S1 = BLOCKED_READ(&dst[dst_idx]);)==""\n"
R"==(if (OW % WINO_M == 0 || ow < OW - 1) {)==""\n"
R"==(dst_idx += dst_off(0, 0, 0, 0, 1);)==""\n"
R"==(S2 = BLOCKED_READ(&dst[dst_idx]);)==""\n"
R"==(} else {)==""\n"
R"==(S2 = 0;)==""\n"
R"==(})==""\n"
R"==(BLOCKED_WRITE(S1, &S[0]);)==""\n"
R"==(BLOCKED_WRITE(S2, &S[OC_BLOCK]);)==""\n"
R"==(})==""\n"
R"==(for (int didx = 0; didx < c_size; ++didx) {)==""\n"
R"==(float accum = CONVERT_FLOAT_T(C[didx]);)==""\n"
R"==(float sum = CONVERT_FLOAT_T(S[didx]);)==""\n"
R"==(int po_oc = oc + c_size % OC_BLOCK;)==""\n"
R"==(APPLY_POST_OPS_SERIAL_BINARY_2D()==""\n"
R"==(C, DATA_T, S, DATA_T, n, 1, po_oc, 1);)==""\n"
R"==(C[didx] = TO_DATA_T(accum);)==""\n"
R"==(})==""\n"
R"==(C1 = BLOCKED_READ(&C[0]);)==""\n"
R"==(C2 = BLOCKED_READ(&C[OC_BLOCK]);)==""\n"
R"==(})==""\n"
R"==(int dst_idx = dst_off(n, oc, 0, oh, ow);)==""\n"
R"==(BLOCKED_WRITE(C1, &dst[dst_idx]);)==""\n"
R"==(if (OW % WINO_M == 0 || ow < OW - 1) {)==""\n"
R"==(dst_idx += dst_off(0, 0, 0, 0, 1);)==""\n"
R"==(BLOCKED_WRITE(C2, &dst[dst_idx]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(__attribute__((reqd_work_group_size(8, 1, 1))) __kernel void)==""\n"
R"==(gen9_wino_conv_fwd_2x3(__global DATA_T *M, const __global DATA_T *V,)==""\n"
R"==(const __global DATA_T *U_param) {)==""\n"
R"==(const int VH_SIZE_VECT = V_off(0, 0, 1 - PH, 0, 0) / VECT_SIZE;)==""\n"
R"==(const int MH_SIZE_VECT = M_off(0, 0, 1, 0, 0) / VECT_SIZE;)==""\n"
R"==(const int U_IC_SIZE_VECT = U_off(0, 1, 0, 0) / VECT_SIZE;)==""\n"
R"==(const int group_x = get_group_id(0);)==""\n"
R"==(const int group_y = get_group_id(1);)==""\n"
R"==(const int group_z = get_group_id(2);)==""\n"
R"==(const int local_x = get_local_id(0);)==""\n"
R"==(const int local_y = get_local_id(1);)==""\n"
R"==(const int local_z = get_local_id(2);)==""\n"
R"==(const int no_of_tiles_x = MW;)==""\n"
R"==(const int no_of_tiles_y = MH;)==""\n"
R"==(const int ow = (group_y * OH_BLOCK) / no_of_tiles_y;)==""\n"
R"==(const int oh = (group_y * OH_BLOCK) % no_of_tiles_y;)==""\n"
R"==(const int oc = group_x * WINO_OC_BLOCK)==""\n"
R"==(+ local_x * VECT_SIZE; )==""\n"
R"==(const int n = group_z / WINO_D;)==""\n"
R"==(const int tile_w_offset = group_z % WINO_D;)==""\n"
R"==(const int ih = oh - PH;)==""\n"
R"==(const int iw = ow;)==""\n"
R"==(const int ic = local_x * VECT_SIZE; )==""\n"
R"==(VECT_DATA_T M0 = (VECT_DATA_T)(0.f);)==""\n"
R"==(VECT_DATA_T M1 = (VECT_DATA_T)(0.f);)==""\n"
R"==(VECT_DATA_T M2 = (VECT_DATA_T)(0.f);)==""\n"
R"==(VECT_DATA_T M3 = (VECT_DATA_T)(0.f);)==""\n"
R"==(VECT_DATA_T M4 = (VECT_DATA_T)(0.f);)==""\n"
R"==(VECT_DATA_T M5 = (VECT_DATA_T)(0.f);)==""\n"
R"==(VECT_DATA_T M6 = (VECT_DATA_T)(0.f);)==""\n"
R"==(VECT_DATA_T M7 = (VECT_DATA_T)(0.f);)==""\n"
R"==(const int M_idx = M_off(n, oc, oh, ow, tile_w_offset);)==""\n"
R"==(__global VECT_DATA_T *dst = (__global VECT_DATA_T *)(M + M_idx);)==""\n"
R"==(const int V_idx = V_off(n, ic, ih, iw, tile_w_offset);)==""\n"
R"==(const __global VECT_DATA_T *V_tile = (__global VECT_DATA_T *)(V + V_idx);)==""\n"
R"==(const int U_idx = U_off(oc, 0, 0, tile_w_offset);)==""\n"
R"==(const __global VECT_DATA_T *U_tile)==""\n"
R"==(= (__global VECT_DATA_T *)(U_param + U_idx);)==""\n"
R"==(VECT_DATA_T a;)==""\n"
R"==(for_(int kh = 0; kh < KH; kh++))==""\n"
R"==(for (int ic_idx = 0; ic_idx < WINO_IC; ic_idx += WINO_IC_BLOCK) {)==""\n"
R"==(const VECT_DATA_T V0 = V_tile[0 * VH_SIZE_VECT];)==""\n"
R"==(const VECT_DATA_T V1 = V_tile[1 * VH_SIZE_VECT];)==""\n"
R"==(const VECT_DATA_T V2 = V_tile[2 * VH_SIZE_VECT];)==""\n"
R"==(const VECT_DATA_T V3 = V_tile[3 * VH_SIZE_VECT];)==""\n"
R"==(const VECT_DATA_T V4 = V_tile[4 * VH_SIZE_VECT];)==""\n"
R"==(const VECT_DATA_T V5 = V_tile[5 * VH_SIZE_VECT];)==""\n"
R"==(const VECT_DATA_T V6 = V_tile[6 * VH_SIZE_VECT];)==""\n"
R"==(const VECT_DATA_T V7 = V_tile[7 * VH_SIZE_VECT];)==""\n"
R"==(#define DOT_PRODUCT(_i, _j) \)==""\n"
R"==(do { \)==""\n"
R"==(a = AS_VECT_DATA_T( \)==""\n"
R"==(intel_sub_group_shuffle(AS_VECT_BLOCK_DATA_T(V##_i), _j)); \)==""\n"
R"==(M##_i = mad(a.x, U0, mad(a.y, U1, mad(a.z, U2, mad(a.w, U3, M##_i)))); \)==""\n"
R"==(} while (0))==""\n"
R"==(unroll_for(int j = 0; j < WINO_IC_BLOCK / VECT_SIZE; j++) {)==""\n"
R"==(const VECT_DATA_T U0 = U_tile[0];)==""\n"
R"==(U_tile += U_IC_SIZE_VECT;)==""\n"
R"==(const VECT_DATA_T U1 = U_tile[0];)==""\n"
R"==(U_tile += U_IC_SIZE_VECT;)==""\n"
R"==(const VECT_DATA_T U2 = U_tile[0];)==""\n"
R"==(U_tile += U_IC_SIZE_VECT;)==""\n"
R"==(const VECT_DATA_T U3 = U_tile[0];)==""\n"
R"==(U_tile += U_IC_SIZE_VECT;)==""\n"
R"==(DOT_PRODUCT(0, j);)==""\n"
R"==(DOT_PRODUCT(1, j);)==""\n"
R"==(DOT_PRODUCT(2, j);)==""\n"
R"==(DOT_PRODUCT(3, j);)==""\n"
R"==(DOT_PRODUCT(4, j);)==""\n"
R"==(DOT_PRODUCT(5, j);)==""\n"
R"==(DOT_PRODUCT(6, j);)==""\n"
R"==(DOT_PRODUCT(7, j);)==""\n"
R"==(})==""\n"
R"==(#undef DOT_PRODUCT)==""\n"
R"==(V_tile += WINO_IC_BLOCK / VECT_SIZE;)==""\n"
R"==(})==""\n"
R"==(dst[0] = M0;)==""\n"
R"==(dst += MH_SIZE_VECT;)==""\n"
R"==(dst[0] = M1;)==""\n"
R"==(dst += MH_SIZE_VECT;)==""\n"
R"==(dst[0] = M2;)==""\n"
R"==(dst += MH_SIZE_VECT;)==""\n"
R"==(dst[0] = M3;)==""\n"
R"==(dst += MH_SIZE_VECT;)==""\n"
R"==(dst[0] = M4;)==""\n"
R"==(dst += MH_SIZE_VECT;)==""\n"
R"==(dst[0] = M5;)==""\n"
R"==(dst += MH_SIZE_VECT;)==""\n"
R"==(dst[0] = M6;)==""\n"
R"==(dst += MH_SIZE_VECT;)==""\n"
R"==(dst[0] = M7;)==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}