namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *layer_norm_common_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#ifndef GPU_INTEL_OCL_LAYER_NORM_COMMON_H)==""\n"
R"==(#define GPU_INTEL_OCL_LAYER_NORM_COMMON_H)==""\n"
R"==(#undef SRC_OFF)==""\n"
R"==(#undef DST_OFF)==""\n"
R"==(#define SRC_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(SRC, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#define DST_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(DST, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#define STAT_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(STAT, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#if SRC_DT_F64 || DST_DT_F64)==""\n"
R"==(#define ACC_DATA_T double)==""\n"
R"==(#else)==""\n"
R"==(#define ACC_DATA_T float)==""\n"
R"==(#endif)==""\n"
R"==(#if IS_BWD)==""\n"
R"==(#if USE_SCALE || USE_SHIFT)==""\n"
R"==(#if VECTORIZE_BWD_SCALESHIFT)==""\n"
R"==(#if VECTOR_SIZE_SCALESHIFT == 1)==""\n"
R"==(#define VECTORIZED_VERSION(x) x)==""\n"
R"==(#define vector_load(x) (x))==""\n"
R"==(#else)==""\n"
R"==(#define VECTORIZED_VERSION(x) CONCAT2(x, VECTOR_SIZE_SCALESHIFT))==""\n"
R"==(#define vector_load(x) CONCAT2(vload, VECTOR_SIZE_SCALESHIFT)(0, &x))==""\n"
R"==(#endif)==""\n"
R"==(#if DT_BF16 == 1)==""\n"
R"==(#define convert_vector_to_float cvt_bf16_to_f32)==""\n"
R"==(#else)==""\n"
R"==(#define convert_vector_to_float VECTORIZED_VERSION(convert_float))==""\n"
R"==(#endif)==""\n"
R"==(#if SRC_DT_BF16 == 1)==""\n"
R"==(#define convert_vector_src_to_float cvt_bf16_to_f32)==""\n"
R"==(#else)==""\n"
R"==(#define convert_vector_src_to_float VECTORIZED_VERSION(convert_float))==""\n"
R"==(#endif)==""\n"
R"==(#if defined(SRC_DT_F64))==""\n"
R"==(#define SRC_BLOCK_DATA_T ulong)==""\n"
R"==(#elif defined(SRC_DT_F32))==""\n"
R"==(#define SRC_BLOCK_DATA_T uint)==""\n"
R"==(#elif defined(SRC_DT_F16) || defined(SRC_DT_BF16))==""\n"
R"==(#define SRC_BLOCK_DATA_T ushort)==""\n"
R"==(#elif defined(SRC_DT_U8) || defined(SRC_DT_S8))==""\n"
R"==(#define SRC_BLOCK_DATA_T uchar)==""\n"
R"==(#else)==""\n"
R"==(#error "Unexpected SRC data type")==""\n"
R"==(#endif)==""\n"
R"==(#define as_vector_data_t VECTORIZED_VERSION(AS_DATA_T))==""\n"
R"==(#define as_vector_src_data_t VECTORIZED_VERSION(AS_SRC_DATA_T))==""\n"
R"==(#define sub_group_read VECTORIZED_VERSION(BLOCK_READ))==""\n"
R"==(#define vector_float VECTORIZED_VERSION(float))==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}