namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ocl_generic_vector_ops_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_GENERIC_VECTOR_OPS_H)==""\n"
R"==(#define GPU_INTEL_OCL_GENERIC_VECTOR_OPS_H)==""\n"
R"==(typedef half __attribute__((ext_vector_type(1))) half1;)==""\n"
R"==(typedef uint __attribute__((ext_vector_type(1))) uint1;)==""\n"
R"==(typedef float __attribute__((ext_vector_type(1))) float1;)==""\n"
R"==(float1 __attribute__((overloadable)) vmad(float1 a, float1 b, float1 c) {)==""\n"
R"==(c[0] = mad(a[0], b[0], c[0]);)==""\n"
R"==(return c;)==""\n"
R"==(})==""\n"
R"==(float2 __attribute__((overloadable)) vmad(float2 a, float2 b, float2 c) {)==""\n"
R"==(return mad(a, b, c);)==""\n"
R"==(})==""\n"
R"==(float4 __attribute__((overloadable)) vmad(float4 a, float4 b, float4 c) {)==""\n"
R"==(return mad(a, b, c);)==""\n"
R"==(})==""\n"
R"==(float8 __attribute__((overloadable)) vmad(float8 a, float8 b, float8 c) {)==""\n"
R"==(return mad(a, b, c);)==""\n"
R"==(})==""\n"
R"==(float16 __attribute__((overloadable)) vmad(float16 a, float16 b, float16 c) {)==""\n"
R"==(return mad(a, b, c);)==""\n"
R"==(})==""\n"
R"==(float1 __attribute__((overloadable)) native_vrecip(float1 x) {)==""\n"
R"==(x[0] = native_recip(x[0]);)==""\n"
R"==(return x;)==""\n"
R"==(})==""\n"
R"==(float2 __attribute__((overloadable)) native_vrecip(float2 x) {)==""\n"
R"==(return native_recip(x);)==""\n"
R"==(})==""\n"
R"==(float4 __attribute__((overloadable)) native_vrecip(float4 x) {)==""\n"
R"==(return native_recip(x);)==""\n"
R"==(})==""\n"
R"==(float8 __attribute__((overloadable)) native_vrecip(float8 x) {)==""\n"
R"==(return native_recip(x);)==""\n"
R"==(})==""\n"
R"==(float16 __attribute__((overloadable)) native_vrecip(float16 x) {)==""\n"
R"==(return native_recip(x);)==""\n"
R"==(})==""\n"
R"==(float1 __attribute__((overloadable)) native_vexp2(float1 x) {)==""\n"
R"==(x[0] = native_exp2(x[0]);)==""\n"
R"==(return x;)==""\n"
R"==(})==""\n"
R"==(float2 __attribute__((overloadable)) native_vexp2(float2 x) {)==""\n"
R"==(return native_exp2(x);)==""\n"
R"==(})==""\n"
R"==(float4 __attribute__((overloadable)) native_vexp2(float4 x) {)==""\n"
R"==(return native_exp2(x);)==""\n"
R"==(})==""\n"
R"==(float8 __attribute__((overloadable)) native_vexp2(float8 x) {)==""\n"
R"==(return native_exp2(x);)==""\n"
R"==(})==""\n"
R"==(float16 __attribute__((overloadable)) native_vexp2(float16 x) {)==""\n"
R"==(return native_exp2(x);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}