namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ocl_math_utils_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_OCL_MATH_UTILS_H)==""\n"
R"==(#define GPU_INTEL_OCL_OCL_MATH_UTILS_H)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_utils.h")==""\n"
R"==(#pragma clang diagnostic ignored "-Wconstant-logical-operand")==""\n"
R"==(int div_up(int a, unsigned int b) {)==""\n"
R"==(return (a + b - 1) / b;)==""\n"
R"==(})==""\n"
R"==(int rnd_up(int a, unsigned int b) {)==""\n"
R"==(return div_up(a, b) * b;)==""\n"
R"==(})==""\n"
R"==(int rnd_down(int a, unsigned int b) {)==""\n"
R"==(return (a / b) * b;)==""\n"
R"==(})==""\n"
R"==(#pragma OPENCL EXTENSION cl_khr_fp16 : enable)==""\n"
R"==(#if DT_BF8 || SRC_DT_BF8 || WEI_DT_BF8 || DST_DT_BF8 || BIA_DT_BF8 || A_DT_BF8 \)==""\n"
R"==(|| B_DT_BF8 || C_DT_BF8 || DATA_DT_BF8 || POST_OP_USING_BF8)==""\n"
R"==(#define MATH_UTILS_DECLARE_BF8 1)==""\n"
R"==(#endif)==""\n"
R"==(#if DT_HF8 || SRC_DT_HF8 || WEI_DT_HF8 || DST_DT_HF8 || BIA_DT_HF8 || A_DT_HF8 \)==""\n"
R"==(|| A_DT_HF8 || B_DT_HF8 || C_DT_HF8 || DATA_DT_HF8 \)==""\n"
R"==(|| POST_OP_USING_HF8)==""\n"
R"==(#define MATH_UTILS_DECLARE_HF8 1)==""\n"
R"==(#endif)==""\n"
R"==(#if DT_S4 || SRC_DT_S4 || WEI_DT_S4 || DST_DT_S4 || BIA_DT_S4 || A_DT_S4 \)==""\n"
R"==(|| B_DT_S4 || C_DT_S4 || DATA_DT_S4 || WEI_ZP_DT_S4 || SRC_ZP_DT_S4)==""\n"
R"==(#define MATH_UTILS_DECLARE_S4 1)==""\n"
R"==(#endif)==""\n"
R"==(#if DT_U4 || SRC_DT_U4 || WEI_DT_U4 || DST_DT_U4 || BIA_DT_U4 || A_DT_U4 \)==""\n"
R"==(|| A_DT_U4 || B_DT_U4 || C_DT_U4 || DATA_DT_U4 || WEI_ZP_DT_U4 \)==""\n"
R"==(|| SRC_ZP_DT_U4)==""\n"
R"==(#define MATH_UTILS_DECLARE_U4 1)==""\n"
R"==(#endif)==""\n"
R"==(#if DT_BF16 || SRC_DT_BF16 || WEI_DT_BF16 || DST_DT_BF16 || BIA_DT_BF16 \)==""\n"
R"==(|| A_DT_BF16 || B_DT_BF16 || C_DT_BF16 || SUM_DT_BF16 || DATA_DT_BF16 \)==""\n"
R"==(|| POST_OP_USING_BF16)==""\n"
R"==(#define MATH_UTILS_DECLARE_BF16 1)==""\n"
R"==(#endif)==""\n"
R"==(ulong8 __builtin_IB_simd_block_read_8_global_l(const __global ulong *);)==""\n"
R"==(ushort16 __builtin_IB_simd_block_read_16_global_h(const __global ushort *);)==""\n"
R"==(void __builtin_IB_simd_block_write_8_global_l(__global ulong *, ulong8);)==""\n"
R"==(void __builtin_IB_simd_block_write_16_global_h(__global ushort *, ushort16);)==""\n"
R"==(float __attribute__((overloadable)) cvt_e8m0_to_f32(uchar f) {)==""\n"
R"==(if (f == (uchar)0xff) return as_float(0xffc00000);)==""\n"
R"==(uint bits = f << 23;)==""\n"
R"==(return as_float(bits);)==""\n"
R"==(})==""\n"
R"==(#if MATH_UTILS_DECLARE_HF8)==""\n"
R"==(uchar __attribute__((overloadable)) cvt_hf_to_f8_e4m3(half f) {)==""\n"
R"==(uchar raw_bits = 0;)==""\n"
R"==(ushort fraw = as_ushort(f);)==""\n"
R"==(uint s8 = (fraw & 0x8000) >> 8;)==""\n"
R"==(fraw = fraw & 0x7fff;)==""\n"
R"==(if (fraw >= 0x5f40) {)==""\n"
R"==(raw_bits = s8 | 0x7f;)==""\n"
R"==(return raw_bits;)==""\n"
R"==(})==""\n"
R"==(if (fraw <= 0x1400) {)==""\n"
R"==(raw_bits = s8;)==""\n"
R"==(return raw_bits;)==""\n"
R"==(})==""\n"
R"==(ushort a = 0x7c00, b = 0x1c00;)==""\n"
R"==(ushort shifter = (fraw & a) + b;)==""\n"
R"==(const int exp_threshold = 0x4000; )==""\n"
R"==(ushort is_denorm = shifter < exp_threshold;)==""\n"
R"==(if (is_denorm) shifter = exp_threshold;)==""\n"
R"==(ushort rounded)==""\n"
R"==(= as_ushort((as_half(fraw) + as_half(shifter)) - as_half(shifter));)==""\n"
R"==(int e8 = ((rounded & 0x7c00) >> 10) - 8;)==""\n"
R"==(uchar m8 = (rounded & 0x03ff) >> 7;)==""\n"
R"==(if (is_denorm) {)==""\n"
R"==(m8 = (m8 | 0x08) >> (-e8 + 1);)==""\n"
R"==(e8 = 0;)==""\n"
R"==(})==""\n"
R"==(raw_bits = s8 | (e8 << 3) | m8;)==""\n"
R"==(return raw_bits;)==""\n"
R"==(})==""\n"
R"==(uchar2 __attribute__((overloadable)) cvt_hf_to_f8_e4m3(half2 f) {)==""\n"
R"==(uchar2 r;)==""\n"
R"==(for (int i = 0; i < 2; i++) {)==""\n"
R"==(r[i] = cvt_hf_to_f8_e4m3(f[i]);)==""\n"
R"==(})==""\n"
R"==(return r;)==""\n"
R"==(})==""\n"
R"==(uchar4 __attribute__((overloadable)) cvt_hf_to_f8_e4m3(half4 f) {)==""\n"
R"==(uchar4 r;)==""\n"
R"==(for (int i = 0; i < 4; i++) {)==""\n"
R"==(r[i] = cvt_hf_to_f8_e4m3(f[i]);)==""\n"
R"==(})==""\n"
R"==(return r;)==""\n"
R"==(})==""\n"
R"==(uchar8 __attribute__((overloadable)) cvt_hf_to_f8_e4m3(half8 f) {)==""\n"
R"==(uchar8 r;)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(r[i] = cvt_hf_to_f8_e4m3(f[i]);)==""\n"
R"==(})==""\n"
R"==(return r;)==""\n"
R"==(})==""\n"
R"==(uchar16 __attribute__((overloadable)) cvt_hf_to_f8_e4m3(half16 f) {)==""\n"
R"==(uchar16 r;)==""\n"
R"==(for (int i = 0; i < 16; i++) {)==""\n"
R"==(r[i] = cvt_hf_to_f8_e4m3(f[i]);)==""\n"
R"==(})==""\n"
R"==(return r;)==""\n"
R"==(})==""\n"
R"==(half __attribute__((overloadable)) cvt_f8_e4m3_to_hf(uchar b) {)==""\n"
R"==(uchar raw_bits_ = b;)==""\n"
R"==(ushort s8 = (raw_bits_ & 0x80) >> 7;)==""\n"
R"==(ushort e8 = (raw_bits_ & 0x78) >> 3;)==""\n"
R"==(ushort m8 = (raw_bits_ & 0x7);)==""\n"
R"==(ushort s16 = s8;)==""\n"
R"==(ushort e16 = e8 + 8; /* 15 - 7 = e16_bias - e8_bias */)==""\n"
R"==(ushort m16 = m8;)==""\n"
R"==(if (e8 == 0 && m8 != 0) {)==""\n"
R"==(ushort count = 2;)==""\n"
R"==(count = m8 > 0x1 ? 1 : count;)==""\n"
R"==(count = m8 > 0x3 ? 0 : count;)==""\n"
R"==(e16 -= count;)==""\n"
R"==(m16 = (m16 << (count + 1)) & 0x7;)==""\n"
R"==(} else if (e8 == 0 && m8 == 0) {)==""\n"
R"==(e16 = 0;)==""\n"
R"==(} else if (e8 == 0xf && m8 == 0x7) {)==""\n"
R"==(e16 = 0x1f;)==""\n"
R"==(m16 = 0x4; )==""\n"
R"==(})==""\n"
R"==(s16 <<= 15;)==""\n"
R"==(e16 <<= 10;)==""\n"
R"==(m16 <<= 7;)==""\n"
R"==(ushort u16 = s16 | e16 | m16;)==""\n"
R"==(return as_half(u16);)==""\n"
R"==(})==""\n"
R"==(half2 __attribute__((overloadable)) cvt_f8_e4m3_to_hf(uchar2 b) {)==""\n"
R"==(half2 f;)==""\n"
R"==(for (int i = 0; i < 2; i++) {)==""\n"
R"==(f[i] = cvt_f8_e4m3_to_hf(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(half4 __attribute__((overloadable)) cvt_f8_e4m3_to_hf(uchar4 b) {)==""\n"
R"==(half4 f;)==""\n"
R"==(for (int i = 0; i < 4; i++) {)==""\n"
R"==(f[i] = cvt_f8_e4m3_to_hf(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(half8 __attribute__((overloadable)) cvt_f8_e4m3_to_hf(uchar8 b) {)==""\n"
R"==(half8 f;)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(f[i] = cvt_f8_e4m3_to_hf(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(half16 __attribute__((overloadable)) cvt_f8_e4m3_to_hf(uchar16 b) {)==""\n"
R"==(half16 f;)==""\n"
R"==(for (int i = 0; i < 16; i++) {)==""\n"
R"==(f[i] = cvt_f8_e4m3_to_hf(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if MATH_UTILS_DECLARE_BF8)==""\n"
R"==(uchar __attribute__((overloadable)) cvt_hf_to_f8_e5m2(half f) {)==""\n"
R"==(ushort fraw = as_ushort(f);)==""\n"
R"==(ushort naninf_mask = 0x7c00;)==""\n"
R"==(bool is_special = (fraw & naninf_mask) == naninf_mask;)==""\n"
R"==(bool is_nan = is_special && (fraw & 0x03ff); )==""\n"
R"==(if (is_nan) { return (fraw >> 8) | 0x02; })==""\n"
R"==(if (is_special) {)==""\n"
R"==(uchar raw_bits = fraw >> 8;)==""\n"
R"==(return raw_bits;)==""\n"
R"==(})==""\n"
R"==(ushort rounding_nudge = 0x007f + ((fraw & 0x0100) >> 8);)==""\n"
R"==(fraw = fraw + rounding_nudge;)==""\n"
R"==(uchar raw_bits = fraw >> 8;)==""\n"
R"==(return raw_bits;)==""\n"
R"==(})==""\n"
R"==(uchar2 __attribute__((overloadable)) cvt_hf_to_f8_e5m2(half2 f) {)==""\n"
R"==(uchar2 r;)==""\n"
R"==(for (int i = 0; i < 2; i++) {)==""\n"
R"==(r[i] = cvt_hf_to_f8_e5m2(f[i]);)==""\n"
R"==(})==""\n"
R"==(return r;)==""\n"
R"==(})==""\n"
R"==(uchar4 __attribute__((overloadable)) cvt_hf_to_f8_e5m2(half4 f) {)==""\n"
R"==(uchar4 r;)==""\n"
R"==(for (int i = 0; i < 4; i++) {)==""\n"
R"==(r[i] = cvt_hf_to_f8_e5m2(f[i]);)==""\n"
R"==(})==""\n"
R"==(return r;)==""\n"
R"==(})==""\n"
R"==(uchar8 __attribute__((overloadable)) cvt_hf_to_f8_e5m2(half8 f) {)==""\n"
R"==(uchar8 r;)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(r[i] = cvt_hf_to_f8_e5m2(f[i]);)==""\n"
R"==(})==""\n"
R"==(return r;)==""\n"
R"==(})==""\n"
R"==(uchar16 __attribute__((overloadable)) cvt_hf_to_f8_e5m2(half16 f) {)==""\n"
R"==(uchar16 r;)==""\n"
R"==(for (int i = 0; i < 16; i++) {)==""\n"
R"==(r[i] = cvt_hf_to_f8_e5m2(f[i]);)==""\n"
R"==(})==""\n"
R"==(return r;)==""\n"
R"==(})==""\n"
R"==(half __attribute__((overloadable)) cvt_f8_e5m2_to_hf(uchar b) {)==""\n"
R"==(uchar2 iraw = {0, b};)==""\n"
R"==(return as_half(iraw);)==""\n"
R"==(})==""\n"
R"==(half2 __attribute__((overloadable)) cvt_f8_e5m2_to_hf(uchar2 b) {)==""\n"
R"==(half2 f;)==""\n"
R"==(for (int i = 0; i < 2; i++) {)==""\n"
R"==(f[i] = cvt_f8_e5m2_to_hf(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(half4 __attribute__((overloadable)) cvt_f8_e5m2_to_hf(uchar4 b) {)==""\n"
R"==(half4 f;)==""\n"
R"==(for (int i = 0; i < 4; i++) {)==""\n"
R"==(f[i] = cvt_f8_e5m2_to_hf(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(half8 __attribute__((overloadable)) cvt_f8_e5m2_to_hf(uchar8 b) {)==""\n"
R"==(half8 f;)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(f[i] = cvt_f8_e5m2_to_hf(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(half16 __attribute__((overloadable)) cvt_f8_e5m2_to_hf(uchar16 b) {)==""\n"
R"==(half16 f;)==""\n"
R"==(for (int i = 0; i < 16; i++) {)==""\n"
R"==(f[i] = cvt_f8_e5m2_to_hf(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if MATH_UTILS_DECLARE_BF16)==""\n"
R"==(#ifdef cl_future_bf16_cvt)==""\n"
R"==(short __builtin_IB_ftobf_1(float a) __attribute__((const));)==""\n"
R"==(short2 __builtin_IB_ftobf_2(float2 a) __attribute__((const));)==""\n"
R"==(short4 __builtin_IB_ftobf_4(float4 a) __attribute__((const));)==""\n"
R"==(short8 __builtin_IB_ftobf_8(float8 a) __attribute__((const));)==""\n"
R"==(short16 __builtin_IB_ftobf_16(float16 a) __attribute__((const));)==""\n"
R"==(float __builtin_IB_bftof_1(short a) __attribute__((const));)==""\n"
R"==(float2 __builtin_IB_bftof_2(short2 a) __attribute__((const));)==""\n"
R"==(float4 __builtin_IB_bftof_4(short4 a) __attribute__((const));)==""\n"
R"==(float8 __builtin_IB_bftof_8(short8 a) __attribute__((const));)==""\n"
R"==(float16 __builtin_IB_bftof_16(short16 a) __attribute__((const));)==""\n"
R"==(ushort __attribute__((overloadable)) cvt_f32_to_bf16(float a) { return as_ushort (__builtin_IB_ftobf_1 (a)); })==""\n"
R"==(ushort2 __attribute__((overloadable)) cvt_f32_to_bf16(float2 a) { return as_ushort2 (__builtin_IB_ftobf_2 (a)); })==""\n"
R"==(ushort4 __attribute__((overloadable)) cvt_f32_to_bf16(float4 a) { return as_ushort4 (__builtin_IB_ftobf_4 (a)); })==""\n"
R"==(ushort8 __attribute__((overloadable)) cvt_f32_to_bf16(float8 a) { return as_ushort8 (__builtin_IB_ftobf_8 (a)); })==""\n"
R"==(ushort16 __attribute__((overloadable)) cvt_f32_to_bf16(float16 a) { return as_ushort16(__builtin_IB_ftobf_16(a)); })==""\n"
R"==(float __attribute__((overloadable)) cvt_bf16_to_f32(ushort a) { return __builtin_IB_bftof_1 (as_short (a)); })==""\n"
R"==(float2 __attribute__((overloadable)) cvt_bf16_to_f32(ushort2 a) { return __builtin_IB_bftof_2 (as_short2 (a)); })==""\n"
R"==(float4 __attribute__((overloadable)) cvt_bf16_to_f32(ushort4 a) { return __builtin_IB_bftof_4 (as_short4 (a)); })==""\n"
R"==(float8 __attribute__((overloadable)) cvt_bf16_to_f32(ushort8 a) { return __builtin_IB_bftof_8 (as_short8 (a)); })==""\n"
R"==(float16 __attribute__((overloadable)) cvt_bf16_to_f32(ushort16 a) { return __builtin_IB_bftof_16(as_short16(a)); })==""\n"
R"==(#ifdef cl_khr_fp64)==""\n"
R"==(double __attribute__((overloadable)) cvt_bf16_to_f64(ushort a) { return convert_double(__builtin_IB_bftof_1 (as_short (a))); })==""\n"
R"==(double2 __attribute__((overloadable)) cvt_bf16_to_f64(ushort2 a) { return convert_double2(__builtin_IB_bftof_2 (as_short2 (a))); })==""\n"
R"==(double4 __attribute__((overloadable)) cvt_bf16_to_f64(ushort4 a) { return convert_double4(__builtin_IB_bftof_4 (as_short4 (a))); })==""\n"
R"==(double8 __attribute__((overloadable)) cvt_bf16_to_f64(ushort8 a) { return convert_double8(__builtin_IB_bftof_8 (as_short8 (a))); })==""\n"
R"==(double16 __attribute__((overloadable)) cvt_bf16_to_f64(ushort16 a) { return convert_double16(__builtin_IB_bftof_16(as_short16(a))); })==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(ushort __attribute__((overloadable)) cvt_f32_to_bf16(float f) {)==""\n"
R"==(uint i = as_uint(f);)==""\n"
R"==(i += 0x00007FFF + ((i & 0x10000) >> 16);)==""\n"
R"==(ushort2 r = as_ushort2(i);)==""\n"
R"==(return r[1];)==""\n"
R"==(})==""\n"
R"==(ushort2 __attribute__((overloadable)) cvt_f32_to_bf16(float2 f) {)==""\n"
R"==(ushort2 r;)==""\n"
R"==(for (int i = 0; i < 2; i++) {)==""\n"
R"==(r[i] = cvt_f32_to_bf16(f[i]);)==""\n"
R"==(})==""\n"
R"==(return r;)==""\n"
R"==(})==""\n"
R"==(ushort4 __attribute__((overloadable)) cvt_f32_to_bf16(float4 f) {)==""\n"
R"==(ushort4 r;)==""\n"
R"==(for (int i = 0; i < 4; i++) {)==""\n"
R"==(r[i] = cvt_f32_to_bf16(f[i]);)==""\n"
R"==(})==""\n"
R"==(return r;)==""\n"
R"==(})==""\n"
R"==(ushort8 __attribute__((overloadable)) cvt_f32_to_bf16(float8 f) {)==""\n"
R"==(ushort8 r;)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(r[i] = cvt_f32_to_bf16(f[i]);)==""\n"
R"==(})==""\n"
R"==(return r;)==""\n"
R"==(})==""\n"
R"==(ushort16 __attribute__((overloadable)) cvt_f32_to_bf16(float16 f) {)==""\n"
R"==(ushort16 r;)==""\n"
R"==(for (int i = 0; i < 16; i++) {)==""\n"
R"==(r[i] = cvt_f32_to_bf16(f[i]);)==""\n"
R"==(})==""\n"
R"==(return r;)==""\n"
R"==(})==""\n"
R"==(float __attribute__((overloadable)) cvt_bf16_to_f32(ushort b) {)==""\n"
R"==(ushort2 r = {0, b};)==""\n"
R"==(float f = as_float(r);)==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(float2 __attribute__((overloadable)) cvt_bf16_to_f32(ushort2 b) {)==""\n"
R"==(float2 f;)==""\n"
R"==(for (int i = 0; i < 2; i++) {)==""\n"
R"==(f[i] = cvt_bf16_to_f32(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(float4 __attribute__((overloadable)) cvt_bf16_to_f32(ushort4 b) {)==""\n"
R"==(float4 f;)==""\n"
R"==(for (int i = 0; i < 4; i++) {)==""\n"
R"==(f[i] = cvt_bf16_to_f32(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(float8 __attribute__((overloadable)) cvt_bf16_to_f32(ushort8 b) {)==""\n"
R"==(float8 f;)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(f[i] = cvt_bf16_to_f32(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(float16 __attribute__((overloadable)) cvt_bf16_to_f32(ushort16 b) {)==""\n"
R"==(float16 f;)==""\n"
R"==(for (int i = 0; i < 16; i++) {)==""\n"
R"==(f[i] = cvt_bf16_to_f32(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(#ifdef cl_khr_fp64)==""\n"
R"==(double __attribute__((overloadable)) cvt_bf16_to_f64(ushort b) {)==""\n"
R"==(ushort2 r = {0, b};)==""\n"
R"==(float f = as_float(r);)==""\n"
R"==(return convert_double(f);)==""\n"
R"==(})==""\n"
R"==(double2 __attribute__((overloadable)) cvt_bf16_to_f64(ushort2 b) {)==""\n"
R"==(double2 f;)==""\n"
R"==(for (int i = 0; i < 2; i++) {)==""\n"
R"==(f[i] = cvt_bf16_to_f64(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(double4 __attribute__((overloadable)) cvt_bf16_to_f64(ushort4 b) {)==""\n"
R"==(double4 f;)==""\n"
R"==(for (int i = 0; i < 4; i++) {)==""\n"
R"==(f[i] = cvt_bf16_to_f64(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(double8 __attribute__((overloadable)) cvt_bf16_to_f64(ushort8 b) {)==""\n"
R"==(double8 f;)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(f[i] = cvt_bf16_to_f64(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(double16 __attribute__((overloadable)) cvt_bf16_to_f64(ushort16 b) {)==""\n"
R"==(double16 f;)==""\n"
R"==(for (int i = 0; i < 16; i++) {)==""\n"
R"==(f[i] = cvt_bf16_to_f64(b[i]);)==""\n"
R"==(})==""\n"
R"==(return f;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(int __attribute__((overloadable)) idot4(char4 a, char4 b, int c) {)==""\n"
R"==(c += a[0] * b[0];)==""\n"
R"==(c += a[1] * b[1];)==""\n"
R"==(c += a[2] * b[2];)==""\n"
R"==(c += a[3] * b[3];)==""\n"
R"==(return c;)==""\n"
R"==(})==""\n"
R"==(int __attribute__((overloadable)) idot4(uchar4 a, uchar4 b, int c) {)==""\n"
R"==(c += a[0] * b[0];)==""\n"
R"==(c += a[1] * b[1];)==""\n"
R"==(c += a[2] * b[2];)==""\n"
R"==(c += a[3] * b[3];)==""\n"
R"==(return c;)==""\n"
R"==(})==""\n"
R"==(int __attribute__((overloadable)) idot4(char4 a, uchar4 b, int c) {)==""\n"
R"==(c += a[0] * b[0];)==""\n"
R"==(c += a[1] * b[1];)==""\n"
R"==(c += a[2] * b[2];)==""\n"
R"==(c += a[3] * b[3];)==""\n"
R"==(return c;)==""\n"
R"==(})==""\n"
R"==(int __attribute__((overloadable)) idot4(uchar4 a, char4 b, int c) {)==""\n"
R"==(c += a[0] * b[0];)==""\n"
R"==(c += a[1] * b[1];)==""\n"
R"==(c += a[2] * b[2];)==""\n"
R"==(c += a[3] * b[3];)==""\n"
R"==(return c;)==""\n"
R"==(})==""\n"
R"==(int __attribute__((overloadable)) idot4(int a, int b, int c) {)==""\n"
R"==(return idot4(as_char4(a), as_char4(b), c);)==""\n"
R"==(})==""\n"
R"==(int __attribute__((overloadable)) idot4(uint a, int b, int c) {)==""\n"
R"==(return idot4(as_uchar4(a), as_char4(b), c);)==""\n"
R"==(})==""\n"
R"==(float __attribute__((overloadable)) f16_dot2(int a, int b, float c) {)==""\n"
R"==(half2 _a = as_half2(a);)==""\n"
R"==(half2 _b = as_half2(b);)==""\n"
R"==(return c + _a[0] * _b[0] + _a[1] * _b[1];)==""\n"
R"==(})==""\n"
R"==(#if MATH_UTILS_DECLARE_BF16)==""\n"
R"==(float __attribute__((overloadable)) bf16_dot2(int a, int b, float c) {)==""\n"
R"==(ushort2 _a = as_ushort2(a);)==""\n"
R"==(ushort2 _b = as_ushort2(b);)==""\n"
R"==(c += cvt_bf16_to_f32(_a[0]) * cvt_bf16_to_f32(_b[0]);)==""\n"
R"==(c += cvt_bf16_to_f32(_a[1]) * cvt_bf16_to_f32(_b[1]);)==""\n"
R"==(return c;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#define DECLARE_BLOCK_READ(suffix, func, data_type, addr_space, p_type) \)==""\n"
R"==(data_type __attribute__((overloadable)) \)==""\n"
R"==(block_read##suffix(const addr_space p_type *p) { \)==""\n"
R"==(return func(p); \)==""\n"
R"==(})==""\n"
R"==(#define DECLARE_BLOCK_READ_EMU(suffix, data_type, addr_space, p_type) \)==""\n"
R"==(data_type __attribute__((overloadable)) \)==""\n"
R"==(block_read##suffix##_emu(const addr_space p_type *p) { \)==""\n"
R"==(data_type ret; \)==""\n"
R"==(uint idx = get_sub_group_local_id(); \)==""\n"
R"==(for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \)==""\n"
R"==(((p_type *)&ret)[i] = p[idx]; \)==""\n"
R"==(idx += get_max_sub_group_size(); \)==""\n"
R"==(} \)==""\n"
R"==(return ret; \)==""\n"
R"==(})==""\n"
R"==(#define DECLARE_BLOCK_WRITE(suffix, func, data_type, addr_space, p_type) \)==""\n"
R"==(void __attribute__((overloadable)) \)==""\n"
R"==(block_write##suffix(addr_space p_type *p, data_type data) { \)==""\n"
R"==(func(p, data); \)==""\n"
R"==(})==""\n"
R"==(#define DECLARE_BLOCK_WRITE_EMU(suffix, data_type, addr_space, p_type) \)==""\n"
R"==(void __attribute__((overloadable)) \)==""\n"
R"==(block_write##suffix##_emu(addr_space p_type *p, data_type data) { \)==""\n"
R"==(uint idx = get_sub_group_local_id(); \)==""\n"
R"==(for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \)==""\n"
R"==(p[idx] = ((p_type *)&data)[i]; \)==""\n"
R"==(p += get_max_sub_group_size(); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __global, uint))==""\n"
R"==(DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __global, uint))==""\n"
R"==(DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __global, uint))==""\n"
R"==(DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __global, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __global, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __global, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __global, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __global, uint))==""\n"
R"==(#ifdef cl_intel_subgroups_char)==""\n"
R"==(void __attribute__((overloadable)))==""\n"
R"==(intel_sub_group_block_write_uc16(__global uchar *p, uchar16 data);)==""\n"
R"==(uchar16 __attribute__((overloadable)))==""\n"
R"==(intel_sub_group_block_read_uc16(const __global uchar *p);)==""\n"
R"==(#endif)==""\n"
R"==(DECLARE_BLOCK_READ_EMU(, uint, __local, uint))==""\n"
R"==(DECLARE_BLOCK_READ_EMU(2, uint2, __local, uint))==""\n"
R"==(DECLARE_BLOCK_READ_EMU(4, uint4, __local, uint))==""\n"
R"==(DECLARE_BLOCK_READ_EMU(8, uint8, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(, uint, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(2, uint2, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(4, uint4, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(8, uint8, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(_us, ushort, __local, ushort))==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(_us2, ushort2, __local, ushort))==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(_us4, ushort4, __local, ushort))==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(_us8, ushort8, __local, ushort))==""\n"
R"==(#ifdef cl_intel_subgroup_local_block_io)==""\n"
R"==(DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __local, uint))==""\n"
R"==(DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __local, uint))==""\n"
R"==(DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __local, uint))==""\n"
R"==(DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE()==""\n"
R"==(_us, intel_sub_group_block_write_us, ushort, __local, ushort))==""\n"
R"==(#else)==""\n"
R"==(DECLARE_BLOCK_READ(, block_read_emu, uint, __local, uint))==""\n"
R"==(DECLARE_BLOCK_READ(2, block_read2_emu, uint2, __local, uint))==""\n"
R"==(DECLARE_BLOCK_READ(4, block_read4_emu, uint4, __local, uint))==""\n"
R"==(DECLARE_BLOCK_READ(8, block_read8_emu, uint8, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE(, block_write_emu, uint, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE(2, block_write2_emu, uint2, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE(4, block_write4_emu, uint4, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE(8, block_write8_emu, uint8, __local, uint))==""\n"
R"==(DECLARE_BLOCK_WRITE(_us, block_write_us_emu, ushort, __local, ushort))==""\n"
R"==(#endif)==""\n"
R"==(#define DECLARE_MMAD_EMU(name, dot, K, m, a_type, b_type, acc_type) \)==""\n"
R"==(acc_type __attribute__((overloadable)) \)==""\n"
R"==(name(a_type A_vectors, b_type B_vectors, acc_type acc) { \)==""\n"
R"==(for (uint i = 0; i < (m); ++i) { \)==""\n"
R"==(for (uint j = 0; j < (K); ++j) \)==""\n"
R"==(acc[i] = dot(sub_group_broadcast(A_vectors[i], j), \)==""\n"
R"==(B_vectors[j], acc[i]); \)==""\n"
R"==(} \)==""\n"
R"==(return acc; \)==""\n"
R"==(})==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x4, idot4, 8, 4, uint4, int8, int4))==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x4, idot4, 8, 4, int4, int8, int4))==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8, idot4, 8, 8, uint8, int8, int8))==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8, idot4, 8, 8, int8, int8, int8))==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8, idot4, 8, 8, ushort8, int8, int8))==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8, idot4, 8, 8, short8, int8, int8))==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x4_f16, f16_dot2, 8, 4, uint4, int8, float4))==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x4_f16, f16_dot2, 8, 4, short4, int8, float4))==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8_f16, f16_dot2, 8, 8, uint8, int8, float8))==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8_f16, f16_dot2, 8, 8, short8, int8, float8))==""\n"
R"==(#if MATH_UTILS_DECLARE_BF16)==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x4_bf16, bf16_dot2, 8, 4, uint4, int8, float4))==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8_bf16, bf16_dot2, 8, 8, uint8, int8, float8))==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x4_bf16, bf16_dot2, 8, 4, ushort4, int8, float4))==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8_bf16, bf16_dot2, 8, 8, ushort8, int8, float8))==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8_bf16, bf16_dot2, 8, 8, short8, int8, float8))==""\n"
R"==(#endif)==""\n"
R"==(#if !DETERMINISTIC && ATOMICS_SUPPORTED)==""\n"
R"==(#define ATOMIC(x) CONCAT2(atomic_, x))==""\n"
R"==(#define DECLARE_ATOMIC_OP(op, type) \)==""\n"
R"==(type __attribute__((overloadable)) CONCAT3(atomic_, op, _global)( \)==""\n"
R"==(volatile global ATOMIC(type) * source, type operand) { \)==""\n"
R"==(return CONCAT3(atomic_fetch_, op, _explicit)( \)==""\n"
R"==(source, operand, memory_order_relaxed); \)==""\n"
R"==(})==""\n"
R"==(DECLARE_ATOMIC_OP(min, int))==""\n"
R"==(DECLARE_ATOMIC_OP(max, int))==""\n"
R"==(DECLARE_ATOMIC_OP(add, int))==""\n"
R"==(DECLARE_ATOMIC_OP(sub, int))==""\n"
R"==(#if ATOMIC_FLOAT_SUPPORTED)==""\n"
R"==(#ifdef __opencl_c_ext_fp32_global_atomic_add)==""\n"
R"==(#define HAS_FLOAT_ATOMIC_ADD)==""\n"
R"==(DECLARE_ATOMIC_OP(add, float))==""\n"
R"==(DECLARE_ATOMIC_OP(sub, float))==""\n"
R"==(#endif )==""\n"
R"==(#ifdef __opencl_c_ext_fp32_global_atomic_min_max)==""\n"
R"==(DECLARE_ATOMIC_OP(min, float))==""\n"
R"==(DECLARE_ATOMIC_OP(max, float))==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#ifndef HAS_FLOAT_ATOMIC_ADD)==""\n"
R"==(inline float atomic_add_global()==""\n"
R"==(volatile __global atomic_float *source, float operand) {)==""\n"
R"==(float old_val = atomic_load_explicit()==""\n"
R"==(source, memory_order_relaxed, memory_scope_device);)==""\n"
R"==(bool success = false;)==""\n"
R"==(do {)==""\n"
R"==(float new_val = old_val + operand;)==""\n"
R"==(success = atomic_compare_exchange_strong_explicit(source, &old_val,)==""\n"
R"==(new_val, memory_order_acq_rel, memory_order_relaxed,)==""\n"
R"==(memory_scope_device);)==""\n"
R"==(} while (!success);)==""\n"
R"==(return old_val;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#if MATH_UTILS_DECLARE_S4 || MATH_UTILS_DECLARE_U4)==""\n"
R"==(#define GET_HALF_BYTE(x, y) get_half_byte(x, y))==""\n"
R"==(uchar __attribute__((overloadable)) cvt_f32_to_u4(float a) {)==""\n"
R"==(uchar i = convert_uchar_sat_rte(a);)==""\n"
R"==(return (i & 0xf0) ? 0x0f : i & 0x0f;)==""\n"
R"==(})==""\n"
R"==(char __attribute__((overloadable)) cvt_f32_to_s4(float a) {)==""\n"
R"==(return convert_char_sat_rte(min(max(a, -8.0f), 7.0f)) & 0x0F;)==""\n"
R"==(})==""\n"
R"==(float __attribute__((overloadable)) cvt_s4_to_f32(char a) {)==""\n"
R"==(char sign = (a & 0x08) ? 0xf0 : 0x0;)==""\n"
R"==(char val = a | sign;)==""\n"
R"==(return convert_float(val);)==""\n"
R"==(})==""\n"
R"==(float __attribute__((overloadable)) cvt_s4_to_s32(char a) {)==""\n"
R"==(char sign = (a & 0x08) ? 0xf0 : 0x0;)==""\n"
R"==(char val = a | sign;)==""\n"
R"==(return convert_int_sat_rte(val);)==""\n"
R"==(})==""\n"
R"==(uchar __attribute__((overloadable)) get_half_byte(__global uchar *x, off_t y) {)==""\n"
R"==(uchar ret = 0;)==""\n"
R"==(if (y % 2) {)==""\n"
R"==(ret = (uchar)((uchar)(x[y / 2] & 0xf0) >> 4);)==""\n"
R"==(} else {)==""\n"
R"==(ret = (uchar)(x[y / 2] & 0x0f);)==""\n"
R"==(})==""\n"
R"==(return ret;)==""\n"
R"==(})==""\n"
R"==(char __attribute__((overloadable)) get_half_byte(__global char *x, off_t y) {)==""\n"
R"==(if (y % 2) {)==""\n"
R"==(return (x[y / 2] & 0xf0) >> 4;)==""\n"
R"==(} else {)==""\n"
R"==(return x[y / 2] & 0x0f;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(void __attribute__((overloadable)))==""\n"
R"==(set_double_half_byte(__global uchar *x, off_t y, uchar z) {)==""\n"
R"==(x[y / 2] = z;)==""\n"
R"==(})==""\n"
R"==(void __attribute__((overloadable)))==""\n"
R"==(set_double_half_byte(__global char *x, off_t y, uchar z) {)==""\n"
R"==(x[y / 2] = z;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}