namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_pooling_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#if DST_DT_F32)==""\n"
R"==(#define DST_DATA_MIN -FLT_MAX)==""\n"
R"==(#elif DST_DT_F64)==""\n"
R"==(#define DST_DATA_MIN -FLT_MAX)==""\n"
R"==(#elif DST_DT_S8)==""\n"
R"==(#define DST_DATA_MIN CHAR_MIN)==""\n"
R"==(#elif DST_DT_U8)==""\n"
R"==(#define DST_DATA_MIN 0)==""\n"
R"==(#elif DST_DT_F16)==""\n"
R"==(#define DST_DATA_MIN -HALF_MAX)==""\n"
R"==(#elif DST_DT_HF8)==""\n"
R"==(#define DST_DATA_MIN (uchar)0xFE)==""\n"
R"==(#elif DST_DT_BF8)==""\n"
R"==(#define DST_DATA_MIN (uchar)0xFB)==""\n"
R"==(#else)==""\n"
R"==(#define DST_DATA_MIN DATA_MIN)==""\n"
R"==(#endif)==""\n"
R"==(#if DT_F64 || DST_DT_F64)==""\n"
R"==(#define ACC_DATA_T double)==""\n"
R"==(#else)==""\n"
R"==(#define ACC_DATA_T float)==""\n"
R"==(#endif)==""\n"
R"==(#if IS_FWD)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_pooling_fwd(__global DATA_T *src, __global int *ws,)==""\n"
R"==(__global DST_DATA_T *dst POST_OP_ARGS) {)==""\n"
R"==(const int mb = GWS_GET_MB();)==""\n"
R"==(const int oc = GWS_GET_OC();)==""\n"
R"==(const int od = GWS_GET_OD();)==""\n"
R"==(const int oh = GWS_GET_OH();)==""\n"
R"==(const int ow = GWS_GET_OW();)==""\n"
R"==(if (mb >= SRC_D0 || oc >= SRC_D1) {)==""\n"
R"==(const uint dst_off = DST_OFF(mb, oc, od, oh, ow);)==""\n"
R"==(dst[dst_off] = TO_DST(0.0f);)==""\n"
R"==(#if ALG_MAX && IS_TRAINING)==""\n"
R"==(ws[dst_off] = 0;)==""\n"
R"==(#endif)==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(const uint dst_off = DST_OFF(mb, oc, od, oh, ow);)==""\n"
R"==(#if ALG_MAX && IS_TRAINING)==""\n"
R"==(ws[dst_off] = -1;)==""\n"
R"==(#endif)==""\n"
R"==(#if ALG_AVG_P || ALG_AVG_NP)==""\n"
R"==(ACC_DATA_T d = 0;)==""\n"
R"==(#endif)==""\n"
R"==(#if ALG_MAX)==""\n"
R"==(#if DT_BF16)==""\n"
R"==(DEF_ACC_DATA_T d = TO_DEF_ACC_DATA_T(DST_DATA_MIN);)==""\n"
R"==(#else)==""\n"
R"==(ACC_DATA_T d = DST_DATA_MIN;)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(for (int kd = 0; kd < KD; ++kd) {)==""\n"
R"==(const int id = od * SD - PD + kd * (DD + 1);)==""\n"
R"==(if (id < 0 || id >= ID) continue;)==""\n"
R"==(for (int kh = 0; kh < KH; ++kh) {)==""\n"
R"==(const int ih = oh * SH - PH + kh * (DH + 1);)==""\n"
R"==(if (ih < 0 || ih >= IH) continue;)==""\n"
R"==(for (int kw = 0; kw < KW; ++kw) {)==""\n"
R"==(const int iw = ow * SW - PW + kw * (DW + 1);)==""\n"
R"==(if (iw < 0 || iw >= IW) continue;)==""\n"
R"==(int src_off = SRC_OFF(mb, oc, id, ih, iw);)==""\n"
R"==(#if ALG_MAX)==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(if (ws[dst_off] < 0) ws[dst_off] = kd * KH * KW + kh * KW + kw;)==""\n"
R"==(#endif)==""\n"
R"==(#if DT_BF16)==""\n"
R"==(DEF_ACC_DATA_T s = DATA_TO_REF(src[src_off]);)==""\n"
R"==(#elif DT_F64)==""\n"
R"==(ACC_DATA_T s = src[src_off];)==""\n"
R"==(#else)==""\n"
R"==(ACC_DATA_T s = DATA_TO_REF(src[src_off]);)==""\n"
R"==(#endif )==""\n"
R"==(if (s > d) {)==""\n"
R"==(d = s;)==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(ws[dst_off] = kd * KH * KW + kh * KW + kw;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#else )==""\n"
R"==(#if DT_F64)==""\n"
R"==(d += src[src_off];)==""\n"
R"==(#else)==""\n"
R"==(d += DATA_TO_REF(src[src_off]);)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if ALG_MAX)==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(if (ws[dst_off] < 0) ws[dst_off] = 0;)==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(#if ALG_AVG_P)==""\n"
R"==(const int num_summands = KD * KW * KH;)==""\n"
R"==(#else)==""\n"
R"==(const int id_start = od * SD - PD;)==""\n"
R"==(const int ih_start = oh * SH - PH;)==""\n"
R"==(const int iw_start = ow * SW - PW;)==""\n"
R"==(const int id_end = od * SD - PD + (KD - 1) * DD + KD;)==""\n"
R"==(const int ih_end = oh * SH - PH + (KH - 1) * DH + KH;)==""\n"
R"==(const int iw_end = ow * SW - PW + (KW - 1) * DW + KW;)==""\n"
R"==(const int id_start_excluded)==""\n"
R"==(= id_start < 0 ? (0 - id_start - 1) / (DD + 1) + 1 : 0;)==""\n"
R"==(const int ih_start_excluded)==""\n"
R"==(= ih_start < 0 ? (0 - ih_start - 1) / (DH + 1) + 1 : 0;)==""\n"
R"==(const int iw_start_excluded)==""\n"
R"==(= iw_start < 0 ? (0 - iw_start - 1) / (DW + 1) + 1 : 0;)==""\n"
R"==(const int id_end_excluded)==""\n"
R"==(= id_end > ID ? (id_end - ID - 1) / (DD + 1) + 1 : 0;)==""\n"
R"==(const int ih_end_excluded)==""\n"
R"==(= ih_end > IH ? (ih_end - IH - 1) / (DH + 1) + 1 : 0;)==""\n"
R"==(const int iw_end_excluded)==""\n"
R"==(= iw_end > IW ? (iw_end - IW - 1) / (DW + 1) + 1 : 0;)==""\n"
R"==(const int num_summands = (KD - id_start_excluded - id_end_excluded))==""\n"
R"==(* (KH - ih_start_excluded - ih_end_excluded))==""\n"
R"==(* (KW - iw_start_excluded - iw_end_excluded);)==""\n"
R"==(#endif)==""\n"
R"==(d /= num_summands;)==""\n"
R"==(#endif)==""\n"
R"==(#if DT_BF16 || DT_F64)==""\n"
R"==(POST_OP_DATA_T tmp = d;)==""\n"
R"==(#else)==""\n"
R"==(POST_OP_DATA_T tmp = (POST_OP_DATA_T)DATA_TO_REF(d);)==""\n"
R"==(#endif )==""\n"
R"==(POST_OP_DATA_T sum_src;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(sum_src = (POST_OP_DATA_T)DATA_TO_REF(dst[dst_off]);)==""\n"
R"==(#endif)==""\n"
R"==(#if NDIMS == 3)==""\n"
R"==(const unsigned po_d2 = ow;)==""\n"
R"==(const unsigned po_d3 = 0;)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#elif NDIMS == 4)==""\n"
R"==(const unsigned po_d2 = oh;)==""\n"
R"==(const unsigned po_d3 = ow;)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#elif NDIMS == 5)==""\n"
R"==(const unsigned po_d2 = od;)==""\n"
R"==(const unsigned po_d3 = oh;)==""\n"
R"==(const unsigned po_d4 = ow;)==""\n"
R"==(#else)==""\n"
R"==(const unsigned po_d2 = 0;)==""\n"
R"==(const unsigned po_d3 = 0;)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#endif)==""\n"
R"==(APPLY_POST_OPS_SERIAL(tmp, POST_OP_DATA_T, sum_src, POST_OP_DATA_T, mb, 1,)==""\n"
R"==(oc, 1, po_d2, 1, po_d3, 1, po_d4, 1, 0, 1);)==""\n"
R"==(#if DT_F64)==""\n"
R"==(dst[dst_off] = tmp;)==""\n"
R"==(#else)==""\n"
R"==(dst[dst_off] = TO_DST(tmp);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if IS_BWD)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_pooling_bwd(__global DATA_T *diff_src, __global int *ws,)==""\n"
R"==(__global DST_DATA_T *diff_dst) {)==""\n"
R"==(const int mb = GWS_GET_MB();)==""\n"
R"==(const int oc = GWS_GET_OC();)==""\n"
R"==(const int id = GWS_GET_ID();)==""\n"
R"==(const int ih = GWS_GET_IH();)==""\n"
R"==(const int iw = GWS_GET_IW();)==""\n"
R"==(DEF_ACC_DATA_T s = 0;)==""\n"
R"==(int denom = 1;)==""\n"
R"==(#if ALG_AVG_P)==""\n"
R"==(denom = KD * KH * KW;)==""\n"
R"==(#endif)==""\n"
R"==(for (int kd = 0; kd < KD; ++kd) {)==""\n"
R"==(int _od = id + PD - kd * (DD + 1);)==""\n"
R"==(if (_od % SD != 0) continue;)==""\n"
R"==(int od = _od / SD;)==""\n"
R"==(if (od < 0 || od >= OD) continue;)==""\n"
R"==(for (int kh = 0; kh < KH; ++kh) {)==""\n"
R"==(int _oh = ih + PH - kh * (DH + 1);)==""\n"
R"==(if (_oh % SH != 0) continue;)==""\n"
R"==(int oh = _oh / SH;)==""\n"
R"==(if (oh < 0 || oh >= OH) continue;)==""\n"
R"==(for (int kw = 0; kw < KW; ++kw) {)==""\n"
R"==(int _ow = iw + PW - kw * (DW + 1);)==""\n"
R"==(if (_ow % SW != 0) continue;)==""\n"
R"==(int ow = _ow / SW;)==""\n"
R"==(if (ow < 0 || ow >= OW) continue;)==""\n"
R"==(const uint dst_off = DST_OFF(mb, oc, od, oh, ow);)==""\n"
R"==(#if ALG_MAX)==""\n"
R"==(const int index = ws[dst_off];)==""\n"
R"==(const int hw = index % (KW * KH);)==""\n"
R"==(const int w_kd = index / (KW * KH);)==""\n"
R"==(const int w_kw = hw % KW;)==""\n"
R"==(const int w_kh = hw / KW;)==""\n"
R"==(if (w_kd != kd || w_kh != kh || w_kw != kw) continue;)==""\n"
R"==(#endif)==""\n"
R"==(#if ALG_AVG_NP)==""\n"
R"==(const int id_start = od * SD - PD;)==""\n"
R"==(const int ih_start = oh * SH - PH;)==""\n"
R"==(const int iw_start = ow * SW - PW;)==""\n"
R"==(const int id_end = od * SD - PD + (KD - 1) * DD + KD;)==""\n"
R"==(const int ih_end = oh * SH - PH + (KH - 1) * DH + KH;)==""\n"
R"==(const int iw_end = ow * SW - PW + (KW - 1) * DW + KW;)==""\n"
R"==(const int id_start_excluded)==""\n"
R"==(= id_start < 0 ? (0 - id_start - 1) / (DD + 1) + 1 : 0;)==""\n"
R"==(const int ih_start_excluded)==""\n"
R"==(= ih_start < 0 ? (0 - ih_start - 1) / (DH + 1) + 1 : 0;)==""\n"
R"==(const int iw_start_excluded)==""\n"
R"==(= iw_start < 0 ? (0 - iw_start - 1) / (DW + 1) + 1 : 0;)==""\n"
R"==(const int id_end_excluded)==""\n"
R"==(= id_end > ID ? (id_end - ID - 1) / (DD + 1) + 1 : 0;)==""\n"
R"==(const int ih_end_excluded)==""\n"
R"==(= ih_end > IH ? (ih_end - IH - 1) / (DH + 1) + 1 : 0;)==""\n"
R"==(const int iw_end_excluded)==""\n"
R"==(= iw_end > IW ? (iw_end - IW - 1) / (DW + 1) + 1 : 0;)==""\n"
R"==(denom = (KD - id_start_excluded - id_end_excluded))==""\n"
R"==(* (KH - ih_start_excluded - ih_end_excluded))==""\n"
R"==(* (KW - iw_start_excluded - iw_end_excluded);)==""\n"
R"==(#endif)==""\n"
R"==(#if ALG_MAX || ALG_AVG_P)==""\n"
R"==(s += TO_DEF_ACC_DATA_T(diff_dst[dst_off]);)==""\n"
R"==(#elif ALG_AVG_NP)==""\n"
R"==(s += TO_DEF_ACC_DATA_T(diff_dst[dst_off]) / denom;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if ALG_MAX || ALG_AVG_P)==""\n"
R"==(s /= denom;)==""\n"
R"==(#endif)==""\n"
R"==(uint diff_src_offset = SRC_OFF(mb, oc, id, ih, iw);)==""\n"
R"==(diff_src[diff_src_offset] = CONVERT_DATA_T(s);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}