namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_prelu_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_eltwise.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#if IS_FWD)==""\n"
R"==(__kernel void ref_prelu_fwd(const __global SRC_DATA_T *src,)==""\n"
R"==(const __global WEI_DATA_T *weights, __global DST_DATA_T *dst) {)==""\n"
R"==(const int d0 = GWS_GET_D0();)==""\n"
R"==(const int d1 = GWS_GET_D1();)==""\n"
R"==(const int d2 = GWS_GET_D2();)==""\n"
R"==(const int d3 = GWS_GET_D3();)==""\n"
R"==(const int d4 = GWS_GET_D4();)==""\n"
R"==(const int d5 = GWS_GET_D5();)==""\n"
R"==(const unsigned data_off = OFF_MD(SRC, d0, d1, d2, d3, d4, d5);)==""\n"
R"==(const unsigned wei_off = OFF_MD(WEI, d0 % WEI_D0, d1 % WEI_D1, d2 % WEI_D2,)==""\n"
R"==(d3 % WEI_D3, d4 % WEI_D4, d5 % WEI_D5);)==""\n"
R"==(const float src_data = SRC_TO_REF(src[data_off]);)==""\n"
R"==(const float wei_data = WEI_TO_REF(weights[wei_off]);)==""\n"
R"==(const float res_data = relu_fwd(src_data, wei_data);)==""\n"
R"==(dst[data_off] = TO_DST(res_data);)==""\n"
R"==(})==""\n"
R"==(#else )==""\n"
R"==(__kernel void ref_prelu_bwd(const __global SRC_DATA_T *src,)==""\n"
R"==(const __global WEI_DATA_T *weights, const __global DST_DATA_T *diff_dst,)==""\n"
R"==(__global DIFF_SRC_DATA_T *diff_src,)==""\n"
R"==(__global DIFF_WEI_DATA_T *diff_weights) {)==""\n"
R"==(const int d0 = GWS_GET_D0();)==""\n"
R"==(const int d1 = GWS_GET_D1();)==""\n"
R"==(const int d2 = GWS_GET_D2();)==""\n"
R"==(const int d3 = GWS_GET_D3();)==""\n"
R"==(const int d4 = GWS_GET_D4();)==""\n"
R"==(const int d5 = GWS_GET_D5();)==""\n"
R"==(const unsigned data_off = OFF_MD(SRC, d0 % SRC_D0, d1 % SRC_D1, d2 % SRC_D2,)==""\n"
R"==(d3 % SRC_D3, d4 % SRC_D4, d5 % SRC_D5);)==""\n"
R"==(const unsigned data_off_pd = OFF_MD(SRC, d0 % SRC_PD0, d1 % SRC_PD1,)==""\n"
R"==(d2 % SRC_PD2, d3 % SRC_PD3, d4 % SRC_PD4, d5 % SRC_PD5);)==""\n"
R"==(const unsigned wei_off = OFF_MD(WEI, d0 % WEI_D0, d1 % WEI_D1, d2 % WEI_D2,)==""\n"
R"==(d3 % WEI_D3, d4 % WEI_D4, d5 % WEI_D5);)==""\n"
R"==(const float src_data = SRC_TO_REF(src[data_off]);)==""\n"
R"==(const float diff_dst_data = DST_TO_REF(diff_dst[data_off]);)==""\n"
R"==(const float wei_data = WEI_TO_REF(weights[wei_off]);)==""\n"
R"==(float diff_src_data)==""\n"
R"==(= src_data > 0 ? diff_dst_data : diff_dst_data * wei_data;)==""\n"
R"==(if (data_off != data_off_pd) diff_src_data = 0.f;)==""\n"
R"==(#define COORDINATES_ARE_IN_RANGE(mem_prefix) \)==""\n"
R"==(({ \)==""\n"
R"==(bool is_in_range = d0 < CONCAT2(mem_prefix, _PD0) \)==""\n"
R"==(&& d1 < CONCAT2(mem_prefix, _PD1) \)==""\n"
R"==(&& d2 < CONCAT2(mem_prefix, _PD2) \)==""\n"
R"==(&& d3 < CONCAT2(mem_prefix, _PD3) \)==""\n"
R"==(&& d4 < CONCAT2(mem_prefix, _PD4) \)==""\n"
R"==(&& d5 < CONCAT2(mem_prefix, _PD5); \)==""\n"
R"==(is_in_range; \)==""\n"
R"==(}))==""\n"
R"==(if (COORDINATES_ARE_IN_RANGE(SRC)))==""\n"
R"==(diff_src[data_off_pd] = TO_SRC(diff_src_data);)==""\n"
R"==(if (!COORDINATES_ARE_IN_RANGE(DIFF_WEI)) return;)==""\n"
R"==(const unsigned diff_wei_off = OFF_MD(DIFF_WEI, d0 % DIFF_WEI_D0,)==""\n"
R"==(d1 % DIFF_WEI_D1, d2 % DIFF_WEI_D2, d3 % DIFF_WEI_D3,)==""\n"
R"==(d4 % DIFF_WEI_D4, d5 % DIFF_WEI_D5);)==""\n"
R"==(const unsigned diff_wei_off_pd = OFF_MD(DIFF_WEI, d0 % DIFF_WEI_PD0,)==""\n"
R"==(d1 % DIFF_WEI_PD1, d2 % DIFF_WEI_PD2, d3 % DIFF_WEI_PD3,)==""\n"
R"==(d4 % DIFF_WEI_PD4, d5 % DIFF_WEI_PD5);)==""\n"
R"==(float diff_wei_data = src_data > 0 ? 0 : diff_dst_data * src_data;)==""\n"
R"==(if (diff_wei_off != diff_wei_off_pd) diff_wei_data = 0.f;)==""\n"
R"==(#if DIFF_WEI_DT_F32)==""\n"
R"==(diff_weights[diff_wei_off_pd] = diff_wei_data;)==""\n"
R"==(#else )==""\n"
R"==(diff_weights[diff_wei_off_pd] = TO_DIFF_WEI(diff_wei_data);)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}
}