namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_resampling_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#if IS_FWD == 1)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_resampling_fwd()==""\n"
R"==(__global const DATA_T *src, __global DST_DATA_T *dst POST_OP_ARGS) {)==""\n"
R"==(const uint mb = GWS_GET_MB();)==""\n"
R"==(const uint c = GWS_GET_C();)==""\n"
R"==(const uint od = GWS_GET_OD();)==""\n"
R"==(const uint oh = GWS_GET_OH();)==""\n"
R"==(const uint ow = GWS_GET_OW();)==""\n"
R"==(const float id = (od + .5f) * ID / OD;)==""\n"
R"==(const float ih = (oh + .5f) * IH / OH;)==""\n"
R"==(const float iw = (ow + .5f) * IW / OW;)==""\n"
R"==(float result;)==""\n"
R"==(const uint dst_index = DST_OFF(mb, c, od, oh, ow);)==""\n"
R"==(if (mb >= DST_D0 || c >= DST_D1) {)==""\n"
R"==(dst[dst_index] = TO_DST(0.0f);)==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(#if RESAMPLING_ALG_NEAREST)==""\n"
R"==(const uint src_index = SRC_OFF(mb, c, (uint)id, (uint)ih, (uint)iw);)==""\n"
R"==(result = CONVERT_FLOAT_T(src[src_index]);)==""\n"
R"==(#else)==""\n"
R"==(const int id0 = max((int)floor(id - .5f), 0);)==""\n"
R"==(const int id1 = min((int)ceil(id - .5f), ID - 1);)==""\n"
R"==(const int ih0 = max((int)floor(ih - .5f), 0);)==""\n"
R"==(const int ih1 = min((int)ceil(ih - .5f), IH - 1);)==""\n"
R"==(const int iw0 = max((int)floor(iw - .5f), 0);)==""\n"
R"==(const int iw1 = min((int)ceil(iw - .5f), IW - 1);)==""\n"
R"==(const float wd[2] = {1.0f - fabs(id - .5f - id0), fabs(id - .5f - id0)};)==""\n"
R"==(const float wh[2] = {1.0f - fabs(ih - .5f - ih0), fabs(ih - .5f - ih0)};)==""\n"
R"==(const float ww[2] = {1.0f - fabs(iw - .5f - iw0), fabs(iw - .5f - iw0)};)==""\n"
R"==(const int ih_arr[2] = {ih0, ih1};)==""\n"
R"==(const int iw_arr[2] = {iw0, iw1};)==""\n"
R"==(float cd[2][2];)==""\n"
R"==(for_(int i = 0; i < 2; i++))==""\n"
R"==(for (int j = 0; j < 2; j++))==""\n"
R"==(cd[i][j] = CONVERT_FLOAT_T()==""\n"
R"==(src[SRC_OFF(mb, c, id0, ih_arr[i], iw_arr[j])]))==""\n"
R"==(* wd[0])==""\n"
R"==(+ CONVERT_FLOAT_T()==""\n"
R"==(src[SRC_OFF(mb, c, id1, ih_arr[i], iw_arr[j])]))==""\n"
R"==(* wd[1];)==""\n"
R"==(float ch[2];)==""\n"
R"==(for (int i = 0; i < 2; i++))==""\n"
R"==(ch[i] = cd[0][i] * wh[0] + cd[1][i] * wh[1];)==""\n"
R"==(result = ch[0] * ww[0] + ch[1] * ww[1];)==""\n"
R"==(#endif)==""\n"
R"==(float sum_src;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(sum_src = DST_TO_REF(dst[dst_index]);)==""\n"
R"==(#endif)==""\n"
R"==(#if NDIMS == 3)==""\n"
R"==(const unsigned po_d2 = ow;)==""\n"
R"==(const unsigned po_d3 = 0;)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#elif NDIMS == 4)==""\n"
R"==(const unsigned po_d2 = oh;)==""\n"
R"==(const unsigned po_d3 = ow;)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#elif NDIMS == 5)==""\n"
R"==(const unsigned po_d2 = od;)==""\n"
R"==(const unsigned po_d3 = oh;)==""\n"
R"==(const unsigned po_d4 = ow;)==""\n"
R"==(#else)==""\n"
R"==(const unsigned po_d2 = 0;)==""\n"
R"==(const unsigned po_d3 = 0;)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#endif)==""\n"
R"==(APPLY_POST_OPS_SERIAL(result, float, sum_src, float, mb, 1, c, 1, po_d2, 1,)==""\n"
R"==(po_d3, 1, po_d4, 1, 0, 1);)==""\n"
R"==(dst[dst_index] = TO_DST(result);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if IS_BWD == 1)==""\n"
R"==(float linear(int x, int fo, int fi) {)==""\n"
R"==(return ((x + .5f) * fo / fi) - .5f;)==""\n"
R"==(})==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_resampling_bwd()==""\n"
R"==(__global DATA_T *diff_src, __global const DST_DATA_T *diff_dst) {)==""\n"
R"==(#define CEIL(x) max((int)ceil(x), (int)0))==""\n"
R"==(#define L(x, fo, fi) linear(x, fo, fi))==""\n"
R"==(#define LS(x, fo, fi) CEIL(L(x, fo, fi)))==""\n"
R"==(#define RS(x, fo, fi) \)==""\n"
R"==(L((int)x - 1, fo, fi) < 0 ? 0 : (int)(L((int)x - 1, fo, fi)) + 1)==""\n"
R"==(#define LE(x, fo, fi, lim) min(CEIL(L(x + 1, fo, fi)), (int)lim))==""\n"
R"==(#define RE(x, fo, fi, lim) \)==""\n"
R"==(min((L(x, fo, fi) < 0 ? 0 : (int)(L(x, fo, fi)) + 1), (int)lim))==""\n"
R"==(const uint mb = GWS_GET_MB();)==""\n"
R"==(const uint c = GWS_GET_C();)==""\n"
R"==(const uint id = GWS_GET_ID();)==""\n"
R"==(const uint ih = GWS_GET_IH();)==""\n"
R"==(const uint iw = GWS_GET_IW();)==""\n"
R"==(const uint src_index = SRC_OFF(mb, c, id, ih, iw);)==""\n"
R"==(if (mb >= DST_D0 || c >= DST_D1) {)==""\n"
R"==(diff_src[src_index] = TO_DST(0.f);)==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(#if RESAMPLING_ALG_NEAREST)==""\n"
R"==(int od_start = CEIL(id * FD - .5f);)==""\n"
R"==(int oh_start = CEIL(ih * FH - .5f);)==""\n"
R"==(int ow_start = CEIL(iw * FW - .5f);)==""\n"
R"==(int od_end = CEIL((id + 1.f) * FD - .5f);)==""\n"
R"==(int oh_end = CEIL((ih + 1.f) * FH - .5f);)==""\n"
R"==(int ow_end = CEIL((iw + 1.f) * FW - .5f);)==""\n"
R"==(float src_val = 0;)==""\n"
R"==(for (int i = od_start; i < od_end; i++) {)==""\n"
R"==(for (int j = oh_start; j < oh_end; j++) {)==""\n"
R"==(for (int k = ow_start; k < ow_end; k++) {)==""\n"
R"==(const int dst_index = DST_OFF(mb, c, i, j, k);)==""\n"
R"==(src_val += DST_TO_REF(diff_dst[dst_index]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(int left_sd = id == 0 ? 0 : LS(id, OD, ID);)==""\n"
R"==(int left_sh = ih == 0 ? 0 : LS(ih, OH, IH);)==""\n"
R"==(int left_sw = iw == 0 ? 0 : LS(iw, OW, IW);)==""\n"
R"==(int right_sd = RS(id, OD, ID);)==""\n"
R"==(int right_sh = RS(ih, OH, IH);)==""\n"
R"==(int right_sw = RS(iw, OW, IW);)==""\n"
R"==(int left_ed = LE(id, OD, ID, OD);)==""\n"
R"==(int left_eh = LE(ih, OH, IH, OH);)==""\n"
R"==(int left_ew = LE(iw, OW, IW, OW);)==""\n"
R"==(int right_ed = id == (ID - 1) ? OD : RE(id, OD, ID, OD);)==""\n"
R"==(int right_eh = ih == (IH - 1) ? OH : RE(ih, OH, IH, OH);)==""\n"
R"==(int right_ew = iw == (IW - 1) ? OW : RE(iw, OW, IW, OW);)==""\n"
R"==(int od_start[2] = {left_sd, right_sd};)==""\n"
R"==(int oh_start[2] = {left_sh, right_sh};)==""\n"
R"==(int ow_start[2] = {left_sw, right_sw};)==""\n"
R"==(int od_end[2] = {left_ed, right_ed};)==""\n"
R"==(int oh_end[2] = {left_eh, right_eh};)==""\n"
R"==(int ow_end[2] = {left_ew, right_ew};)==""\n"
R"==(float src_val = 0.0f;)==""\n"
R"==(for (int c1 = 0; c1 < 2; c1++) {)==""\n"
R"==(for (int c2 = 0; c2 < 2; c2++) {)==""\n"
R"==(for (int c3 = 0; c3 < 2; c3++) {)==""\n"
R"==(for (int i = od_start[c1]; i < od_end[c1]; i++) {)==""\n"
R"==(for (int j = oh_start[c2]; j < oh_end[c2]; j++) {)==""\n"
R"==(for (int k = ow_start[c3]; k < ow_end[c3]; k++) {)==""\n"
R"==(float dst_val = DST_TO_REF()==""\n"
R"==(diff_dst[DST_OFF(mb, c, i, j, k)]);)==""\n"
R"==(float d = L(i, ID, OD);)==""\n"
R"==(float h = L(j, IH, OH);)==""\n"
R"==(float w = L(k, IW, OW);)==""\n"
R"==(float Wid = c1 == 0 ? 1.f - fabs(d - (int)d))==""\n"
R"==(: fabs(d - (int)d);)==""\n"
R"==(float Wih = c2 == 0 ? 1.f - fabs(h - (int)h))==""\n"
R"==(: fabs(h - (int)h);)==""\n"
R"==(float Wiw = c3 == 0 ? 1.f - fabs(w - (int)w))==""\n"
R"==(: fabs(w - (int)w);)==""\n"
R"==(src_val += dst_val * Wid * Wih * Wiw;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if DT_S32 == 1)==""\n"
R"==(diff_src[src_index] = CONVERT_DATA_T(src_val);)==""\n"
R"==(#else )==""\n"
R"==(diff_src[src_index] = TO_DATA_T(src_val);)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}