namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_sdpa_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#include "gpu/intel/ocl/sdpa_utils.h")==""\n"
R"==(__kernel void ref_sdpa(const __global QRY_DATA_T *Q,)==""\n"
R"==(const __global KEY_DATA_T *K, const __global VAL_DATA_T *V,)==""\n"
R"==(__global DST_DATA_T *dst, const __global SCALE_DATA_T *scale_ptr,)==""\n"
R"==(const __global MSK_DATA_T *mask, long nv, long nd) {)==""\n"
R"==(long q = get_global_id(0);)==""\n"
R"==(long b0 = get_global_id(1);)==""\n"
R"==(long b1 = get_global_id(2);)==""\n"
R"==(float s[SIZE_K];)==""\n"
R"==(for (long k = 0; k < SIZE_K; k++) {)==""\n"
R"==(float acc = 0;)==""\n"
R"==(for (long h = 0; h < nd; h++) {)==""\n"
R"==(long qry_off = QRY_OFF(b1 % QRY_D0, b0 % QRY_D1, q, h);)==""\n"
R"==(long key_off = KEY_OFF(b1 % KEY_D0, b0 % KEY_D1, h, k);)==""\n"
R"==(acc += convert_float(Q[qry_off]) * convert_float(K[key_off]);)==""\n"
R"==(})==""\n"
R"==(s[k] = acc;)==""\n"
R"==(})==""\n"
R"==(float s_sum = 0;)==""\n"
R"==(#if WITH_ATTN_SCALE)==""\n"
R"==(SCALE_DATA_T scale = *scale_ptr;)==""\n"
R"==(#if INVERT_SCALE)==""\n"
R"==(scale = 1.f / scale;)==""\n"
R"==(#endif)==""\n"
R"==(for (long k = 0; k < SIZE_K; k++) {)==""\n"
R"==(s[k] *= scale;)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_ATTN_MASK)==""\n"
R"==(long msk_off = MSK_OFF(b1 % MSK_D0, b0 % MSK_D1, q, k);)==""\n"
R"==(s[k] += convert_float(mask[msk_off]);)==""\n"
R"==(#endif)==""\n"
R"==(s[k] = exp(s[k]);)==""\n"
R"==(s_sum += s[k];)==""\n"
R"==(})==""\n"
R"==(for (long k = 0; k < SIZE_K; k++))==""\n"
R"==(s[k] /= s_sum;)==""\n"
R"==(for (long v = 0; v < nv; v++) {)==""\n"
R"==(float acc = 0;)==""\n"
R"==(for (long k = 0; k < SIZE_K; k++) {)==""\n"
R"==(long val_off = VAL_OFF(b1 % VAL_D0, b0 % VAL_D1, k, v);)==""\n"
R"==(acc += convert_float(V[val_off]) * s[k];)==""\n"
R"==(})==""\n"
R"==(long dst_off = DST_OFF(b1 % DST_D0, b0 % DST_D1, 0, q, v);)==""\n"
R"==(dst[dst_off] = TO_DST(acc);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}