namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *reusable_lnorm_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2023-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_io.h")==""\n"
R"==(#include "gpu/intel/ocl/types_interop.h")==""\n"
R"==(NAMED_KERNEL_ATTR(STAT))==""\n"
R"==(__kernel void lnorm_reusable_calc_mean(__global SRC_STAT_DT *src,)==""\n"
R"==(__global float *mean, dim_t reduce_size, dim_t reduce_stride,)==""\n"
R"==(dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(src = GWS_GET_BUFFER_POS_NAMED(SRC, STAT, gws_params, src);)==""\n"
R"==(mean = GWS_GET_BUFFER_POS_NAMED(STAT, STAT, gws_params, mean);)==""\n"
R"==(ACC_DT sum = SPECIAL(ACC_DT, zero);)==""\n"
R"==(for (off_t i = 0; i < reduce_size; i++) {)==""\n"
R"==(ACC_DT src_val;)==""\n"
R"==(load(&src_val, src + i * (off_t)reduce_stride);)==""\n"
R"==(sum += src_val;)==""\n"
R"==(})==""\n"
R"==(float res = into_float(sum) / reduce_size;)==""\n"
R"==(write(mean, &res);)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(STAT))==""\n"
R"==(__kernel void lnorm_reusable_calc_var(__global SRC_STAT_DT *src,)==""\n"
R"==(__global float *mean, __global float *variance, dim_t reduce_size,)==""\n"
R"==(dim_t reduce_stride, dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(src = GWS_GET_BUFFER_POS_NAMED(SRC, STAT, gws_params, src);)==""\n"
R"==(mean = GWS_GET_BUFFER_POS_NAMED(STAT, STAT, gws_params, mean);)==""\n"
R"==(variance = GWS_GET_BUFFER_POS_NAMED(STAT, STAT, gws_params, variance);)==""\n"
R"==(float mean_val;)==""\n"
R"==(load(&mean_val, mean);)==""\n"
R"==(float sum = 0.0f;)==""\n"
R"==(for (off_t i = 0; i < reduce_size; i++) {)==""\n"
R"==(ACC_DT src_val;)==""\n"
R"==(load(&src_val, src + i * (off_t)reduce_stride);)==""\n"
R"==(float v0 = src_val - mean_val;)==""\n"
R"==(sum += v0 * v0;)==""\n"
R"==(})==""\n"
R"==(float res = sum / reduce_size;)==""\n"
R"==(write(variance, &res);)==""\n"
R"==(})==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void lnorm_reusable_fwd(__global SRC_DT *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DST_DT *dst, __global SS_DT *scale,)==""\n"
R"==(__global SS_DT *shift, float eps, __global float *src_scale,)==""\n"
R"==(__global float *dst_scale, dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(mean = GWS_GET_BUFFER_POS(STAT, gws_params, mean);)==""\n"
R"==(variance = GWS_GET_BUFFER_POS(STAT, gws_params, variance);)==""\n"
R"==(scale = GWS_GET_BUFFER_POS(SS, gws_params, scale);)==""\n"
R"==(shift = GWS_GET_BUFFER_POS(SS, gws_params, shift);)==""\n"
R"==(src = GWS_GET_BUFFER_POS(SRC, gws_params, src);)==""\n"
R"==(dst = GWS_GET_BUFFER_POS(DST, gws_params, dst);)==""\n"
R"==(float sm = 1.0f;)==""\n"
R"==(float sv = 0.0f;)==""\n"
R"==(if (USE_SCALE) load(&sm, scale);)==""\n"
R"==(if (USE_SHIFT) load(&sv, shift);)==""\n"
R"==(float src_val, var_val, mean_val;)==""\n"
R"==(load(&src_val, src);)==""\n"
R"==(load(&var_val, variance);)==""\n"
R"==(load(&mean_val, mean);)==""\n"
R"==(float sqrt_variance = 1.0f / sqrt(var_val + eps);)==""\n"
R"==(float res = sm * (src_val - mean_val) * sqrt_variance + sv;)==""\n"
R"==(if (WITH_SRC_SCALES) {)==""\n"
R"==(float src_scale_val;)==""\n"
R"==(load(&src_scale_val, src_scale);)==""\n"
R"==(res *= src_scale_val;)==""\n"
R"==(})==""\n"
R"==(if (WITH_DST_SCALES) {)==""\n"
R"==(float dst_scale_val;)==""\n"
R"==(load(&dst_scale_val, dst_scale);)==""\n"
R"==(res /= dst_scale_val;)==""\n"
R"==(})==""\n"
R"==(write(dst, &res);)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(SS))==""\n"
R"==(__kernel void lnorm_reusable_bwd_scaleshift(__global SRC_SS_DT *src,)==""\n"
R"==(__global float *mean, __global float *variance,)==""\n"
R"==(__global DST_SS_DT *diff_dst, __global SS_SS_DT *diff_scale,)==""\n"
R"==(__global SS_SS_DT *diff_shift, dim_t stat_size, dim_t stat_stride,)==""\n"
R"==(float eps, dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(src = GWS_GET_BUFFER_POS_NAMED(SRC, SS, gws_params, src);)==""\n"
R"==(diff_dst = GWS_GET_BUFFER_POS_NAMED(DST, SS, gws_params, diff_dst);)==""\n"
R"==(diff_scale = GWS_GET_BUFFER_POS_NAMED(SS, SS, gws_params, diff_scale);)==""\n"
R"==(diff_shift = GWS_GET_BUFFER_POS_NAMED(SS, SS, gws_params, diff_shift);)==""\n"
R"==(float gamma = 0.0f;)==""\n"
R"==(float beta = 0.0f;)==""\n"
R"==(for (int i = 0; i < stat_size; i++) {)==""\n"
R"==(off_t off = i * stat_stride;)==""\n"
R"==(ACC_BWD_DT dst_val;)==""\n"
R"==(load(&dst_val, diff_dst + off);)==""\n"
R"==(ACC_DT src_val;)==""\n"
R"==(load(&src_val, src + off);)==""\n"
R"==(float mean_val, var_val;)==""\n"
R"==(load(&mean_val, mean + i);)==""\n"
R"==(load(&var_val, variance + i);)==""\n"
R"==(beta += dst_val;)==""\n"
R"==(gamma += dst_val * (src_val - mean_val) / sqrt(var_val + eps);)==""\n"
R"==(})==""\n"
R"==(if (diff_shift) write(diff_shift, &beta);)==""\n"
R"==(if (diff_scale) write(diff_scale, &gamma);)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(STAT))==""\n"
R"==(__kernel void lnorm_reusable_bwd(__global SRC_STAT_DT *src,)==""\n"
R"==(__global DST_STAT_DT *diff_dst, __global SRC_STAT_DT *diff_src,)==""\n"
R"==(__global SS_DT *scale, __global float *mean, __global float *variance,)==""\n"
R"==(float eps, dim_t norm_stride, dim_t norm_size, char include_stats,)==""\n"
R"==(dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(ASSUME((include_stats == 0) || (include_stats == 1));)==""\n"
R"==(src = GWS_GET_BUFFER_POS_NAMED(SRC, STAT, gws_params, src);)==""\n"
R"==(diff_dst = GWS_GET_BUFFER_POS_NAMED(DST, STAT, gws_params, diff_dst);)==""\n"
R"==(diff_src = GWS_GET_BUFFER_POS_NAMED(SRC, STAT, gws_params, diff_src);)==""\n"
R"==(mean = GWS_GET_BUFFER_POS_NAMED(STAT, STAT, gws_params, mean);)==""\n"
R"==(variance = GWS_GET_BUFFER_POS_NAMED(STAT, STAT, gws_params, variance);)==""\n"
R"==(float mean_val, var_val;)==""\n"
R"==(load(&mean_val, mean);)==""\n"
R"==(load(&var_val, variance);)==""\n"
R"==(float inv_var = rsqrt(var_val + eps);)==""\n"
R"==(float mu = 0.0f;)==""\n"
R"==(float sigma = 0.0f;)==""\n"
R"==(if (include_stats) {)==""\n"
R"==(for (int i = 0; i < norm_size; i++) {)==""\n"
R"==(off_t off = i * norm_stride;)==""\n"
R"==(ACC_BWD_DT dst_val;)==""\n"
R"==(load(&dst_val, diff_dst + off);)==""\n"
R"==(ACC_DT src_val;)==""\n"
R"==(load(&src_val, src + off);)==""\n"
R"==(float scale_val = 1.0f;)==""\n"
R"==(if (scale) load(&scale_val, scale + i);)==""\n"
R"==(mu += dst_val * scale_val;)==""\n"
R"==(sigma += dst_val * scale_val * src_val;)==""\n"
R"==(})==""\n"
R"==(sigma -= mu * mean_val;)==""\n"
R"==(sigma *= inv_var * inv_var;)==""\n"
R"==(})==""\n"
R"==(for (int i = 0; i < norm_size; i++) {)==""\n"
R"==(off_t off = i * norm_stride;)==""\n"
R"==(ACC_BWD_DT dst_val;)==""\n"
R"==(load(&dst_val, diff_dst + off);)==""\n"
R"==(ACC_DT src_val;)==""\n"
R"==(load(&src_val, src + off);)==""\n"
R"==(float scale_val = 1.0f;)==""\n"
R"==(if (scale) load(&scale_val, scale + i);)==""\n"
R"==(float res = dst_val * scale_val;)==""\n"
R"==(if (include_stats) {)==""\n"
R"==(res -= (mu + sigma * (src_val - mean_val)) / norm_size;)==""\n"
R"==(})==""\n"
R"==(float out = inv_var * res;)==""\n"
R"==(write(diff_src + off, &out);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}