namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *reusable_ref_reduction_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2021-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#include "gpu/intel/ocl/reduction/ocl_reduction.h")==""\n"
R"==(#include "gpu/intel/ocl/types_interop.h")==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void reusable_ref_reduce(__global DATA_T *src,)==""\n"
R"==(__global DST_DATA_T *dst, off_t reduction_stride, off_t reduction_size,)==""\n"
R"==(off_t div, float power, float eps,)==""\n"
R"==(dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(ASSUME(reduction_size > 0);)==""\n"
R"==(ASSUME(reduction_stride > 0);)==""\n"
R"==(ASSUME(div > 0);)==""\n"
R"==(src = GWS_GET_BUFFER_POS(SRC, gws_params, src);)==""\n"
R"==(dst = GWS_GET_BUFFER_POS(DST, gws_params, dst);)==""\n"
R"==(DEF_ACC_DATA_T acc;)==""\n"
R"==(init_acc(REDUCTION_ALG, &acc);)==""\n"
R"==(for (off_t i = 0; i < reduction_size; i++) {)==""\n"
R"==(const off_t src_off = i * reduction_stride;)==""\n"
R"==(const DEF_ACC_DATA_T src_val = TO_DEF_ACC_DATA_T(src[src_off]);)==""\n"
R"==(acc = reduce(REDUCTION_ALG, acc, src_val, power);)==""\n"
R"==(})==""\n"
R"==(DST_DATA_T dst_data = TO_DST()==""\n"
R"==(finalize(REDUCTION_ALG, convert_float(acc), div, power, eps));)==""\n"
R"==(*dst = dst_data;)==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}