namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *simple_layer_normalization_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/layer_norm_common.h")==""\n"
R"==(#if IS_FWD)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void simple_lnorm_fwd(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DST_DATA_T *dst,)==""\n"
R"==(__global WEI_DATA_T *scale, __global WEI_DATA_T *shift, float eps,)==""\n"
R"==(__global float *src_scale, __global float *dst_scale) {)==""\n"
R"==(int x[6] = {0};)==""\n"
R"==(x[0] = GWS_GET_X0();)==""\n"
R"==(x[1] = GWS_GET_X1();)==""\n"
R"==(x[2] = GWS_GET_X2();)==""\n"
R"==(x[3] = GWS_GET_X3();)==""\n"
R"==(if (x[0] >= DST_D0 || x[1] >= DST_D1 || x[2] >= DST_D2 || x[3] >= DST_D3) {)==""\n"
R"==(int local_id = get_sub_group_local_id();)==""\n"
R"==(for (int c = 0; c < C; c += SUB_GROUP_SIZE) {)==""\n"
R"==(x[NDIMS - 1] = c + local_id;)==""\n"
R"==(int dst_off = DST_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(dst[dst_off] = TO_DST(CONVERT_DATA_T(0.f));)==""\n"
R"==(})==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(int s_off = STAT_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(float v_mean = CALCULATE_STATS ? 0 : mean[s_off];)==""\n"
R"==(float v_variance = CALCULATE_STATS ? 0 : variance[s_off];)==""\n"
R"==(if (CALCULATE_STATS) {)==""\n"
R"==(VECT_FLOAT_T v_acc = 0;)==""\n"
R"==(for (int c = 0; c < C; c += SUB_GROUP_SIZE * VECT_DT_N) {)==""\n"
R"==(x[NDIMS - 1] = c;)==""\n"
R"==(int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(v_acc += CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ()==""\n"
R"==((const __global BLOCK_DATA_T *)&src[src_off])));)==""\n"
R"==(})==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(v_mean = v_acc;)==""\n"
R"==(#else )==""\n"
R"==(v_mean = 0;)==""\n"
R"==(for (int i = 0; i < VECT_DT_N; ++i) {)==""\n"
R"==(v_mean += v_acc[i];)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(float total_sum = sub_group_reduce_add(v_mean);)==""\n"
R"==(v_mean = total_sum / C;)==""\n"
R"==(v_acc = 0;)==""\n"
R"==(VECT_FLOAT_T m = 0;)==""\n"
R"==(for (int c = 0; c < C; c += SUB_GROUP_SIZE * VECT_DT_N) {)==""\n"
R"==(x[NDIMS - 1] = c;)==""\n"
R"==(int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(m = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ()==""\n"
R"==((const __global BLOCK_DATA_T *)&src[src_off])));)==""\n"
R"==(m -= v_mean;)==""\n"
R"==(v_acc += m * m;)==""\n"
R"==(})==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(v_variance = v_acc;)==""\n"
R"==(#else )==""\n"
R"==(v_variance = 0;)==""\n"
R"==(for (int i = 0; i < VECT_DT_N; ++i) {)==""\n"
R"==(v_variance += v_acc[i];)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(total_sum = sub_group_reduce_add(v_variance);)==""\n"
R"==(v_variance = total_sum / C;)==""\n"
R"==(})==""\n"
R"==(const float rsqrt_variance = rsqrt(v_variance + eps);)==""\n"
R"==(int local_id = get_sub_group_local_id();)==""\n"
R"==(for (int c = 0; c < C; c += SUB_GROUP_SIZE) {)==""\n"
R"==(float sm = (scale ? CONVERT_WEI_FLOAT_T(scale[c + local_id]) : 1.0f))==""\n"
R"==(* rsqrt_variance;)==""\n"
R"==(float sv = shift ? CONVERT_WEI_FLOAT_T(shift[c + local_id]) : 0.0f;)==""\n"
R"==(x[NDIMS - 1] = c + local_id;)==""\n"
R"==(int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(int dst_off = DST_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(float d = (sm * (SRC_TO_REF(src[src_off]) - v_mean) + sv);)==""\n"
R"==(#if WITH_SRC_SCALES)==""\n"
R"==(d *= src_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALES)==""\n"
R"==(d /= dst_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(dst[dst_off] = TO_DST(d);)==""\n"
R"==(})==""\n"
R"==(if (CALCULATE_STATS) {)==""\n"
R"==(if (SAVE_STATS) {)==""\n"
R"==(mean[s_off] = v_mean;)==""\n"
R"==(variance[s_off] = v_variance;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(#if USE_SCALE || USE_SHIFT)==""\n"
R"==(NAMED_KERNEL_ATTR(SCALESHIFT))==""\n"
R"==(__kernel void simple_lnorm_bwd_scaleshift(__global SRC_DATA_T *src,)==""\n"
R"==(__global float *mean, __global float *variance,)==""\n"
R"==(__global DATA_T *diff_dst, __global float *diff_scale,)==""\n"
R"==(__global float *diff_shift, float eps) {)==""\n"
R"==(const int c = GWS_GET_C();)==""\n"
R"==(const int n_chunk_idx = GWS_GET_N();)==""\n"
R"==(const int n_start = n_chunk_idx * N_CHUNK_SIZE;)==""\n"
R"==(const int n_end = n_start + N_CHUNK_SIZE;)==""\n"
R"==(const int shift_off = N_CHUNKS * C;)==""\n"
R"==(diff_shift += shift_off;)==""\n"
R"==(vector_float diff_gamma_vect = 0;)==""\n"
R"==(vector_float diff_beta_vect = 0;)==""\n"
R"==(for (int n_off = n_start; n_off < n_end; n_off += VECTOR_SIZE_SCALESHIFT) {)==""\n"
R"==(const vector_float mean_vect = vector_load(mean[n_off]);)==""\n"
R"==(const vector_float variance_vect = vector_load(variance[n_off]);)==""\n"
R"==(const vector_float inv_sqrt_variance = rsqrt(variance_vect + eps);)==""\n"
R"==(#if NDIMS == 2)==""\n"
R"==(const int src_off = SRC_OFF(n_off, c, 0, 0, 0, 0);)==""\n"
R"==(const int dst_off = DST_OFF(n_off, c, 0, 0, 0, 0);)==""\n"
R"==(#else)==""\n"
R"==(const int src_off = SRC_OFF(0, n_off, c, 0, 0, 0);)==""\n"
R"==(const int dst_off = DST_OFF(0, n_off, c, 0, 0, 0);)==""\n"
R"==(#endif)==""\n"
R"==(const vector_float src_vect = convert_vector_src_to_float()==""\n"
R"==(as_vector_src_data_t(sub_group_read()==""\n"
R"==((const __global SRC_BLOCK_DATA_T *)&src[src_off])));)==""\n"
R"==(const vector_float diff_dst_vect)==""\n"
R"==(= convert_vector_to_float(as_vector_data_t(sub_group_read()==""\n"
R"==((const __global BLOCK_DATA_T *)&diff_dst[dst_off])));)==""\n"
R"==(diff_gamma_vect)==""\n"
R"==(+= (src_vect - mean_vect) * diff_dst_vect * inv_sqrt_variance;)==""\n"
R"==(diff_beta_vect += diff_dst_vect;)==""\n"
R"==(})==""\n"
R"==(float diff_gamma = 0, diff_beta = 0;)==""\n"
R"==(#if VECTOR_SIZE_SCALESHIFT == 1)==""\n"
R"==(diff_gamma = diff_gamma_vect;)==""\n"
R"==(diff_beta = diff_beta_vect;)==""\n"
R"==(#else)==""\n"
R"==(for (int elem_idx = 0; elem_idx < VECTOR_SIZE_SCALESHIFT; elem_idx++) {)==""\n"
R"==(diff_gamma += diff_gamma_vect[elem_idx];)==""\n"
R"==(diff_beta += diff_beta_vect[elem_idx];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(const int result_offset = n_chunk_idx * C + c;)==""\n"
R"==(if (USE_SCALE))==""\n"
R"==(intel_sub_group_block_write((__global uint *)&diff_scale[result_offset],)==""\n"
R"==(as_uint(diff_gamma));)==""\n"
R"==(if (USE_SHIFT))==""\n"
R"==(intel_sub_group_block_write((__global uint *)&diff_shift[result_offset],)==""\n"
R"==(as_uint(diff_beta));)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(SCALESHIFT_FINALIZE))==""\n"
R"==(__kernel void simple_lnorm_bwd_scaleshift_final(__global float *tmp_reduce_mem,)==""\n"
R"==(__global WEI_DATA_T *diff_scale, __global WEI_DATA_T *diff_shift) {)==""\n"
R"==(const int c = GWS_GET_C_finalize();)==""\n"
R"==(const int diff_shift_off = N_CHUNKS * C;)==""\n"
R"==(__global float *tmp_diff_scale = tmp_reduce_mem;)==""\n"
R"==(__global float *tmp_diff_shift = tmp_reduce_mem + diff_shift_off;)==""\n"
R"==(float diff_gamma = 0;)==""\n"
R"==(float diff_beta = 0;)==""\n"
R"==(for (int n_chunk_idx = 0; n_chunk_idx < N_CHUNKS; n_chunk_idx++) {)==""\n"
R"==(const int result_off = n_chunk_idx * C + c;)==""\n"
R"==(diff_gamma += tmp_diff_scale[result_off];)==""\n"
R"==(diff_beta += tmp_diff_shift[result_off];)==""\n"
R"==(})==""\n"
R"==(if (diff_scale) diff_scale[c] = CONVERT_WEI_DATA_T(diff_gamma);)==""\n"
R"==(if (diff_shift) diff_shift[c] = CONVERT_WEI_DATA_T(diff_beta);)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void simple_lnorm_bwd(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DATA_T *diff_dst,)==""\n"
R"==(__global WEI_DATA_T *scale, __global DATA_T *diff_src, float eps) {)==""\n"
R"==(int x[6] = {0};)==""\n"
R"==(x[0] = GWS_GET_X0();)==""\n"
R"==(x[1] = GWS_GET_X1();)==""\n"
R"==(x[2] = GWS_GET_X2();)==""\n"
R"==(x[3] = GWS_GET_X3();)==""\n"
R"==(const int s_off = STAT_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const float mean_val = mean[s_off];)==""\n"
R"==(const float inv_sqrt_variance = rsqrt(variance[s_off] + eps);)==""\n"
R"==(float dd_gamma = 0, dd_gamma_x = 0;)==""\n"
R"==(VECT_FLOAT_T dd_gamma_vect = 0;)==""\n"
R"==(VECT_FLOAT_T dd_gamma_x_vect = 0;)==""\n"
R"==(if (CALCULATE_STATS) {)==""\n"
R"==(for (int c = 0; c < C; c += VECT_DT_N * SUB_GROUP_SIZE) {)==""\n"
R"==(VECT_FLOAT_T gamma = 1.0f;)==""\n"
R"==(if (scale) { gamma = LOAD_VECT_WEI(&scale[c]); })==""\n"
R"==(x[NDIMS - 1] = c;)==""\n"
R"==(const int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const int dst_off = DST_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const VECT_FLOAT_T src_vect)==""\n"
R"==(= CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ()==""\n"
R"==((const __global BLOCK_DATA_T *)&src[src_off])));)==""\n"
R"==(const VECT_FLOAT_T dst_vect)==""\n"
R"==(= CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ(()==""\n"
R"==(const __global BLOCK_DATA_T *)&diff_dst[dst_off])));)==""\n"
R"==(dd_gamma_vect += dst_vect * gamma;)==""\n"
R"==(dd_gamma_x_vect += dst_vect * gamma * (src_vect - mean_val);)==""\n"
R"==(})==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(dd_gamma = dd_gamma_vect;)==""\n"
R"==(dd_gamma_x = dd_gamma_x_vect;)==""\n"
R"==(#else)==""\n"
R"==(for (int i = 0; i < VECT_DT_N; ++i) {)==""\n"
R"==(dd_gamma += dd_gamma_vect[i];)==""\n"
R"==(dd_gamma_x += dd_gamma_x_vect[i];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(dd_gamma = sub_group_reduce_add(dd_gamma);)==""\n"
R"==(dd_gamma_x = sub_group_reduce_add(dd_gamma_x);)==""\n"
R"==(dd_gamma_x *= inv_sqrt_variance;)==""\n"
R"==(})==""\n"
R"==(for (int c = 0; c < C; c += VECT_DT_N * SUB_GROUP_SIZE) {)==""\n"
R"==(VECT_FLOAT_T gamma = 1.0f;)==""\n"
R"==(if (scale) { gamma = LOAD_VECT_WEI(&scale[c]); })==""\n"
R"==(x[NDIMS - 1] = c;)==""\n"
R"==(const int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const int dst_off = DST_OFF(x[0], x[1], x[2], x[3], x[4], x[5]);)==""\n"
R"==(const VECT_FLOAT_T src_vect = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T()==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&src[src_off])));)==""\n"
R"==(VECT_FLOAT_T v_diff_src_vect)==""\n"
R"==(= CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ()==""\n"
R"==((const __global BLOCK_DATA_T *)&diff_dst[dst_off])));)==""\n"
R"==(v_diff_src_vect *= gamma;)==""\n"
R"==(if (CALCULATE_STATS) {)==""\n"
R"==(v_diff_src_vect -= dd_gamma / C)==""\n"
R"==(+ (src_vect - mean_val) * dd_gamma_x * inv_sqrt_variance)==""\n"
R"==(/ C;)==""\n"
R"==(})==""\n"
R"==(v_diff_src_vect *= inv_sqrt_variance;)==""\n"
R"==(VECT_BLOCK_WRITE((__global BLOCK_DATA_T *)&diff_src[src_off],)==""\n"
R"==(AS_VECT_BLOCK_DATA_T(CONVERT_VECTOR_DATA_T(v_diff_src_vect)));)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}
}