namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *simple_softmax_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_SIMPLE_SOFTMAX_H)==""\n"
R"==(#define GPU_INTEL_OCL_SIMPLE_SOFTMAX_H)==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#define CONCAt2(a, b) a##b)==""\n"
R"==(#define CONCAT2(a, b) CONCAt2(a, b))==""\n"
R"==(#define IS_HALF_half 1)==""\n"
R"==(#define IS_HALF(dt) CONCAT2(IS_HALF_, dt))==""\n"
R"==(#if IS_FWD)==""\n"
R"==(#define DD(i) CONCAt2(DST_D, i))==""\n"
R"==(#elif IS_BWD)==""\n"
R"==(#define DD(i) CONCAt2(SRC_D, i))==""\n"
R"==(#else)==""\n"
R"==(#error unsupported data parameter)==""\n"
R"==(#endif)==""\n"
R"==(#define OFF(dim, idx) \)==""\n"
R"==((dim % CONCAT2(DATA_B, idx)) * CONCAT2(DATA_SB, idx) \)==""\n"
R"==(+ (dim / CONCAT2(DATA_B, idx)) * CONCAT2(DATA_S, idx))==""\n"
R"==(#if SOFTMAX_AXIS_IDX == 0)==""\n"
R"==(#define DATA_OFF(dim0, dim1, dim2, dim3, dim4, softmax_dim) \)==""\n"
R"==(OFF(softmax_dim, 0) + OFF(dim0, 1) + OFF(dim1, 2) + OFF(dim2, 3) \)==""\n"
R"==(+ OFF(dim3, 4) + OFF(dim4, 5))==""\n"
R"==(#define NEEDS_PADDING(dim0, dim1, dim2, dim3, dim4, softmax_dim) \)==""\n"
R"==(softmax_dim >= DD(0) || dim0 >= DD(1) || dim1 >= DD(2) || dim2 >= DD(3) \)==""\n"
R"==(|| dim3 >= DD(4) || dim4 >= DD(5))==""\n"
R"==(#elif SOFTMAX_AXIS_IDX == 1)==""\n"
R"==(#define DATA_OFF(dim0, dim1, dim2, dim3, dim4, softmax_dim) \)==""\n"
R"==(OFF(dim0, 0) + OFF(softmax_dim, 1) + OFF(dim1, 2) + OFF(dim2, 3) \)==""\n"
R"==(+ OFF(dim3, 4) + OFF(dim4, 5))==""\n"
R"==(#define NEEDS_PADDING(dim0, dim1, dim2, dim3, dim4, softmax_dim) \)==""\n"
R"==(dim0 >= DD(0) || softmax_dim >= DD(1) || dim1 >= DD(2) || dim2 >= DD(3) \)==""\n"
R"==(|| dim3 >= DD(4) || dim4 >= DD(5))==""\n"
R"==(#elif SOFTMAX_AXIS_IDX == 2)==""\n"
R"==(#define DATA_OFF(dim0, dim1, dim2, dim3, dim4, softmax_dim) \)==""\n"
R"==(OFF(dim0, 0) + OFF(dim1, 1) + OFF(softmax_dim, 2) + OFF(dim2, 3) \)==""\n"
R"==(+ OFF(dim3, 4) + OFF(dim4, 5))==""\n"
R"==(#define NEEDS_PADDING(dim0, dim1, dim2, dim3, dim4, softmax_dim) \)==""\n"
R"==(dim0 >= DD(0) || dim1 >= DD(1) || softmax_dim >= DD(2) || dim2 >= DD(3) \)==""\n"
R"==(|| dim3 >= DD(4) || dim4 >= DD(5))==""\n"
R"==(#elif SOFTMAX_AXIS_IDX == 3)==""\n"
R"==(#define DATA_OFF(dim0, dim1, dim2, dim3, dim4, softmax_dim) \)==""\n"
R"==(OFF(dim0, 0) + OFF(dim1, 1) + OFF(dim2, 2) + OFF(softmax_dim, 3) \)==""\n"
R"==(+ OFF(dim3, 4) + OFF(dim4, 5))==""\n"
R"==(#define NEEDS_PADDING(dim0, dim1, dim2, dim3, dim4, softmax_dim) \)==""\n"
R"==(dim0 >= DD(0) || dim1 >= DD(1) || dim2 >= DD(2) || softmax_dim >= DD(3) \)==""\n"
R"==(|| dim3 >= DD(4) || dim4 >= DD(5))==""\n"
R"==(#elif SOFTMAX_AXIS_IDX == 4)==""\n"
R"==(#define DATA_OFF(dim0, dim1, dim2, dim3, dim4, softmax_dim) \)==""\n"
R"==(OFF(dim0, 0) + OFF(dim1, 1) + OFF(dim2, 2) + OFF(dim3, 3) \)==""\n"
R"==(+ OFF(softmax_dim, 4) + OFF(dim4, 5))==""\n"
R"==(#define NEEDS_PADDING(dim0, dim1, dim2, dim3, dim4, softmax_dim) \)==""\n"
R"==(dim0 >= DD(0) || dim1 >= DD(1) || dim2 >= DD(2) || dim3 >= DD(3) \)==""\n"
R"==(|| softmax_dim >= DD(4) || dim4 >= DD(5))==""\n"
R"==(#elif SOFTMAX_AXIS_IDX == 5)==""\n"
R"==(#define DATA_OFF(dim0, dim1, dim2, dim3, dim4, softmax_dim) \)==""\n"
R"==(OFF(dim0, 0) + OFF(dim1, 1) + OFF(dim2, 2) + OFF(dim3, 3) + OFF(dim4, 4) \)==""\n"
R"==(+ OFF(softmax_dim, 5))==""\n"
R"==(#define NEEDS_PADDING(dim0, dim1, dim2, dim3, dim4, softmax_dim) \)==""\n"
R"==(dim0 >= DD(0) || dim1 >= DD(1) || dim2 >= DD(2) || dim3 >= DD(3) \)==""\n"
R"==(|| dim4 >= DD(4) || softmax_dim >= DD(5))==""\n"
R"==(#else)==""\n"
R"==(#error unsupported softmax dimension)==""\n"
R"==(#endif)==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}
}