namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *xe_hpc_systolic_gemm_copy_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2021-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#pragma clang diagnostic ignored "-Wunknown-attributes")==""\n"
R"==(#if ELEMENT_SIZE == 2)==""\n"
R"==(#pragma OPENCL EXTENSION cl_intel_subgroups_short : enable)==""\n"
R"==(#define ELEMENT ushort)==""\n"
R"==(#define ELEMENT2 ushort2)==""\n"
R"==(#define ELEMENT4 ushort4)==""\n"
R"==(#define ELEMENT_WORD ushort)==""\n"
R"==(#define ELEMENT_WORD4 ushort4)==""\n"
R"==(#define ELEMENT_INT ushort2)==""\n"
R"==(#define ELEMENT_INT4 ushort8)==""\n"
R"==(#define VLOAD_ELEMENT_INT vload2)==""\n"
R"==(#define ELEMENTS_PER_INT 2)==""\n"
R"==(#define BLOCK_READ_ELEMENT2 intel_sub_group_block_read_us2)==""\n"
R"==(#define BLOCK_READ_ELEMENT4 intel_sub_group_block_read_us4)==""\n"
R"==(#define BLOCK_READ_ELEMENT_WORD intel_sub_group_block_read_us)==""\n"
R"==(#define MASKED_BLOCK_READ_ELEMENT_WORD masked_block_read_element)==""\n"
R"==(#define BLOCK_WRITE_ELEMENT_WORD4 intel_sub_group_block_write_us4)==""\n"
R"==(#define BLOCK_WRITE_ELEMENT_INT4 intel_sub_group_block_write_us8)==""\n"
R"==(#elif ELEMENT_SIZE == 1)==""\n"
R"==(#define ELEMENT uchar)==""\n"
R"==(#define ELEMENT2 uchar2)==""\n"
R"==(#define ELEMENT4 uchar4)==""\n"
R"==(#define ELEMENT_WORD uchar2)==""\n"
R"==(#define ELEMENT_WORD4 uchar8)==""\n"
R"==(#define ELEMENT_INT uchar4)==""\n"
R"==(#define ELEMENT_INT4 uchar16)==""\n"
R"==(#define VLOAD_ELEMENT_INT vload4)==""\n"
R"==(#define BLOCK_READ_ELEMENT2 intel_sub_group_block_read_uc2)==""\n"
R"==(#define BLOCK_READ_ELEMENT4 intel_sub_group_block_read_uc4)==""\n"
R"==(#define BLOCK_READ_ELEMENT_WORD intel_sub_group_block_read_uc2)==""\n"
R"==(#define MASKED_BLOCK_READ_ELEMENT_WORD masked_block_read_element2)==""\n"
R"==(#define BLOCK_WRITE_ELEMENT_WORD4 intel_sub_group_block_write_uc8)==""\n"
R"==(#define BLOCK_WRITE_ELEMENT_INT2 intel_sub_group_block_write_uc8)==""\n"
R"==(#define BLOCK_WRITE_ELEMENT_INT4 intel_sub_group_block_write_uc16)==""\n"
R"==(#define ELEMENTS_PER_INT 4)==""\n"
R"==(#define SUM_T int)==""\n"
R"==(#define SUM_T2 int2)==""\n"
R"==(#define SUM_T4 int4)==""\n"
R"==(#define CONVERT_SUM_T convert_int)==""\n"
R"==(#define CONVERT_SUM_T2 convert_int2)==""\n"
R"==(#define CONVERT_SUM_T4 convert_int4)==""\n"
R"==(#if COPY_SIGNED)==""\n"
R"==(#define AS_SIGNED_ELEMENT as_char)==""\n"
R"==(#define AS_SIGNED_ELEMENT4 as_char4)==""\n"
R"==(#define AS_SIGNED_ELEMENT_WORD as_char2)==""\n"
R"==(#define AS_SIGNED_ELEMENT_INT as_char4)==""\n"
R"==(#define SIGNED_ELEMENT_WORD char2)==""\n"
R"==(#define SIGNED_ELEMENT_INT char4)==""\n"
R"==(#else)==""\n"
R"==(#define AS_SIGNED_ELEMENT as_uchar)==""\n"
R"==(#define AS_SIGNED_ELEMENT4 as_uchar4)==""\n"
R"==(#define AS_SIGNED_ELEMENT_WORD as_uchar2)==""\n"
R"==(#define AS_SIGNED_ELEMENT_INT as_uchar4)==""\n"
R"==(#define SIGNED_ELEMENT_WORD uchar2)==""\n"
R"==(#define SIGNED_ELEMENT_INT uchar4)==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(#error Unsupported element size.)==""\n"
R"==(#endif)==""\n"
R"==(#if !COPY_A && !COPY_B)==""\n"
R"==(#error Source matrix not defined.)==""\n"
R"==(#endif)==""\n"
R"==(inline ELEMENT masked_block_read_element(global ELEMENT *p, int rem) {)==""\n"
R"==(ELEMENT v;)==""\n"
R"==(int lid = get_sub_group_local_id();)==""\n"
R"==(int sg = get_sub_group_size();)==""\n"
R"==(v = (lid < rem) ? p[lid] : 0;)==""\n"
R"==(return v;)==""\n"
R"==(})==""\n"
R"==(inline ELEMENT2 masked_block_read_element2(global ELEMENT *p, int rem) {)==""\n"
R"==(ELEMENT2 v;)==""\n"
R"==(int lid = get_sub_group_local_id();)==""\n"
R"==(int sg = get_sub_group_size();)==""\n"
R"==(v.s0 = (lid < rem) ? p[lid] : 0;)==""\n"
R"==(v.s1 = (lid + sg < rem) ? p[lid + sg] : 0;)==""\n"
R"==(return v;)==""\n"
R"==(})==""\n"
R"==(inline ELEMENT4 masked_block_read_element4(global ELEMENT *p, int rem) {)==""\n"
R"==(ELEMENT4 v;)==""\n"
R"==(int lid = get_sub_group_local_id();)==""\n"
R"==(int sg = get_sub_group_size();)==""\n"
R"==(v.s0 = (lid < rem) ? p[lid] : 0;)==""\n"
R"==(v.s1 = (lid + sg < rem) ? p[lid + sg] : 0;)==""\n"
R"==(v.s2 = (lid + 2 * sg < rem) ? p[lid + 2 * sg] : 0;)==""\n"
R"==(v.s3 = (lid + 3 * sg < rem) ? p[lid + 3 * sg] : 0;)==""\n"
R"==(return v;)==""\n"
R"==(})==""\n"
R"==(__attribute__((overloadable)) inline int sum(int v) {)==""\n"
R"==(return sub_group_reduce_add(v);)==""\n"
R"==(})==""\n"
R"==(__attribute__((overloadable)) inline int sum(int2 v) {)==""\n"
R"==(return sub_group_reduce_add(v.s0) + sub_group_reduce_add(v.s1);)==""\n"
R"==(})==""\n"
R"==(__attribute__((overloadable)) inline int sum(int4 v) {)==""\n"
R"==(return sub_group_reduce_add(v.s0) + sub_group_reduce_add(v.s1))==""\n"
R"==(+ sub_group_reduce_add(v.s2) + sub_group_reduce_add(v.s3);)==""\n"
R"==(})==""\n"
R"==(void dummy_dpas() {)==""\n"
R"==(if (get_sub_group_local_id() >= 16) {)==""\n"
R"==(int __builtin_IB_sub_group_idpas_s8_s8_8_1(int, int, int8))==""\n"
R"==(__attribute__((const));)==""\n"
R"==(global volatile int *_;)==""\n"
R"==(int z = __builtin_IB_sub_group_idpas_s8_s8_8_1(0, _[0], 1);)==""\n"
R"==(for (int i = 0; i < z; i++))==""\n"
R"==((void)_[0];)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#define DUMMY_DPAS /*dummy_dpas()*/)==""\n"
R"==(#if ELEMENT_SIZE == 2)==""\n"
R"==(#define PARTIAL_LOAD(regs, rrem, crem, cc, p) \)==""\n"
R"==(if ((2 * cc + 1) < crem) { \)==""\n"
R"==(if (lid < rrem) regs[cc] = vload2(0, p); \)==""\n"
R"==(} else if ((2 * cc) < crem) { \)==""\n"
R"==(if (lid < rrem) regs[cc].s0 = *(p); \)==""\n"
R"==(})==""\n"
R"==(#elif ELEMENT_SIZE == 1)==""\n"
R"==(#define PARTIAL_LOAD(regs, rrem, crem, cc, p) \)==""\n"
R"==(if ((4 * cc + 3) < crem) { \)==""\n"
R"==(if (lid < rrem) regs[cc] = vload4(0, p); \)==""\n"
R"==(} else if ((4 * cc + 2) < crem) { \)==""\n"
R"==(if (lid < rrem) regs[cc].s012 = vload3(0, p); \)==""\n"
R"==(} else if ((4 * cc + 1) < crem) { \)==""\n"
R"==(if (lid < rrem) regs[cc].s01 = vload2(0, p); \)==""\n"
R"==(} else if (4 * cc < crem) { \)==""\n"
R"==(if (lid < rrem) regs[cc].s0 = *(p); \)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if COPY_A)==""\n"
R"==(#define UNROLL_M 64)==""\n"
R"==(#define UNROLL_K (32 / ELEMENT_SIZE))==""\n"
R"==(#if COPY_SUM)==""\n"
R"==(#define GET_A_SUM_ADDRESS \)==""\n"
R"==(global int *a_sum = (global int *)(a_packed + offseta_packed \)==""\n"
R"==(+ (m0 + UNROLL_M) * lda_packed - UNROLL_M * sizeof(int));)==""\n"
R"==(#else)==""\n"
R"==(#define GET_A_SUM_ADDRESS)==""\n"
R"==(#endif)==""\n"
R"==(#if COPY_CLEAR_SUM)==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16))) kernel void)==""\n"
R"==(xe_hpc_systolic_gemm_copy(long m, long k, global ELEMENT *a_packed,)==""\n"
R"==(int offseta_packed, int lda_packed) {)==""\n"
R"==(uint m0 = (sub_group_broadcast(get_global_id(0), 0) / 16) * UNROLL_M;)==""\n"
R"==(GET_A_SUM_ADDRESS;)==""\n"
R"==(uint4 zero = 0;)==""\n"
R"==(intel_sub_group_block_write4((global uint *)a_sum, zero);)==""\n"
R"==(})==""\n"
R"==(#elif !COPY_TRANS)==""\n"
R"==(#if ELEMENT_SIZE == 2)==""\n"
R"==(#define REPACK_REG(rr, cc) \)==""\n"
R"==(blk_r[rr].s##cc = (((uint)c[2 * cc + 1].s##rr) << 16) | c[2 * cc].s##rr)==""\n"
R"==(#elif ELEMENT_SIZE == 1)==""\n"
R"==(#define REPACK_REG(rr, cc) \)==""\n"
R"==(blk_r[rr].s##cc = (((uint)c[4 * cc + 3].s##rr) << 24) \)==""\n"
R"==(| (((uint)c[4 * cc + 2].s##rr) << 16) \)==""\n"
R"==(| (((uint)c[4 * cc + 1].s##rr) << 8) | c[4 * cc].s##rr)==""\n"
R"==(#endif)==""\n"
R"==(#define REPACK_CC(cc) \)==""\n"
R"==(REPACK_REG(0, cc); \)==""\n"
R"==(REPACK_REG(1, cc); \)==""\n"
R"==(REPACK_REG(2, cc); \)==""\n"
R"==(REPACK_REG(3, cc))==""\n"
R"==(#define REPACK \)==""\n"
R"==(REPACK_CC(0); \)==""\n"
R"==(REPACK_CC(1); \)==""\n"
R"==(REPACK_CC(2); \)==""\n"
R"==(REPACK_CC(3); \)==""\n"
R"==(REPACK_CC(4); \)==""\n"
R"==(REPACK_CC(5); \)==""\n"
R"==(REPACK_CC(6); \)==""\n"
R"==(REPACK_CC(7))==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16))) kernel void)==""\n"
R"==(xe_hpc_systolic_gemm_copy(long m, long k, global ELEMENT *a, long offseta,)==""\n"
R"==(long lda, global ELEMENT *a_packed, int offseta_packed,)==""\n"
R"==(int lda_packed) {)==""\n"
R"==(int lid = get_sub_group_local_id();)==""\n"
R"==(uint m0 = (sub_group_broadcast(get_global_id(0), 0) / 16) * UNROLL_M;)==""\n"
R"==(uint k0 = get_global_id(1) * UNROLL_K;)==""\n"
R"==(int mrem = m - m0;)==""\n"
R"==(int krem = k - k0;)==""\n"
R"==(bool aligned = ((as_long(a) | lda | offseta) & (ELEMENTS_PER_INT - 1)) == 0;)==""\n"
R"==(if (mrem <= 0 || krem <= 0) return;)==""\n"
R"==(GET_A_SUM_ADDRESS;)==""\n"
R"==(a += offseta + m0 + k0 * lda;)==""\n"
R"==(a_packed += offseta_packed + m0 * lda_packed + k0 * UNROLL_M;)==""\n"
R"==(ELEMENT4 c[UNROLL_K];)==""\n"
R"==(if (mrem >= UNROLL_M && krem >= UNROLL_K && aligned) {)==""\n"
R"==(for (int h = 0; h < UNROLL_K; h++))==""\n"
R"==(c[h] = BLOCK_READ_ELEMENT4(a + h * lda);)==""\n"
R"==(} else {)==""\n"
R"==(for (int h = 0; h < UNROLL_K; h++))==""\n"
R"==(if (h < krem))==""\n"
R"==(c[h] = masked_block_read_element4(a + h * lda, mrem);)==""\n"
R"==(else)==""\n"
R"==(c[h] = 0;)==""\n"
R"==(})==""\n"
R"==(uint8 blk_r[UNROLL_M / 16];)==""\n"
R"==(REPACK;)==""\n"
R"==(for (int rr = 0; rr < UNROLL_M / 16; rr++))==""\n"
R"==(intel_sub_group_block_write8()==""\n"
R"==((global uint *)(a_packed + rr * UNROLL_K * 16), blk_r[rr]);)==""\n"
R"==(#if COPY_SUM)==""\n"
R"==(SUM_T4 sum = 0;)==""\n"
R"==(for (int h = 0; h < UNROLL_K; h++))==""\n"
R"==(sum += CONVERT_SUM_T4(AS_SIGNED_ELEMENT4(c[h]));)==""\n"
R"==(atomic_add(a_sum + lid, sum.s0);)==""\n"
R"==(atomic_add(a_sum + lid + 16, sum.s1);)==""\n"
R"==(atomic_add(a_sum + lid + 32, sum.s2);)==""\n"
R"==(atomic_add(a_sum + lid + 48, sum.s3);)==""\n"
R"==(#endif)==""\n"
R"==(DUMMY_DPAS;)==""\n"
R"==(})==""\n"
R"==(#else /* COPY_TRANS */)==""\n"
R"==(__attribute__((intel_reqd_workgroup_walk_order(1, 0))))==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16))) kernel void)==""\n"
R"==(xe_hpc_systolic_gemm_copy(long m, long k, global ELEMENT *a, long offseta,)==""\n"
R"==(long lda, global ELEMENT *a_packed, int offseta_packed,)==""\n"
R"==(int lda_packed) {)==""\n"
R"==(int lid = get_sub_group_local_id();)==""\n"
R"==(uint m0 = (sub_group_broadcast(get_global_id(0), 0) / 16) * UNROLL_M;)==""\n"
R"==(uint k0 = get_global_id(1) * UNROLL_K;)==""\n"
R"==(int mrem = m - m0;)==""\n"
R"==(int krem = k - k0;)==""\n"
R"==(if (mrem <= 0 || krem <= 0) return;)==""\n"
R"==(GET_A_SUM_ADDRESS;)==""\n"
R"==(a += offseta + m0 * lda + k0;)==""\n"
R"==(a_packed += offseta_packed + m0 * lda_packed + k0 * UNROLL_M;)==""\n"
R"==(#if COPY_SUM)==""\n"
R"==(SUM_T sum[UNROLL_M / 16] = {0};)==""\n"
R"==(#endif)==""\n"
R"==(for (int rr = 0; rr < UNROLL_M / 16; rr++, mrem -= 16) {)==""\n"
R"==(ELEMENT_INT regs[8];)==""\n"
R"==(if (mrem >= UNROLL_M && krem >= UNROLL_K) {)==""\n"
R"==(for (int cc = 0; cc < UNROLL_K / ELEMENTS_PER_INT; cc++))==""\n"
R"==(regs[cc] = VLOAD_ELEMENT_INT(0,)==""\n"
R"==(a + ((rr * 16) + lid) * lda + (cc * ELEMENTS_PER_INT));)==""\n"
R"==(} else {)==""\n"
R"==(for (int cc = 0; cc < UNROLL_K / ELEMENTS_PER_INT; cc++) {)==""\n"
R"==(regs[cc] = 0;)==""\n"
R"==(PARTIAL_LOAD(regs, mrem, krem, cc,)==""\n"
R"==(a + ((rr * 16) + lid) * lda + (cc * ELEMENTS_PER_INT));)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(uint8 blk_r;)==""\n"
R"==(blk_r.s0 = as_uint(regs[0]);)==""\n"
R"==(blk_r.s1 = as_uint(regs[1]);)==""\n"
R"==(blk_r.s2 = as_uint(regs[2]);)==""\n"
R"==(blk_r.s3 = as_uint(regs[3]);)==""\n"
R"==(blk_r.s4 = as_uint(regs[4]);)==""\n"
R"==(blk_r.s5 = as_uint(regs[5]);)==""\n"
R"==(blk_r.s6 = as_uint(regs[6]);)==""\n"
R"==(blk_r.s7 = as_uint(regs[7]);)==""\n"
R"==(#if COPY_SUM)==""\n"
R"==(for (int cc = 0; cc < UNROLL_K / ELEMENTS_PER_INT; cc++) {)==""\n"
R"==(sum[rr] += CONVERT_SUM_T(AS_SIGNED_ELEMENT(regs[cc].s0));)==""\n"
R"==(sum[rr] += CONVERT_SUM_T(AS_SIGNED_ELEMENT(regs[cc].s1));)==""\n"
R"==(sum[rr] += CONVERT_SUM_T(AS_SIGNED_ELEMENT(regs[cc].s2));)==""\n"
R"==(sum[rr] += CONVERT_SUM_T(AS_SIGNED_ELEMENT(regs[cc].s3));)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(intel_sub_group_block_write8()==""\n"
R"==((global uint *)(a_packed + rr * UNROLL_K * 16), blk_r);)==""\n"
R"==(})==""\n"
R"==(#if COPY_SUM)==""\n"
R"==(atomic_add(a_sum + lid, sum[0]);)==""\n"
R"==(atomic_add(a_sum + lid + 16, sum[1]);)==""\n"
R"==(atomic_add(a_sum + lid + 32, sum[2]);)==""\n"
R"==(atomic_add(a_sum + lid + 48, sum[3]);)==""\n"
R"==(#endif)==""\n"
R"==(DUMMY_DPAS;)==""\n"
R"==(})==""\n"
R"==(#endif /* !COPY_TRANS */)==""\n"
R"==(#endif /* COPY_A */)==""\n"
R"==(#if COPY_B)==""\n"
R"==(#define UNROLL_K (32 / ELEMENT_SIZE))==""\n"
R"==(#if ELEMENT_SIZE == 2)==""\n"
R"==(#define REPACK_CC_WORD(cc) \)==""\n"
R"==(do { \)==""\n"
R"==(colgroups[cc].s0 = cols[cc * 4]; \)==""\n"
R"==(colgroups[cc].s1 = cols[cc * 4 + 1]; \)==""\n"
R"==(colgroups[cc].s2 = cols[cc * 4 + 2]; \)==""\n"
R"==(colgroups[cc].s3 = cols[cc * 4 + 3]; \)==""\n"
R"==(} while (false))==""\n"
R"==(#define REPACK_CC(cc) \)==""\n"
R"==(do { \)==""\n"
R"==(colgroups[cc].s01 = cols[cc * 4]; \)==""\n"
R"==(colgroups[cc].s23 = cols[cc * 4 + 1]; \)==""\n"
R"==(colgroups[cc].s45 = cols[cc * 4 + 2]; \)==""\n"
R"==(colgroups[cc].s67 = cols[cc * 4 + 3]; \)==""\n"
R"==(} while (false))==""\n"
R"==(#elif ELEMENT_SIZE == 1)==""\n"
R"==(#define REPACK_CC_WORD(cc) \)==""\n"
R"==(do { \)==""\n"
R"==(colgroups[cc].s01 = cols[cc * 4]; \)==""\n"
R"==(colgroups[cc].s23 = cols[cc * 4 + 1]; \)==""\n"
R"==(colgroups[cc].s45 = cols[cc * 4 + 2]; \)==""\n"
R"==(colgroups[cc].s67 = cols[cc * 4 + 3]; \)==""\n"
R"==(} while (false))==""\n"
R"==(#define REPACK_CC(cc) \)==""\n"
R"==(do { \)==""\n"
R"==(colgroups[cc].s0123 = cols[cc * 4]; \)==""\n"
R"==(colgroups[cc].s4567 = cols[cc * 4 + 1]; \)==""\n"
R"==(colgroups[cc].s89ab = cols[cc * 4 + 2]; \)==""\n"
R"==(colgroups[cc].scdef = cols[cc * 4 + 3]; \)==""\n"
R"==(} while (false))==""\n"
R"==(#define REPACK_CC2(cc) \)==""\n"
R"==(do { \)==""\n"
R"==(colgroups[cc].s0246 = cols[cc * 2]; \)==""\n"
R"==(colgroups[cc].s1357 = cols2[cc * 2]; \)==""\n"
R"==(colgroups[cc].s8ace = cols[cc * 2 + 1]; \)==""\n"
R"==(colgroups[cc].s9bdf = cols2[cc * 2 + 1]; \)==""\n"
R"==(} while (false))==""\n"
R"==(#endif)==""\n"
R"==(#if COPY_SUM)==""\n"
R"==(#define GET_B_SUM_ADDRESS \)==""\n"
R"==(global int *b_sum = (global int *)(b_packed + offsetb_packed \)==""\n"
R"==(+ (n0 + UNROLL_N) * ldb_packed - UNROLL_N * sizeof(int));)==""\n"
R"==(#else)==""\n"
R"==(#define GET_B_SUM_ADDRESS)==""\n"
R"==(#endif)==""\n"
R"==(#if COPY_CLEAR_SUM)==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16))) kernel void)==""\n"
R"==(xe_hpc_systolic_gemm_copy(long k, long n, global ELEMENT *b_packed,)==""\n"
R"==(int offsetb_packed, int ldb_packed) {)==""\n"
R"==(uint n0 = (sub_group_broadcast(get_global_id(0), 0) / 16) * UNROLL_N;)==""\n"
R"==(GET_B_SUM_ADDRESS;)==""\n"
R"==(uint2 zero = 0;)==""\n"
R"==(intel_sub_group_block_write2((__global uint *)b_sum, zero);)==""\n"
R"==(#if UNROLL_N > 32)==""\n"
R"==(intel_sub_group_block_write((__global uint *)b_sum + 32, zero.s0);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#elif !COPY_TRANS)==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16))) kernel void)==""\n"
R"==(xe_hpc_systolic_gemm_copy(long k, long n, global ELEMENT *b, long offsetb,)==""\n"
R"==(long ldb, global ELEMENT *b_packed, int offsetb_packed,)==""\n"
R"==(int ldb_packed) {)==""\n"
R"==(int lid = get_sub_group_local_id();)==""\n"
R"==(uint k0 = (sub_group_broadcast(get_global_id(0), 0) / 16) * UNROLL_K;)==""\n"
R"==(uint n0 = get_global_id(1) * UNROLL_N;)==""\n"
R"==(int krem = k - k0;)==""\n"
R"==(int nrem = n - n0;)==""\n"
R"==(bool aligned = ((as_long(b) | ldb | offsetb) & (ELEMENTS_PER_INT - 1)) == 0;)==""\n"
R"==(if (nrem <= 0 || krem <= 0) return;)==""\n"
R"==(GET_B_SUM_ADDRESS;)==""\n"
R"==(b += offsetb + k0 + n0 * ldb;)==""\n"
R"==(b_packed += offsetb_packed + n0 * ldb_packed + k0 * UNROLL_N;)==""\n"
R"==(#define UNROLL_N_CHUNK (UNROLL_N / 2))==""\n"
R"==(#if COPY_SUM)==""\n"
R"==(SUM_T sums[UNROLL_N];)==""\n"
R"==(#endif)==""\n"
R"==(ELEMENT_WORD cols[UNROLL_N / 2];)==""\n"
R"==(for (int c0 = 0; c0 < UNROLL_N;)==""\n"
R"==(c0 += UNROLL_N_CHUNK, nrem -= UNROLL_N_CHUNK) {)==""\n"
R"==(if (krem >= UNROLL_K && nrem >= UNROLL_N_CHUNK && aligned) {)==""\n"
R"==(for (int c = 0; c < UNROLL_N_CHUNK; c++))==""\n"
R"==(cols[c] = BLOCK_READ_ELEMENT_WORD(b + (c + c0) * ldb);)==""\n"
R"==(} else {)==""\n"
R"==(for (int c = 0; c < UNROLL_N_CHUNK; c++))==""\n"
R"==(if (c < nrem))==""\n"
R"==(cols[c] = MASKED_BLOCK_READ_ELEMENT_WORD()==""\n"
R"==(b + (c + c0) * ldb, krem);)==""\n"
R"==(else)==""\n"
R"==(cols[c] = 0;)==""\n"
R"==(})==""\n"
R"==(ELEMENT_WORD4 colgroups[UNROLL_N_CHUNK / 4];)==""\n"
R"==(for (int cc = 0; cc < UNROLL_N_CHUNK / 4; cc++))==""\n"
R"==(REPACK_CC_WORD(cc);)==""\n"
R"==(for (int cc = 0; cc < UNROLL_N_CHUNK / 4; cc++))==""\n"
R"==(BLOCK_WRITE_ELEMENT_WORD4()==""\n"
R"==(b_packed + (cc * 4 + c0) * UNROLL_K, colgroups[cc]);)==""\n"
R"==(#if COPY_SUM)==""\n"
R"==(for (int c = 0; c < UNROLL_N_CHUNK; c++))==""\n"
R"==(sums[c + c0] = sum(CONVERT_SUM_T2(AS_SIGNED_ELEMENT_WORD(cols[c])));)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#if COPY_SUM)==""\n"
R"==(for (int c0 = 0; c0 < UNROLL_N; c0 += get_sub_group_size()))==""\n"
R"==(atomic_add(b_sum + c0 + lid, sums[c0 + lid]);)==""\n"
R"==(#endif)==""\n"
R"==(DUMMY_DPAS;)==""\n"
R"==(})==""\n"
R"==(#else /* COPY_TRANS */)==""\n"
R"==(#define ADD_SUM(coln) \)==""\n"
R"==(for (int cc = 0; cc < UNROLL_N / 4; cc++) { \)==""\n"
R"==(sums[4 * cc + 0] \)==""\n"
R"==(+= sum(CONVERT_SUM_T(AS_SIGNED_ELEMENT(coln[cc].s0))); \)==""\n"
R"==(sums[4 * cc + 1] \)==""\n"
R"==(+= sum(CONVERT_SUM_T(AS_SIGNED_ELEMENT(coln[cc].s1))); \)==""\n"
R"==(sums[4 * cc + 2] \)==""\n"
R"==(+= sum(CONVERT_SUM_T(AS_SIGNED_ELEMENT(coln[cc].s2))); \)==""\n"
R"==(sums[4 * cc + 3] \)==""\n"
R"==(+= sum(CONVERT_SUM_T(AS_SIGNED_ELEMENT(coln[cc].s3))); \)==""\n"
R"==(})==""\n"
R"==(__attribute__((intel_reqd_workgroup_walk_order(1, 0))))==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16))) kernel void)==""\n"
R"==(xe_hpc_systolic_gemm_copy(long k, long n, global ELEMENT *b, long offsetb,)==""\n"
R"==(long ldb, global ELEMENT *b_packed, int offsetb_packed,)==""\n"
R"==(int ldb_packed) {)==""\n"
R"==(int lid = get_sub_group_local_id();)==""\n"
R"==(uint k0 = (sub_group_broadcast(get_global_id(0), 0) / 16) * UNROLL_K;)==""\n"
R"==(uint n0 = get_global_id(1) * UNROLL_N;)==""\n"
R"==(int krem = k - k0;)==""\n"
R"==(int nrem = n - n0;)==""\n"
R"==(int sg = get_sub_group_size();)==""\n"
R"==(if (nrem <= 0 || krem <= 0) return;)==""\n"
R"==(GET_B_SUM_ADDRESS;)==""\n"
R"==(b += offsetb + n0 + k0 * ldb;)==""\n"
R"==(b_packed += offsetb_packed + n0 * ldb_packed + k0 * UNROLL_N;)==""\n"
R"==(ELEMENT_INT cols[UNROLL_N / ELEMENTS_PER_INT];)==""\n"
R"==(ELEMENT_INT4 colgroups[UNROLL_N / 8];)==""\n"
R"==(if (krem >= sg && nrem >= UNROLL_N) {)==""\n"
R"==(for (int cc = 0; cc < UNROLL_N / ELEMENTS_PER_INT; cc++))==""\n"
R"==(cols[cc] = VLOAD_ELEMENT_INT()==""\n"
R"==(0, b + cc * ELEMENTS_PER_INT + lid * ldb);)==""\n"
R"==(} else {)==""\n"
R"==(for (int cc = 0; cc < UNROLL_N / ELEMENTS_PER_INT; cc++) {)==""\n"
R"==(cols[cc] = 0;)==""\n"
R"==(PARTIAL_LOAD(cols, krem, nrem, cc,)==""\n"
R"==(b + cc * ELEMENTS_PER_INT + lid * ldb);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if ELEMENT_SIZE == 2)==""\n"
R"==(for (int cc = 0; cc < UNROLL_N / 8; cc++))==""\n"
R"==(REPACK_CC(cc);)==""\n"
R"==(#else)==""\n"
R"==(#if COPY_SUM)==""\n"
R"==(SUM_T sums[UNROLL_N] = {0};)==""\n"
R"==(ADD_SUM(cols);)==""\n"
R"==(#endif)==""\n"
R"==(ELEMENT_INT cols2[UNROLL_N / ELEMENTS_PER_INT];)==""\n"
R"==(krem -= sg;)==""\n"
R"==(if (krem >= sg && nrem >= UNROLL_N) {)==""\n"
R"==(for (int cc = 0; cc < UNROLL_N / ELEMENTS_PER_INT; cc++))==""\n"
R"==(cols2[cc] = VLOAD_ELEMENT_INT()==""\n"
R"==(0, b + cc * ELEMENTS_PER_INT + (lid + sg) * ldb);)==""\n"
R"==(} else {)==""\n"
R"==(for (int cc = 0; cc < UNROLL_N / ELEMENTS_PER_INT; cc++) {)==""\n"
R"==(cols2[cc] = 0;)==""\n"
R"==(PARTIAL_LOAD(cols2, krem, nrem, cc,)==""\n"
R"==(b + cc * ELEMENTS_PER_INT + (lid + sg) * ldb);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(for (int cc = 0; cc < UNROLL_N / 8; cc++))==""\n"
R"==(REPACK_CC2(cc);)==""\n"
R"==(#if COPY_SUM)==""\n"
R"==(ADD_SUM(cols2);)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(for (int cc = 0; cc < UNROLL_N / 8; cc++))==""\n"
R"==(BLOCK_WRITE_ELEMENT_INT4(b_packed + cc * 8 * UNROLL_K, colgroups[cc]);)==""\n"
R"==(#if COPY_SUM)==""\n"
R"==(for (int c0 = 0; c0 < UNROLL_N; c0 += get_sub_group_size()))==""\n"
R"==(atomic_add(b_sum + c0 + lid, sums[c0 + lid]);)==""\n"
R"==(#endif)==""\n"
R"==(DUMMY_DPAS;)==""\n"
R"==(})==""\n"
R"==(#endif /* !COPY_TRANS */)==""\n"
R"==(#endif /* COPY_B */)==""\n"
R"==()==";
}
}
}
}
}